<?php

/**
 * Help file, manages viewing of help and rule pages.
 *
 * @package Vikingboard
 * @author Tor Henning Ueland <tor.henning@vikingboard.com>
 * @author Marius Pedersen Taule <marius@vikingboard.com>
 *
 * $Id: help.php 1678 2007-09-04 20:25:02Z jorgenboard $
 */

define('VBOARD', __FILE__);
require_once('inc/kernel.php');


/**
 * Vikingboard Help class
 */
class Help
{
	var $data;
	var $user;
	var $screen;
	var $lang;

	/*
	 * Constructor
	 */
	function Help(&$data, &$user, &$screen)
	{
		//Set up some vars
		$this->data		=	&$data;
		$this->user		=	&$user;
		$this->screen	=	&$screen;
		$this->lang		=	new lang_help();

		switch(true)
		{
			case isset($_GET['rules']):
			$this->display('rules');
			break;

			case isset($_GET['guidelines']):
			$this->display('guidelines');
			break;

			default :
			$this->display('help');
			break;
		}
	}

	/**
	 * Display
	 *
	 * Displays various help topics to the user
	 * @param string $what Which help topic to get from the database
	 */
	function display($what)
	{
		// Get the help topic from database
		$info	=	$this->data->cachedQuery('get_help_topics', array($what));
		$info	=	$info[0];

		// Add to data array
		$data	=	array
		(
			'title'		=>	$this->lang->$what,
			'content'	=>	$info->content,
		);

		$this->screen->add_html('help', $data);

		// Create navigation item
		$navigation	=	array
		(
			'help.php?' . $what	=>	$this->lang->$what,
		);

		// And off we go :)
		$this->screen->add_wrapper($this->lang->$what, $navigation);
		$this->screen->print_page();
	}
}

$Help	=	new Help($data, $user, $screen, $config);

?>