<?php
/**
*
* @package Vikingboard
* @author Tor Henning Ueland <tor.henning@vikingboard.com>
* @version 0.2
*
* $Id: backup.php 1603 2007-08-16 19:19:22Z paitrakt $
*
*/

//oh no!
if (!defined('VBOARD'))
{
	die('Hacker attempt in ' . basename(__FILE__));
}

class admin {

	/**
	 * Class loaded, this is called by the main admin page script.
	 * Database backup manager
	 *
	 * @param obj screen
	 * @param obj data
	 * @param obj config
	 *
	 * @return bool
	 */
    function admin($screen, $data, $config)
    {
        //Set "things"
        $this->lang		= new lang_admin_backup();
        $this->screen	= $screen;
        $this->data   	= $data;
        $this->config	= $config;

		//Find out what to do
		switch (ifsetor($_GET['do'], ''))
		{
			//Create a SQL dump
		  	case 'sqldump':
		  		$this->createDump();
		  	break;

		  	//Show the frontpage
			default:
				$this->showOptions();
  		}

        //Return html page to the main admin page
        return $this->html;
    }

	/**
	 * Creates a SQL dump
	 *
	 * @return bool
	 */
	function createDump()
	{

		// Get all tables with the current Vikingboard prefix
		$table_sql = $this->data->query('get_tables', array());

		// Put them into a loopable array
		$tables = array();
		foreach ($table_sql as $result)
		{
			foreach ($result as $table_name)
			{
				$tables[] = $table_name;
			}
		}

		// Loop over each table, and construct SQL
		$SQL = '';
		foreach ($tables as $t)
		{
			//Foreach table, get create table in the SQL language
			$howto 	= $this->data->query('get_create_sql', array($t));
			$row	= $howto[0];
			$name	= 'Create Table';
			$howto = $row->$name;

			$SQL	.=	"\n{$howto};\n";

			//Then we want to know how the table structure looks like, so we can put data into it
			$structure = $this->data->query('get_table_structure', array($t));
			foreach ($structure as $c)
			{
				$fields[] = $c->Field;
			}

			//Get data
			$content = $this->data->query('get_everything_from_table', array($t));

			// Don't loop if empty
			if (!empty($content))
			{
				foreach ($content as $c)
				{
					$SQL	.=	"INSERT INTO {$t} (";
					foreach ($fields as $f)
					{
						$SQL	.=	"`{$f}`, ";
					}

					$SQL	.=	') VALUES (';

					foreach ($fields as $f)
					{
						$data = $c->$f;
						$data	=   str_replace("\r\n", '\n', $data);
						$data	=   str_replace(" \r\n", '\n', $data);
			            $data	=   str_replace("\r", '\n', $data);
						$data	=   str_replace("\n", '\n', $data);
						$data	=   str_replace(" \n", '\n', $data);
						$data	=   str_replace('\n\n', '\n', $data);
						$data	=   str_replace("'", "\\'", $data);
						$data	=   str_replace(";", "\\;", $data);
						//$data	=	htmlentities($data);
						$SQL	.=	"'{$data}', ";
					}

					$SQL	.=	");\n";
					$SQL	= str_replace(', )', ')', $SQL);
				}
			}


			unset($fields);

		}

		//Then lets let the user download the SQL code
		$size = strlen($SQL);
		header('Pragma: no-cache');
		header("Content-Length: {$size}");
		header('Content-Type: text/plain; name="vikingboard_database.sql"');
		header('Content-disposition: attachment; filename=vikingboard_database.sql');
		echo $SQL;
		die();
	}

	/**
	 * Simply shows the backup manager frontpage
	 *
	 * @return bool
	 */
    function showOptions()
    {
		//Build the page, simple job
		$this->screen->set_lang('lang_admin_backup');
		$this->html  		=   $this->screen->return_html('admin_backup_frontpage');
	}
}
?>
