<?php
/**
 * @package Vikingboard
 * @author Tor Henning Ueland <tor.henning@vikingboard.com>
 * @version 0.2
 * @copyright Copyright (c) 2004-2007 The Vikingboard Project
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License
 * @link http://vikingboard.com/
 * @version $Id: cachemanager.php 1670 2007-09-02 12:09:23Z ueland $*
 */

//oh no!
if (!defined('VBOARD'))
{
	die('Hacker attempt in ' . basename(__FILE__));
}

/**
 * Admin main class
 *
 */
class admin
{

	/**
	 * Cache management page
	 *
	 * @param obj screen
	 * @param obj cache
	 * @param obj db
	 * @param obj config
	 *
	 * @return bool
	 */
    function admin($screen, $data, $config)
    {
        //Set "things"
        $this->lang		= new lang_admin_cachemanager();
        $this->screen	= $screen;
        $this->data		= $data;
		$this->config	= $config;

		$this->screen->set_lang('lang_admin_cachemanager');

		//Do "something"
		switch(ifsetor($_GET['cmd'], false))
		{
			//View a cachefile
			case 'show':
			$this->view_file();
			break;

			case 'delete':
			$this->delete_file();
			break;

			//show cache overview
			default:
			$this->show_cache();
  		}

        //Return html page to the main admin page
        return $this->html;
    }

	/**
	 * Show contents of a cachefile
	 *
	 */
    function view_file()
    {
		$view = ifsetor($_GET['view'], false);

		//Make sure that the file we want to view is a real file
		if ((strpos($view, 'cache/') === false) || strpos($view, '..'))
		{
			trigger_error('Security: Attempted directory traversal.', E_USER_NOTICE);
			die('Have you ever heard about a place called localhost? I\'ts supposed to be the easiest place to crack :-)');
		}
		else
		{
			// Get cache data and make it safe to show
			$data = file_get_contents("./{$view}");
			$data = htmlentities($data, ENT_QUOTES);

			$this->html	.=  $this->screen->return_html('admin_cache_viewraw', array('cache' => $data));
		}
	}

	/**
	 * Delete a cache file or folder
	 *
	 * This is just a stub
	 *
	 * TODO: Implement
	 *
	 */
	function delete_file()
	{
		$the_file = $_GET['remove'];
		if (strpos($the_file, '..') || !stristr($the_file, 'cache') || !strpos($the_file, '.'))
		{
			trigger_error('Security: Attempted directory traversal.', E_USER_NOTICE);
			return false;
		}
		else
		{
			unlink($the_file);
			redirect('admin.php?act=cachemanager');
		}
	}

	/**
	 * List all cachefiles
	 *
	 */
    function show_cache()
    {
    	$ignored_files = array('index.html', 'CVS', '.svn', 'temp', '.', '..');

		//Read through root cachefolder
		if ($handle = opendir('cache/'))
		{
			while (false !== ($folder = readdir($handle)))
			{
				//Ignore certain files
				if (!in_array($folder, $ignored_files) && is_dir('cache/' . $folder))
				{
					$cachefolders[]    =   $folder;
				}
	   		}
	   		// Cleanup
			closedir($handle);
		}

		//loop through subfolders and find cache files
		foreach ($cachefolders as $cachefolder)
		{
			// cachesize array first
			$cachesize[$cachefolder] = 0;

			if ($handle = opendir("cache/{$cachefolder}"))
			{
	  			while (false !== ($file = readdir($handle)))
	  			{
	  				$filename = "cache/{$cachefolder}/{$file}";

	  				// Is this a proper cache file?
					if (!in_array($file, $ignored_files) && is_file($filename))
					{
						// Add to the great array of cachefiles/folders
						$filename 	= str_replace('\\', '/', $filename);
						$filesize 	= filesize($filename);

	     				$cachefiles[$cachefolder][$filename]  =  $filesize;

	     				// Increment total cachesize
	     				$cachesize[$cachefolder] = ($cachesize[$cachefolder] + $filesize);
	     			}
			   	}
			   	// Cleanup
			   	closedir($handle);
			}
		}
		unset($cachefolders, $file);

		// We now have this array structure;
		// array('folder' => array('file' => 'filesize', 'file2' => 'filesize2'))
		// Which we now will loop trough and print to our beloved user
		$output = '';
		foreach ($cachefiles as $folder => $files)
		{
			//For each folder, list name and files
			//Set up name
			$size 	= round(($cachesize[$folder] / 1000), 2);
			$name  	=   str_replace('%size%', $size, $this->lang->folder_name);
			$name  	=   str_replace('%name%', $folder, $name);
			$output	.=  $this->screen->return_html('admin_cache_startList', array('name' => $name));

			//Loop files
			foreach ($files as $file => $filesize)
	 		{
				$filesize	=   round(($filesize / 1000), 1);
				$output		.=  $this->screen->return_html('admin_cache_row', array('file' => $file, 'size' => $filesize));
			}

			$output		.=  $this->screen->return_html('admin_cache_endtList');
		}

		//Return parsed html code
        $this->html	=	$this->screen->return_html('admin_cachemanager', array('content' => $output));
	}
}
?>
