<?php
/**
*
* @package Vikingboard
* @author Tor Henning Ueland <tor.henning@vikingboard.com>
* @version 0.2
*
* $Id: cencor.php 1531 2007-07-22 13:26:31Z jorgenboard $
*
*/

//oh no!
if (!defined('VBOARD'))
{
	die('Hacker attempt in ' . basename(__FILE__));
}

class admin
{

	/**
	 * Class loaded, this is called by the main admin page script.
	 * Management of bad words.
	 *
	 * @param obj screen
	 * @param obj cache
	 * @param obj db
	 * @param obj config
	 *
	 * @return bool
	 */
    function admin($screen, $data, $config)
    {
        //Set "things"
        $this->lang 	= new lang_admin_wordcencor();
        $this->screen	= $screen;
        $this->data 	= $data;
        $this->config	= $config;
        $this->screen->set_lang('lang_admin_wordcencor');

		//Find out what to do
		switch (ifsetor($_GET['cmd'], ''))
		{
		  	case 'delete':
		  	$this->delete_row();
		  	$this->list_words();
		  	break;

		  	case 'addword':
		  	$this->add_row();
		  	$this->list_words();
		  	break;

			default:
			$this->list_words();
  		}

        //Return html page to the main admin page
        return $this->html;
    }

	/**
	 * Adds a badword cencor
	 *
	 * @return bool
	 */
	function add_row()
	{
		//Set variables
		$before = $_POST['before'];
		$after	= $_POST['after'];

		$before = htmlspecialchars($before);
		$after	= htmlspecialchars($after);

		//Make sure we got all we want
		if (empty($before) || empty($after))
		{
			error_msg($this->lang->missingData, 1);
		}

		//Lets add the word if we got everything
		$this->data->query('add_badword', array($before, $after));

		//Drop the cache
		$this->data->flush_cache();
	}

	/**
	 * Deletes a badword cencor
	 *
	 * @return bool
	 */
	function delete_row()
	{
		$id = safe_user_int('id', false);
		if ($id !== false)
		{
			//Delete from DB
			$this->data->query('delete_badword', array($id));

			//Drop the cache
			$this->data->flush_cache();
		}
		else
		{
			error_msg($this->lang->missingData, 1);
		}
	}


	/**
	 * Shows badwords management page to user
	 *
	 * @return bool
	 */
    function list_words()
    {
		//Build a list off all words
		$words = $this->data->cachedQuery('get_badwords', array());

		if (!empty($words))
		{
			$rows = '';
			foreach ($words as $word)
			{
				$row['before']	=	$word->name;
				$row['after']	=	$word->nname;
				$row['id']		=	$word->id;
				$rows			.=	$this->screen->return_html('admin_cencor_row', $row);
			}
		}
		else
		{
			// Construct "No data" template
		}

		//Build the page
		$html['wordlist']		=	$rows;
        $this->html  =   $this->screen->return_html('admin_cencor_list', $html);
	}

}
?>