<?php
/**
*
* @package Vikingboard
* @author Tor Henning Ueland <tor.henning@vikingboard.com>
* @version 0.2
*
* $Id: config_global.php 1669 2007-09-01 22:24:10Z jorgenboard $
*
*/

//oh no!
if (!defined('VBOARD'))
{
	die('Hacker attempt in ' . basename(__FILE__));
}

class admin
{

	/**
	 * Class loaded, this is called by the main admin page script.
	 * This script handles the main configuration
	 *
	 * @param obj screen
	 * @param obj cache
	 * $param obj db
	 *
	 * @return bool
	 */
    function admin($screen, $data, $config)
    {
        //Set "everything"
        $this->screen	=	$screen;
        $this->config	=	$config;
		$this->lang		=	new lang_config_global();
		$this->screen->set_lang('lang_config_global');

        //Update configuration?
        if ($_POST)
        {
			$this->saveConfig();
		}
		else
		{
			$this->showConfig();
		}

        //Return html page to the main admin page
        return $this->html;
    }



	function saveConfig()
	{
		//read config file
		$file	=	file_get_contents('./inc/conf.php');
		$file   =   str_replace("\n\n", "\n", $file);
		$file   =   str_replace("\r\n", "\n", $file);
		$file   =   explode("\n", $file);
		$lines	=	count($file);

		//Update data
		$num    =   0;
		$edit   =   0;
		$newFile=   '';

		foreach ($file as $row)
		{
			if (preg_match("#Div configuration#si", $row) && $edit == 0)
			{
				$edit   =   1;
			}
			if (preg_match("#End of div configuration#si", $row) && $edit == 1)
			{
				$edit   =   0;
			}
			if ($edit == 1)
			{
				foreach ($_POST as $configName => $configValue)
				{
					if (preg_match("'var.*".$configName."'si", $row))
					{
						$row    =   "\t\tvar\t\${$configName}\t\t=\t\"{$configValue}\";";
					}
				}
			}
			if (($num + 1) !=$lines)
			{
				$file[$num] =   "{$row}\r\n";
			}
			else
			{
				$file[$num] =   $row;
			}
			$num++;
		}

		foreach ($file as $row)
		{
			$newFile    .=  $row;
		}

		//save data to file
		if (is_writable('./inc/conf.php'))
		{
			if (!$handle = fopen('./inc/conf.php', 'w+'))
			{
				error_msg($this->lang->could_not_open_config, 1);
			}
			else
			{
				if (fwrite($handle, $newFile) === FALSE)
				{
					error_msg($this->lang->could_not_save_config, 1);
				}
				else
				{
					redirect('admin.php?act=config_global');
				}
			}
		}
		else
		{
			trigger_error('Config: inc/conf_extended.php not writable.', E_USER_NOTICE);

			error_msg($this->lang->config_not_writable, 1);
		}
 	}

 	//=======================
    //  Show configuration
    //=======================
    function showConfig()
    {
		//Get config file
		require_once('./inc/conf_extended.php');

		$output = '';

		// For each setting group
		foreach ($groups as $groupID => $groupName)
		{
			// Get the group name and start the group html output
			$html['groupName']  =   $groupName;
			$output 			.=	$this->screen->return_html('adm_conf_global_startgroup', $html);

			// Loop through all config settings in a group
			foreach ($configToGroup as $configs => $value)
			{
				// Do this config belong to this group?
				if ($value == $groupID)
				{
					//Textbox
					if ($configDescr[$configs]['type']   ==  '1')
					{
						$html['value']  =   $this->config->$configs;
						$html['name']   =   $configs;
						$html['size']   =   strlen($this->config->$configs);
						$html['descr']  =   $configDescr[$configs]['ending'];
						$valueBox  		=   $this->screen->return_html('adm_conf_global_textbox', $html);
						unset($html);
					}

					//Drop-down
					if ($configDescr[$configs]['type']   ==  '2')
					{
						$content = '';
						foreach ($configDescr[$configs]['value'] as $row => $value)
						{
							if ($row == $this->config->$configs)
							{
								$html['value']  	=   $row;
								$html['selected']   =   true;
							}
							else
							{
	                            $html['value']  	=   $row;
	                            $html['selected']	=	false;
							}
							$html['name']   =   $value;

							$content    .=   $this->screen->return_html('adm_conf_global_drop_content', $html);
							unset($html);
						}

						$html['name']   	=   $configs;
						$html['content']	=   $content;
						$valueBox  		=   $this->screen->return_html('adm_conf_global_drop_wrap', $html);
						unset($content);
						unset($html);
					}


					// Output this particular config setting
					$html['title']  =   $configDescr[$configs]['title'];
					$html['descr']  =   $configDescr[$configs]['descr'];
					$html['foo']    =   $valueBox;
					$output    	.=  $this->screen->return_html('adm_conf_global_setting_wrap', $html);

					//Make sure we dont use the same value the next time
					unset($valueBox);
					unset($html);
				}
			}

			// Then output the group ending
            $output    	.=  $this->screen->return_html('adm_conf_global_endSubGroup', '');
		}

		// And then the final output
		$output    			.=  $this->screen->return_html('adm_conf_global_endGroup', '');
		$html['content']	=	$output;
		$this->html         =   $this->screen->return_html('adm_conf_global', $html);
	}


}
?>