<?php
/**
*
* @package Vikingboard
* @author Jørgen Tellnes <jorgis@jorgis.com>
* @version 0.2
* @copyright Copyright (c) 2004-2006 The Vikingboard Project
* @license GPL {@link http://www.gnu.org/licenses/gpl.html}
* @link http://www.vikingboard.com
*
* $Id: forums.php 1852 2007-11-24 13:52:29Z jorgenboard $
*
*/

//oh no!
if (!defined('VBOARD'))
{
	die('Hacker attempt in ' . basename(__FILE__));
}



/**
 * The general, standard admin class for handling admin-pages
 * and other stuff.
 *
 * @todo Use "No rows to show"-tablerows to avoid foreach-errors, blank pages
 * 			and messed-up layout.
 */
class admin
{
	/**
	 * Class loaded, this is called by the main admin page script.
	 * This script handles the management of categories and forums
	 *
	 * @param obj screen
	 * @param obj data
	 * @param obj config
	 *
	 * @return bool
	 */
    function admin($screen, $data, $config) {

        //Set "things"
        $this->lang		= new lang_admin_forums();
        $this->screen	= $screen;
        $this->data		= $data;
        $this->config	= $config;
		$this->screen->set_lang('lang_admin_forums');

		// Return value
		$this->html		= '';

		//Find out what to do
		$cmd = @$_GET['cmd'];

		switch ($cmd) {

			//Edit category
			case 'editcat':
			$this->editCategory();
			break;

			//Edit forum
			case 'editforum':
			$this->editForum();
			break;

			//Add forum
			case 'newforum':
			$this->addForum();
			break;

			//new category
			case 'newcat':
			$this->addCat();
			break;

			//Delete forum
			case 'deleteforum':
			$this->deleteForum();
			break;

			//Delete category
			case 'deletecat':
			$this->deleteCategory();
			break;

			//synchronize forum
			case 'resyncforum':
			$this->resyncForum();
			break;

			//move forum
			case 'moveforum':
			$this->move_forum();
			break;

			//move category
			case 'movecat':
			$this->move_cat();
			break;

			//Show listing
			default:
			$this->listForums();
			break;
  		}

        //Return html page to the main admin page
        return $this->html;
    }

    /**
     * Add a new forum to the board
     *
     */
    function addForum()
    {
		//Save a new forum?
		if (!empty($_POST['name']))
		{
			//Save it if all fields is good
			if (!empty($_POST['name']) && !empty($_POST['descr']) && is_numeric($_POST['category']))
			{
				//find the order
				$order = $this->data->query('get_last_forum', array($_POST['category']));
				$order = $order[0];

				$this->data->query('createForum', array($_POST['name'], $_POST['descr'], $_POST['category'], $order->order + 10));

				//flush the cache and get back to forum listing
				$this->data->flush_cache();

				redirect('admin.php?act=forums');
	  		}
	  		else
	  		{
				//Complain if we didn't get all the data we need
                $html['infoMessage']  =   $this->lang->missingData;
			}
  		}

		//Get categories and construct the list
		$categories = $this->data->cachedQuery('get_forum_categories');

		$categoryList	=	'';
		foreach ($categories as $category)
		{
			$categoryList   .=  $this->screen->return_html('dropdown_option', array('value' => $category->id, 'selected' => '', 'name' => $category->name));
		}

		//Show the add forum page
		$html['categorylist']	= $categoryList;

		$this->html 			=   $this->screen->return_html('admin_forums_addforum', $html);
	}

	/**
	 * Add a new category to the board
	 *
	 */
	function addCat()
	{
		//is there any action?
		if ($_POST['name'] && $_POST['descr'])
		{
			//get cat order
			$order = $this->data->query('get_last_cat', array());
			$order = $order[0];

			$this->data->query('createCategory', array($_POST['name'], $order->order + 10));

			//flush cache
			$this->data->flush_cache();

			redirect('admin.php?act=forums');
		}

		//and output
		$this->html		=	$this->screen->return_html('admin_forums_addcat', $html);
	}

	/**
	 * Edit a specified category
	 *
	 */
    function editCategory()
    {
  		//Category id
		if (is_numeric($_GET['id']) && ($_GET['id'] > 0))
		{
			$id =   $_GET['id'];
  		}
  		else
  		{
			$id =   1;
		}

		//Should we save some data?
		if (isset($_POST['name']))
		{
			//Category name
			$name  = htmlspecialchars($_POST['name']);


			//okey then, first update database
			$this->data->query('update_category', array($id, $name, $_POST['extended']));

			//Then flush cached data
			$this->data->flush_cache();

			//And redirect
			redirect('admin.php?act=forums');
  		}

		//Fetch information about it
		$info   =   $this->data->cachedQuery('get_forum_category', array('0' => $id));
		$info   =   $info[0];

		if ($info->extend == '1')
		{
			$html['checked']	=	'checked';
		}
		else
		{
			$html['checked']	=	'';
		}

		//Print the edit form
		$html['categoryName']   =   $info->name;
		$html['id']     		=   $info->id;

		$this->html 			=   $this->screen->return_html('admin_forums_editcat', $html);
		unset($html);
	}

	/**
	 * Edit a specified forum
	 *
	 */
	function editForum()
	{

		$forumid = safe_user_int('id', false);
		if (!$forumid)
		{
			error_msg($this->lang->no_forum_id, 1);
		}

		//are there anything to do?
		if (isset($_POST['name']))
		{
			//Category description
			$descr = htmlspecialchars($_POST['description']);

			//Category name
			$name  = htmlspecialchars($_POST['name']);

			//update the forum info
			$this->data->query('update_forum_info', array($forumid, $name, $descr));

			$cat = $_POST['category'];
			if ($cat > '0')
			{
				$this->data->query('move_forum', array($forumid, $cat));
			}

			//Flush cache and get back
			$this->data->flush_cache();

			redirect('admin.php?act=forums');
		}

		//get all categories available
		$cats = $this->data->query('get_forum_categories', array());

		//Start the dropdown rows
		$cat_move = $this->screen->return_html('dropdown_option',
										array('value' => '0',
												'selected' => 'selected="selected"',
												'name' => $this->lang->editforum_sel_cat));
		foreach ($cats as $cat)
		{
			$html = array(	'value' 	=>	$cat->id,
							'selected'	=>	'',
							'name'		=>	$cat->name);
			$cat_move .= $this->screen->return_html('dropdown_option', $html);
			unset($html);
		}

		//then let us output the form
		$forum = $this->data->query('get_forum_info', array($forumid));
		$forum = $forum[0];

		$html['name']		=	$forum->name;
		$html['descr']		=	$forum->descr;
		$html['id']			=	$forum->id;
		$html['categories']	=	$cat_move;

		$this->html			=	$this->screen->return_html('admin_forums_editforum', $html);

	}

	/**
	 * Move a forum up/down
	 *
	 */
	function move_forum()
	{
		$move 	= $_GET['move'];
		$id 	= safe_user_int('id', 1);

		$forum 	= $this->data->cachedQuery('get_forum_cat', array($id));
		$forum 	= $forum[0];

		switch ($move)
		{
			case 'up':
				$this->data->query('change_forum_order', array($id, "- '15'"));
				$this->realign($forum->cat);
			break;

			case 'down':
				$this->data->query('change_forum_order', array($id, "+ '15'"));
				$this->realign($forum->cat);
			break;
		}
	}

	/**
	 * Move a category up/down
	 *
	 */
	function move_cat()
	{
		$move 	= $_GET['move'];
		$id 	= safe_user_int('id', 0);

		switch ($move)
		{
			case 'up':
				$this->data->query('change_cat_order', array($id, "- '15'"));
				$this->realign(0);
				break;

			case 'down':
				$this->data->query('change_cat_order', array($id, "+ '15'"));
				$this->realign(0);
				break;
		}
	}

	/**
	 * Recount and readjust all the forum ordering stuffies
	 *
	 * @param int $cat
	 */
	function realign($cat)
	{
		if ($cat != '0')
		{
			//get all forums in cat, ordered by order field
			$forums = $this->data->query('get_forums_in_category', array($cat));

			$order = 10;
			//loop'em all!
			foreach ($forums as $f)
			{
				//update all forum orders
				$this->data->cachedQuery('update_forum_order', array($f->id, $order));
				$order += 10;
			}
		}
		elseif ($cat == '0')
		{
			$cats = $this->data->query('get_forum_categories', array());

			$order = 10;

			//loopin'
			foreach ($cats as $c)
			{
				//update all cat orders
				$this->data->cachedQuery('update_cat_order', array($c->id, $order));
				$order += 10;
			}
		}

		//flush cache and return
		$this->data->flush_cache();
		redirect('admin.php?act=forums');
	}

	/**
	 * Deletes a forum
	 *
	 */
	function deleteForum()
	{
		global $user;

		//global vars
		$id 		= safe_user_int('id', false);
		if (!$id)
		{
			die('ID not specified or invalid.');
		}

		$confirm 	= $_GET['confirm'];
		$do 		= ifsetor($_GET['do'], '');
		$move		= safe_user_int('move', 1);

		//are there any "leftovers"?
		$forum	=	$this->data->query('get_topics_in_forum', array($id));
		$forum	=	$forum[0];

		$forumname	= 	$this->data->query('get_forum_info', array($id));
		$forumname	=	$forumname[0];

		//is there any topics/posts left in the forum?
		if ($forum->total > 0)
		{
			if (!$do)
			{
				//get all forums for the dropdown
				$forums		=	$this->data->cachedQuery('get_all_forums', array());

				$forumlist = '';
				foreach ($forums as $f)
				{
					if ($f->id != $id)
						$forumlist .= $this->screen->return_html('dropdown_option',
										array(	'value' => $f->id,
												'selected' => '',
												'name' => $f->name	));
				}

				//output the choices
				$html['descr']		=	str_replace('%forum%', $forumname->name, $this->lang->delforum_descr);
				$html['id']			=	$id;
				$html['options'] 	=	$forumlist;
				$html['skin_set'] 	= 	$user->skin_set;
				$this->html			=	$this->screen->return_html('admin_forums_deleteforum', $html);
			}
			elseif ($do == 'delete')
			{
				// Delete all topics and unlink all posts
				$topics = $this->data->query('get_all_topics_in_forum', array($id));

				foreach ($topics as $t)
				{
					$this->data->query('delete_posts_in_topic', array($t->id));
					$this->data->query('delete_topic', array($t->id));
				}

				//de1337
				$this->data->query('delete_forum', array($id));
				$this->data->flush_cache();
				redirect('admin.php?act=forums');
			}
			elseif ($do == 'move')
			{
				//move to the selected forum
				$this->data->query('move_forum_contents', array($id, $move));

				//and unlink the forum
				$this->data->query('delete_forum', array($id));
				$this->data->flush_cache();
				redirect('admin.php?act=forums');

			}

		}
		elseif ($forum->total == 0)
		{
			//reaaally sure?
			if ($confirm != 'yes')
			{
				$forum_descr	=	str_replace('%forum%', $forumname->name, $this->lang->delforum_descr_notopics);
				$this->html 	= 	confirm($this->lang->delete_forum_header, $forum_descr, array(
												$this->lang->delete_forum => 'admin.php?act=forums&amp;cmd=deleteforum&amp;id=' . $id . '&amp;confirm=yes',
												$this->lang->abort_delete => 'admin.php?act=forums'));
			}
			elseif ($confirm == 'yes')
			{
				//de1337
				$this->data->query('delete_forum', array($id));
				$this->data->flush_cache();
				redirect('admin.php?act=forums');
			}
		}


	}

	/**
	 * Deletes a category
	 *
	 *
	 * @todo Fix the order-values for moved forums, so that they will be max_order + 1 and above
	 */
	function deleteCategory()
	{
		global $user;

		//globals
		$id 		=	safe_user_int('id', false);
		$confirm	=	$_GET['confirm'];
		$do			=	$_GET['do'];
		$move		=	safe_user_int('move', 1);

		//get some info, so we can make qualified judgements
		$cat 		= $this->data->query('get_cat_topics', array($id));
		$cat		= $cat[0];
		$catinfo	= $this->data->query('get_forum_category', array($id));
		$catinfo	= $catinfo[0];

		//is there any topics (and therefore also posts) left in the category?
		if ($cat->topics > 0)
		{

			//then, what do the user want us to do?
			if (!$do)
			{
				$cats 	=	$this->data->cachedQuery('get_forum_categories', array());

				//get the categories to suggest
				$categories = '';
				foreach ($cats as $cat)
				{
					if ($cat->id != $id)
					{
						$categories .= $this->screen->return_html('dropdown_option',
															array(	'value' => $cat->id,
																	'selected' => '',
																	'name' => $cat->name	));
					}
				}

				//construct the page and send it to Screen
				$html = array('skin_set' 	=> $user->skin_set,
								'descr'		=> str_replace('%cat%', $catinfo->name, $this->lang->delcat_descr),
								'id'		=> $id,
								'options'	=> $categories);

				$this->html = $this->screen->return_html('admin_forums_deletecat', $html);
			}
			elseif ($do == 'delete')
			{
				// Loop over all forums in category
				$forums = $this->data->query('get_forums_in_category', array($id));

				foreach ($forums as $f)
				{
					// Delete all topics and unlink all posts in this forum
					$topics = $this->data->query('get_all_topics_in_forum', array($f->id));

					foreach ($topics as $t)
					{
						$this->data->query('delete_posts_in_topic', array($t->id));
						$this->data->query('delete_topic', array($t->id));
					}

					$this->data->query('delete_forum', array($f->id));
				}

				//de1337
				$this->data->query('delete_category', array($id));
				$this->data->flush_cache();

				//return
				redirect('admin.php?act=forums');
			}
			elseif ($do == 'move')
			{
				//move forums and topics to the selected category
				$this->data->query('move_category_forums', array($id, $move));
				$this->data->query('move_category_topics', array($id, $move));

				//and unlink the category
				$this->data->query('delete_category_forums', array($id));
				$this->data->query('delete_category', array($id));

				// Flush cache and return
				$this->data->flush_cache();
				redirect('admin.php?act=forums');
			}

		}
		elseif ($cat->topics == '0')
		{
			// Reaaally sure?
			if ($confirm != 'yes')
			{
				$descr		= str_replace('%cat%', $catinfo->name, $this->lang->delcat_descr_notopics);
				$this->html = confirm($this->lang->delete_category_header, $descr, array(
											$this->lang->delete_category => 'admin.php?act=forums&amp;cmd=deletecat&amp;id=' . $id . '&amp;confirm=yes',
											$this->lang->abort_delete => 'admin.php?act=forums'));
			}
			elseif ($confirm == 'yes')
			{
				//de1337
				$this->data->query('delete_category', array($id));

				// Flush cache and return
				$this->data->flush_cache();
				redirect('admin.php?act=forums');
			}
		}
	}

	/**
	 * Update and resynchronize the post/topic-stats
	 * for a specified forum
	 *
	 */
	function resyncForum()
	{

		$forumid = $_GET['id'];

		//get the REAL number of posts
		$post	=	$this->data->query('get_posts_in_forum', array($forumid));
		$post	=	$post[0]->total;

		//and the REAL number of topics
		$topics =	$this->data->query('get_topics_in_forum', array($forumid));
		$topics =	$topics[0]->total;

		//and check if we need to update the post/topic-stats
		$stats 	=	$this->data->query('get_forum_stats', array($forumid));
		$stats 	=	$stats[0];

		//get the last post info
		$last_topic = $this->data->query('get_last_topic', array($forumid));
		$last_topic	= $last_topic[0];

		$last_post 	= $this->data->query('get_last_post', array($last_topic->id));
		$last_post	= $last_post[0];

		$this->data->query('update_last_post', array($forumid,
													$last_post->author_name,
													$last_post->id,
													$last_post->author_id,
													$last_post->posted,
													$last_topic->title,
													$last_topic->id));
		//update
		if (($stats->stat_posts != $post) OR ($stats->stat_threads != $topics))
		{
			$this->data->query('update_forum_stats', array($forumid, $topics, $post));
		}

		//and then let us get back to where we were
		$this->data->flush_cache();

		redirect('admin.php?act=forums');
	}

	/**
	 * Lists all forums and categories
	 *
	 */
    function listForums()
    {

		global $user;

		//Fetch and loop over categories
		$categories = $this->data->cachedQuery('get_forum_categories');

		$output = '';
		foreach ($categories as $category)
		{

			$html['name']   =   $category->name;
			$html['id']     =   $category->id;
			$html['img_set'] =	$user->skin_set;

			$output 		.=  $this->screen->return_html('admin_forums_cat', $html);
			unset($html);

			//Then loop over forums in this category
			$forums =   $this->data->cachedQuery('get_forums_in_category', array($category->id));

			foreach ($forums as $forum)
			{
				$html['name']   =   $forum->name;
				$html['edit']   =   $this->lang->edit;
				$html['delete'] =   $this->lang->delete;
				$html['move']   =   $this->lang->move;
				$html['resync'] =   $this->lang->resync;
				$html['descr']	=	$forum->descr;
				$html['topics']	=	$forum->stat_threads;
				$html['posts']	=	$forum->stat_posts;
				$html['img_set']	=	$user->skin_set;
				$html['id']		=	$forum->id;

				$output 		.=  $this->screen->return_html('admin_forums_forums', $html);
				unset($html);
			}

			$output .= $this->screen->return_html('admin_forums_endcat', array());
		}


		//Fetch the "wrapper" for the forum management
		$html['content'] 	=   $output;
        $this->html  		=   $this->screen->return_html('admin_forums_main', $html);
	}

}
?>