<?php
/**
 * Reported posts
 *
 * @package Vikingboard
 * @author Marius Pedersen Taule <marius@vikingboard.com>
 * @version 0.1b
 *
 * $Id: user.php 842 2006-07-06 16:21:36Z jorgenboard $
 */

// Oh no!
if (!defined('VBOARD'))
{
	die('Hacker attempt in ' . basename(__FILE__));
}

class admin
{
	/**
	 * Class loaded, this is called by the main admin page script.
	 * Reported posts management in Admin CP
	 *
	 * @param obj screen
	 * @param obj data
	 * @param obj config
	 */
	function admin($screen, $data, $config)
	{
		// Setting a few variables
		$this->screen	=	$screen;
		$this->data		=	$data;
		$this->config	=	$config;
		$this->lang		=	new lang_admin_reported();

		$this->screen->set_lang('lang_admin_reported');

		// Determinating what to do
		switch (ifsetor($_GET['cmd'], false))
		{
			case 'post':
			$this->reported_post();
			break;

			case 'update':
			$this->update_reported_post();
			break;

			case 'multi':
			$this->change_multiple_status();
			break;

			default:
			$this->list_reported_posts();
		}
	}

	/**
	 * List reported posts
	 *
	 * Displays a list of the reported posts.
	 */
	function list_reported_posts()
	{
		$reports	=	ifsetor($_POST['reports'], false);
		$status		=	ifsetor($_POST['status'], false);

		if ($reports)
		{
			foreach ($reports as $r)
			{
				$this->change_status($r, $status);
			}
		}

		$status		=	array(
								array(
									'value'		=>	'1',
									'name'		=>	$this->lang->status_open
								),
								array(
									'value'		=>	'2',
									'name'		=>	$this->lang->status_closed
								),
								array(
									'value'		=>	'3',
									'name'		=>	$this->lang->status_pending
								)
							);

		switch (ifsetor($_POST['view_status'], false))
		{
			case 'any' :
			$WHERE	=	"";
			break;

			case 'open' :
			$WHERE	=	"r.status = '1' AND";
			break;

			case 'closed' :
			$WHERE	=	"r.status = '2' AND";
			break;

			case 'pending' :
			$WHERE	=	"r.status = '3' AND";
			break;

			default :
			$WHERE	=	"r.status IN(1, 3) AND";
		}

		$reported	=	$this->data->cachedQuery('get_reported_posts', array($WHERE));

		$i			=	0;
		$rows		=	'';

		if ($reported)
		{
			foreach ($reported as $report)
			{
				$i++;

				$html	=	array(
					'post_id'			=>	$report->post_id,
					'thread_title'		=>	$report->thread_title,
					'thread_id'			=>	$report->thread_id,
					'post_author_id'	=>	$report->author_id,
					'post_author'		=>	$report->author_name,
					'reportee_id'		=>	$report->reportee_id,
					'reportee'			=>	$report->reportee_name,
					'report_id'			=>	$report->report_id,
					'status'			=>	$status[$report->status-1]['name'],
					'date'				=>	date($this->config->timestamp1, forumtime($report->time))
				);

				$rows	.=	$this->screen->return_html('admin-reported_post_row', $html);
			}

		}

		if ($i == 0)
		{
			$html	=	array(
				'empty_row'		=>	$this->lang->no_reports,
				'colspan'		=>	'7'
			);
			$rows	=	$this->screen->return_html('empty_row', $html);
		}

		$html	=	array('posts'	=>	$rows);

		$this->html	=	$this->screen->return_html('admin-reported_posts', $html);
	}

	/**
	 * Change status
	 *
	 * @param int id
	 * @param string status
	 * @return void
	 */
	function change_status($id, $status)
	{
		switch ($status)
		{
			case 'open':
			$change	=	'1';
			break;

			case 'closed':
			$change	=	'2';
			break;

			case 'pending':
			$change	=	'3';
			break;
		}

		if ($change)
		{
			$this->data->query('update_report_status', array($id, $change));
		}
	}

	/**
	 * Reported post
	 *
	 * Displays a single report.
	 */
	function reported_post()
	{
		// Getting some data
		$id				=	safe_user_int('r', 0);
		$reported		=	$this->data->cachedQuery('get_reported_post', array($id));
		$reported		=	$reported[0];

		if (!$reported)
		{
			die('No report with that id');
		}

		// Preparing the different status states
		$status		=	array(
			array(
				'value'		=>	'1',
				'name'		=>	$this->lang->status_open,
			),
			array(
				'value'		=>	'2',
				'name'		=>	$this->lang->status_closed,
			),
			array(
				'value'		=>	'3',
				'name'		=>	$this->lang->status_pending,
			),
		);

		$status_options	=	'';
		foreach ($status as $s)
		{
			// Is the current status the same as the report's status?
			if ($s['value'] == $reported->status)
			{
				$selected		=	'selected="selected"';
				$status_text	=	$s['name'];
			}
			else
			{
				$selected	=	'';
			}

			$option	=	array(
				'value'		=>	$s['value'],
				'selected'	=>	$selected,
				'name'		=>	$s['name'],
			);

			// Template pleace!
			$status_options	.=	$this->screen->return_html('dropdown_option', $option);
		}

		$thread_text	=	str_replace('%post_id%', $reported->pid, $this->lang->thread);
		$thread_text	=	str_replace('%thread_id%', $reported->tid, $thread_text);
		$thread_text	=	str_replace('%thread_title%', $reported->topic_title, $thread_text);

		$comment		=	(!$reported->comment) ? $this->lang->none : $reported->comment;

		// Template variables
		$html	=	array(
			'id'					=>	$id,
			'thread_title'			=>	$thread_text,
			'thread_id'				=>	$reported->tid,
			'thread_name'			=>	$reported->topic_title,
			'post_id'				=>	$reported->pid,
			'post_author_id'		=>	$reported->pid,
			'post_author_name'		=>	$reported->author_name,
			'reportee_id'			=>	$reported->uid,
			'reportee_name'			=>	$reported->reportee_name,
			'reported_time'			=>	date($this->config->timestamp1, forumtime($reported->time)),
			'message'				=>	nl2br($reported->message),
			'status'				=>	$status_text,
			'comment'				=>	nl2br($comment),
			'comment_value'			=>	$reported->comment,
			'status_options'		=>	$status_options
		);

		// Adding to template, hooray!
		$this->html	=	$this->screen->return_html('admin-reported_post', $html);
	}

	/**
	 * Update reported post
	 *
	 * Updates the report with new info (and sends PM).
	 */
	function update_reported_post()
	{
		$id				=	$_POST['id'];
		$status			=	$_POST['status'];
		$comment		=	$_POST['comment'];

		/*$pm_reportee	=	$_POST['pm_reportee'];
		$pm_author		=	$_POST['pm_author'];*/

		//$reported	=	$this->db->get_reported_post($id);

		//$this->db->update_reported_post($id, $status, $comment, $reported->pm_reportee, $reported->pm_author);
		$this->data->query('update_reported_post', array($id, $status, $comment));

		/*if($pm_reportee != $reported->pm_reportee)
		{
			$this->db->send_pm($pm_reportee, $reported->reportee);
		}

		if($pm_author)
		{
			$this->db->send_pm($pm_author, $reported->author);
		}*/

		redirect('admin.php?act=reported&cmd=post&r=' . $id);
	}

	/**
	 * Change status on multiple reports
	 */
	function change_status_multi($report, $status)
	{
		if($report)
		{
			switch($status)
			{
				case 'open':
				$change	=	'1';
				break;

				case 'closed':
				$change	=	'2';
				break;

				case 'pending':
				$change	=	'3';
				break;

				default:
				$change	=	'1';
			}

			$this->data->query('update_reports_status', array($change, $status));
		}
	}
}

?>