<?php

/**
 * @package Vikingboard
 * @author Tor Henning Ueland <tor.henning@vikingboard.com>
 * @version 0.2.0
 *
 * $Id: templates.php 1664 2007-08-31 20:43:18Z paitrakt $
 */

// oh no!
if (!defined('VBOARD'))
{
	die('Hacker attempt in ' . basename(__FILE__));
}


class admin
{
	/**
	 * Class loaded, this is called by the main admin page script.
	 * This whole script handles management of themplates
	 *
	 * @param obj screen
	 * @param obj cache
	 * @param obj db
	 * @param obj config
	 *
	 * @return bool
	 */
	function admin($screen, $data, $config)
	{
		$this->screen	=	$screen;
		$this->data		=	$data;
		$this->config	=	$config;
		$this->lang		=	new lang_admin_templates;
		$this->screen->set_lang('lang_admin_templates');

		// what to do?
		switch (ifsetor($_GET['cmd'], false))
		{
			case 'editor':
			$this->html	=	$this->editor();
			break;

			case 'newcode':
			$this->html	=	$this->newCodeForm();
			break;

			case 'addNewCode':
			$this->html	=	$this->addNewCode();
			break;

			case 'addcategory':
			$this->html	=	$this->addCatForm();
			break;

			case "addNewCategory":
			$this->html	=	$this->saveNewCat();
			break;

			default:
			$this->html	=	$this->show_template_sets();
			break;
		}

		// Return content
		return $this->html;
	}


	/**
	 * Displays a "new template" form.
	 *
	 * @access public
	 * @return bool
	 */
	function addCatForm()
	{
		return $this->screen->return_html('admin-tpl_addcategory', array());
	}


	/**
	 * Saves a new template category
	 *
	 * @access public
	 * @return bool
	 */
	function saveNewCat()
	{
		if ($_POST['catName'] !="")
		{
			// Add to DB
			$this->data->query('add_template_category', $_POST['catName']);

			// Drop cache (it will magicly be recached)
			$this->data->reset();

			// Redirect user
			redirect('admin.php?act=templates');
		}
		else
		{
			// Else show an error message (if we dont have a name)
			error_msg($this->lang->missing_data, 1);
		}
	}


	/**
	 * Saves a new template code to database
	 *
	 * @access public
	 * @return bool
	 */
	function addNewCode()
	{
		// Make sure we have all that we need
		if ($_POST['tagName'] !="" && $_POST['niceName'] !="")
		{
			$sets = $this->data->query('get_template_sets');
			foreach($sets as $set) {
				$this->data->query('add_template_tag', array($set->id, $_POST['tagName'], $_POST['niceName'], $_POST['category']));
			}
			redirect('admin.php?act=templates');
  		}
  		else
  		{
			error_msg($this->lang->missing_data, 1);
		}
	}


	/**
	 * Shows the new code form
	 *
	 * @access public
	 * @return bool
	 */
	function newCodeForm()
	{
		// Fetch categories
		$categories	=	$this->data->query('get_template_categories');

		$html['dropDown']	=	'';
		foreach ($categories as $row)
		{
			$html['dropDown']	.=	'<option value="' . $row->id . '">' . $row->name . "</option>\n";
		}

		// Show the form
		return $this->screen->return_html('admin-tpl_addcode', $html);
	}


	/**
	 * Shows the template editor
	 *
	 * @access public
	 * @return bool
	 * @todo add security check
	 */
	function editor()
	{
		// Update content?
		if (isset($_POST['html']))
		{
            // Update database
			$in[0]	=	safe_user_int('id', 0);
			$in[1]	=	$_POST['nice_name'];
			$in[2]	=	$_POST['system_name'];
			$in[3]	=	safe_user_int('category', '');
			$in[4]  = 	safe_user_int('set', '');
			$this->data->query('update_template_code', $in);

			// Write template data
			$path = 'static/'.$_POST['set'].'/templates/'.$in[2].'.html';

			if(is_writable($path) || is_file($path) == false) {
				$handle = fopen($path, 'w');
				fwrite($handle, $_POST['html']);
				fclose($handle);
			}

			// Drop cache
			$this->data->flush_cache(true);

			// Redirect back
			redirect("admin.php?act=templates&cmd=editor&id={$in[0]}");
		}


		// Fetch the template to work with now
		$tplInfo[]		=	safe_user_int('id', 0); // Template id
		$templateInfo	=	$this->data->query('get_template_from_id', $tplInfo);
		$templateInfo	=	$templateInfo[0];

		// Build a category list
		$toDrop['name']	=	"category";
		$dropDown		=	$this->screen->return_html('dropdown_start', $toDrop);
		$categories		=	$this->data->cachedQuery('get_template_categories');

		foreach ($categories as $category)
		{
			$content['value']	=	$category->id;
			$content['name']	=	$category->name;

			if ($category->id == $templateInfo->cat )
			{
				$content['selected']	=	"selected";
			}
			else
			{
				$content['selected']	=	"";
			}

			$dropDown	.=	$this->screen->return_html('dropdown_option', $content);
		}

		$dropDown	.=	$this->screen->return_html('dropdown_end', $toDrop);

        // Do a "can-write " check
        $path = 'static/'.$templateInfo->set_id.'/templates/'.$templateInfo->name.'.html';
        if(is_writable($path) == false) {
            $html['cantWrite'] = true;
            $html['writePath'] = $path;
        }

		// Define template tags for the editor (content);
		$html['templateId']	=	safe_user_int('id', 0);
		$html['niceName']	=	$templateInfo->nice_name;
		$html['systemName']	=	$templateInfo->name;
		$html['category']	=	$dropDown;
		$html['html']		=	file_get_contents('static/'.$templateInfo->set_id.'/templates/'.$templateInfo->name.'.html');
		$html['set']		=	$templateInfo->set_id;

		// Get the template to show the editor
		return $this->screen->return_html('admin-tpl_editor', $html);
	}


	/**
	 * Shows all template sets, frontpage of this page
	 *
	 * @access public
	 * @return bool
	 */
	function show_template_sets()
	{
		// Get template sets
		$sql	=	$this->data->query('get_template_sets');
		$sets	=	'';

		foreach ($sql as $row)
		{
			// Mark the unactive as unactive
			if ($row->active == 0)
			{
				$name	=	"{$this->lang->unactive}{$row->name}";
			}
			else
			{
				$name	=	$row->name;
			}

			// Add some html
			$set['name']	=	$name;
			$set['id']		=	$row->id;
			$sets			.=	$this->screen->return_html('admin_tpl_listset', $set);

			// Is this the active set?
			if ($row->id == safe_user_int('active', 0))
			{
				// Then show the categories :D
				$thisCat[]	=	$row->id;
				$catSQL		=	$this->data->query('get_template_categories');

				foreach ($catSQL as $thisCat)
				{
					$cat['name']	=	$thisCat->name;
					$active			.=	$this->screen->return_html('admin-tpl_listcat', $cat);

					// For each category, find templates in the category
					$getTpl[]	=	$thisCat->id; // catID
					$getTpl[]	=	$row->id; // setID
					$tplSQL		=	$this->data->query('get_templates_in_set_and_cat', $getTpl);

					foreach ($tplSQL as $thisTPL)
					{
						$tpl['name']	=	$thisTPL->nice_name;
						$tpl['id']		=	$thisTPL->id;
						$active			.=	$this->screen->return_html('admin-tpl_listtpl', $tpl);
					}

					unset($getTpl);
				}

				// Also add "unspesified as a category"
				$getTpl[]	=	$row->id; // setID
				$getTpl[]	=	0; // catID
				$tplSQL		=	$this->data->query('get_templates_in_set_and_cat', $getTpl);
// Debug? print_r($tplSQL);
				if($tplSQL)
				{
					$cat['name']	=	'Undefined template bits';
					$active			.=	$this->screen->return_html('admin-tpl_listcat', $cat);

					foreach ($tplSQL as $thisTPL)
					{
						$tpl['name']	=	$thisTPL->nice_name;
						$tpl['id']		=	$thisTPL->id;
						$active			.=	$this->screen->return_html('admin-tpl_listtpl', $tpl);
					}
				}

				unset($getTpl);
			}
		}

		// Add html to output
		$html['info']				=	$this->lang->info;
		$html['listtemplatesets']	=	$sets;
		$html['active']	=	$active;

		$html	=	$this->screen->return_html('admin_tpl_main', $html);

		return $html;
	}
}

?>
