<?php

/**
 * Fancy Teletype Pocket (FTP) class
 *
 * For all your FTP-related issues
 * @author Jrgen Tellnes <jorgis@jorgis.com>
 * @version 0.2.0
 * $Id: ftp.php 1183 2006-11-27 08:56:09Z PaiTrakt $
 */

//oh no!
if (!defined("VBOARD"))
{
	die('Hacker attempt in ' . basename(__FILE__));
}

class FTP
{
	// Variables declared
	var $connection;
	var $username;
	var $password;
	var $host;
	var $dir;

	// Connecting to server
	function connect($host)
	{
		if ($ftp = ftp_connect($host))
		{
			$this->connection	=	$ftp;
			return true;
		}
		else
		{
			return false;
		}
	}

	// Logging in
	function login($uname, $pass)
	{
		if (ftp_login($this->connection, $uname, $pass))
		{
			return true;
		}
		else
		{
			return false;
		}
	}

	// CHMOD (PHP4-compatible)
	function chmod($file, $value)
	{
		if (ftp_site($this->connection, 'CHMOD ' . $value . ' ' . $file))
		{
			return true;
		}
		else 
		{
			return false;
		}
	}

	// Making a new directory, removing old
	function mkdir($folder)
	{
		if (@ftp_mkdir($this->connection, $folder))
		{
			return true;
		}
		else 
		{
			if (@ftp_rmdir($this->connection, $folder))
			{
				if (@ftp_mkdir($this->connection, $folder))
				{
					return true;
				}
				else
				{
					return false;
				}
			}
			else 
			{
				return false;
			}
		}
	}

	// Upload a file to server
	function put($file, $remote_file, $mode = FTP_ASCII)
	{
		if (ftp_put($this->connection, $remote_file, $file, $mode))
		{
			return true;
		}
		else 
		{
			return false;
		}
	} 

	// Closing connection
	function close()
	{
		if (ftp_close($this->connection))
		{
			return true;
		}
		else 
		{
			return false;
		}
	}
}

?>