<?php

/**
 * Mail class
 *
 * This file takes care of all emailing work that is to be done
 *
 * @param int $sendto User ID of the user that the mail is sent to
 * @param string $title	Email title
 * @param string $msg The email message to the user
 * @author  Tor Henning Ueland
 * @version 0.2.0
 *
 * $Id: php.php 1598 2007-08-16 00:04:04Z paitrakt $
 */

//oh no!
if (!defined('VBOARD'))
{
	die('Hacker attempt in ' . basename(__FILE__));
}


/**
 * Emailer
 *
 * @param string sendto
 * @param string title
 * @param string msg
 */
function emailer($sendto, $title, $msg)
{
	// Globalizing
	global $config, $data;

	// Getting the required fields from the user table
	$mailinfo	=	$data->query('get_users_mailinfo_from_id', array($sendto));
	$mailinfo	=	$mailinfo[0];

	/**
	 * Activating the language file (note here that we are getting
	 * the correct language for the user, and bulgarian user does
	 * not want to have a norwegian language in this mail now will he?
	 */
	if (!$mailinfo->lang)
	{
		if (!(include_once('inc/lang/' . $config->def_lang . '/index.php')))
		{
			die(print 'Error: Could not get the language file');
		}
	}
	else
	{
		if ($mailinfo->lang != $config->def_lang)
		{
			if (!(include_once('inc/lang/' . $mailinfo->lang . '/index.php')))
			{
				die(print 'Error: Could not get the language file');
			}
		}
		else
		{
			if (!(include_once('inc/lang/' . $config->def_lang . '/index.php')))
			{
				die(print 'Error: Could not get the language file');
			}
		}
	}

	// Some default email variables
	$vars	=	array
	(
		array
		(
				'%username%',
				'%board_name%',
				'%board_url%',
		),
		array
		(
				$mailinfo->name,
				$config->forum_name,
				$config->forum_url,
		),
	);

	$lang	=	new lang_emails();
	$hello	=	str_replace($vars[0], $vars[1], $lang->hello);
	$msg	=	str_replace($vars[0], $vars[1], $msg);
	$footer	=	str_replace($vars[0], $vars[1], $lang->footer);

	// Let`s start of by compiling the message with a header, body & footer.
	$message	=	$hello . $msg . $footer;

	// So the message is done, lets make the rest of the mail data
	$headers  = "MIME-Version: 1.0\r\n";
	$headers .= "Content-type: text/plain; charset=UTF-8\r\n";
	$headers .= "Return-Path: " . $config->forum_email . "";
	$headers .= "X-Mailer: Vikingboard Emailer";
	$headers .= "To: " . $mailinfo->name . " <" . $mailinfo->email . ">\r\n";
	$headers .= "From: " . $config->forum_name." <" . $config->forum_email . ">\r\n";

	// Send it!
	if (!mail($mailinfo->email, $title, $message, $headers))
	{
		// Save the email to the mail queue in case it did`nt got sent for some (strange) reason.
		$data->query('save_problem_email', array($mailinfo->email, $title, $headers, $message));
	}
}

?>
