<?php
/**
 *
 * This is the Vikingboard Admin CP SQL file
 *
 * @package Vikingboard
 * @author Tor Henning Ueland <tor.henning@vikingboard.com>
 * @version 0.1
 * @copyright Copyright (c) 2004-2006 The Vikingboard Project
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://www.vikingboard.com
 *
 * $Id: adminsql_MySQL.php 1853 2007-11-24 14:02:04Z jorgenboard $
 *
 */

//oh no!
if (!defined("VBOARD"))
{
	die('Hacker attempt in ' . basename(__FILE__));
}

/*
	DATABASE TYPE:	MySQL
	INFO: Database Abstraction Layer (Contains all queries used in the Admin area)
*/

//Zeh datAfilE(t) (yummy).
if (!include_once('driver_MySQL.php'))
{
	error_msg('<br /><b>Critical error:</b> Could not load database driver!', 0);
}

class sql
{
	// The query-count
	var $queries	=	'0';
	var $database   =   '';
	var $prefix     =   '';

	function sql()
	{
		global $config;
		$this->database =	new database;
		$this->prefix	=	$this->database->db_prefix;
	}

	//=====================
	//  Custom SQL code
	//=====================
	function manual($query)
	{
		$query  =   str_replace("prefix", $this->prefix, $query);
		$this->database->query( $query );

		$this->queries++; //incrementing the query count
		return $this->database;
	}



	//=====================
	//  Add a new template tag
	//=====================
	function add_template_tag($tagName, $niceName, $content, $category)
	{
        $this->database->query("SELECT id FROM {$this->prefix}template_sets");
        $this->queries++;

        //Add it to each set
        while($row = $this->database->row())
        {
            $this->database->query("INSERT INTO {$this->prefix}template (set_id, code, name, nice_name, cat)
						VALUES ('{$row->id}', '{$content}', '{$tagName}', '{$niceName}', '{$category}')");
            $this->queries++;
 		}
	}

	//=====================
	//  Add a new template category
	//=====================
	function add_template_category($name)
	{
        $this->database->query("INSERT INTO {$this->prefix}template_category (name) VALUES ('{$name}')");
        $this->queries++;
	}

	//=====================
	//  Update a template
	//=====================
	function update_template_code($template_id, $html, $category)
	{
		$this->database->query("UPDATE {$this->prefix}template SET code='$html', cat='$category' WHERE id='$template_id' LIMIT 1");

		$this->queries++; //incrementing the query count
		return $this->database;
	}

	//=====================
	//  Get template from ID
	//=====================
	function get_template_from_id($template_id)
	{
		$this->database->query("SELECT * FROM {$this->prefix}template WHERE id='$template_id' LIMIT 1");

		$this->queries++;
		return $this->database;
	}

	//=====================
	//	Get sites that are using the board today
	//=====================
	function get_all_sites()
	{
		$this->database->query("SELECT * FROM {$this->prefix}config");
	    $this->queries++;
		return $this->database;
	}

	//=====================
	//Get the forum/site`s configuration
	//=====================
	function get_forum_config()
	{
		$this->database->query("SELECT * FROM {$this->prefix}config
				WHERE site_host = '".$_SERVER['HTTP_HOST']."' LIMIT 1");
	    $this->queries++;
		return $this->database;
	}

	//=====================
	//SQL for updating the sessions table
	//=====================
	function session_updater($session_id)
	{
		$this->database->query("UPDATE {$this->prefix}sessions SET time ='".forumtime()."',
	 			ip ='".$_SERVER['REMOTE_ADDR']."'
				WHERE sid ='".$session_id."' LIMIT 1");
        $this->queries++;
	}

	//=====================
	//SQL for inserting into the sessions table
	//=====================s
	function session_inserter($session_id)
	{
		$this->database->query("INSERT INTO {$this->prefix}sessions (sid, time, ip)
	 			VALUES ('".$session_id."', '".forumtime()."',
				'".$_SERVER['REMOTE_ADDR']."')");
        $this->queries++;
	}

	//=====================
	// Fetch template categories
	//=====================
	function get_template_categories()
	{
		$this->database->query("SELECT * FROM {$this->prefix}template_category ORDER BY `id` ASC");
        $this->queries++;
		return $this->database;
    }

	//=====================
	// Fetch templates in set and category
	//=====================
	function get_templates_in_set_and_cat($set, $cat)
	{
		$this->database->query("SELECT * FROM {$this->prefix}template WHERE cat='{$cat}' AND set_id='{$set}' ORDER BY name ASC");
        $this->queries++;
		return $this->database;
    }

	//=====================
	//Mothafucka large Query that gets all the data about the user.
	//=====================
	function get_user_info($session)
	{
		$this->database->query("SELECT s.uid, s.time AS updateTime, m.*, g.*
				FROM {$this->prefix}sessions s, {$this->prefix}member m, {$this->prefix}groups g
				WHERE s.sid = '".$session."' AND m.id = s.uid AND g.id=s.group LIMIT 1");
        $this->queries++;
		return $this->database->row();
	}

	//=====================
	// Checking a username to make shure that we dont register a user width double names.
	//=====================
	function get_username_from_name($username)
	{
		$this->database->query("SELECT id FROM {$this->prefix}member WHERE name ='$username'");

		$this->queries++;
		return $this->database;
	}

	/**
	 * Get groups
	 *
	 * @return object dbd
	 */
	function get_groups()
	{
		$this->database->query("SELECT g_name, id FROM {$this->prefix}groups WHERE 1");
		$this->queries++;
		return $this->database;
	}

	//=====================
	// Getting smileys :D :woot: :blush: :wee: :mad: :tomanysmileys: :RTFM: :lol:
	//=====================
	function get_smileys()
	{
		$this->database->query("SELECT id, name, url, code FROM {$this->prefix}smiley WHERE {$this->prefix}smiley.show ='1'");

		$this->queries++;
		return $this->database;
	}



	//=====================
	//Getting the user that is logging in
	//=====================
	function get_info_about_user_logging_in($username, $password)
	{
		$this->database->query("SELECT `id`, `name`,`group` FROM {$this->prefix}member WHERE password = '$password' AND name='$username' LIMIT 1");
		$this->queries++;
		return $this->database->row();
	}

	//=====================
	//Logging in a user :D (wooho, welcome DUDE :D)
	//=====================
	function update_loginuser($ID=1, $group, $name, $login_hide, $login_remember,$session_id)
	{
		global	$user;

		$this->database->query("UPDATE `{$this->prefix}sessions` SET `uid` = '$ID', `time` = '".forumtime()."', `stayin` = '$login_remember',
					`hide` = '$login_hide', `ip` = '".$_SERVER['REMOTE_ADDR']."', `user` = '$name', `group` = '$group'
					WHERE `sid` ='$session_id' LIMIT 1");

		$this->queries++;

		return $this->database;
	}

}
?>
