<?php
/**
 *
 * @package Vikingboard
 * @author Tor Henning Ueland <tor.henning@vikingboard.com>
 * @version 0.2.0
 * @copyright Copyright (c) 2004-2007 The Vikingboard Project
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://vikingboard.com/
 *
 * $Id: driver_MySQL.php 1813 2007-11-19 21:12:56Z ueland $
 *
 */


/**
 *	DATABASE TYPE:	MySQL
 *	INFO: This is the DB driver for the MySQL database.
 */


/**
 * Master database class
 *
 * This database handler is for the MySQL database system
 *
 */
class Database
{
	//Declare variables
	var $db_srv = "localhost";
	var $db_usr = "ueland";
	var $db_pwd = "ueland";
	var $db_db = "vikingboard";
	var $db_prefix = "vboard_";
	var $created;
	var $config;
	var $theQueries;
	var $currentQuery;
	var $connection;

	/**
	 * Class constructor
	 *
	 * Connects to database, loads the SQL query packages, and selects the database
	 *
	 * @param obj $conf Vikingboard config
	 */
	function Database($conf)
	{

		$this->config 	  = $conf;

		//Connect using persistant connection (not recommended, really slow)
		if (isset($conf->persistant) && $conf->persistant == 1)
		{
			if (!$this->connection = mysql_pconnect($this->db_srv, $this->db_usr, $this->db_pwd))
			{
				trigger_error('SQL: ' . mysql_error(), E_USER_WARNING);
				// Returning false
				$this->created = false;
				return;
            }
		}

		//connect using non-persistant connection
		else
		{
			if (!$this->connection = @mysql_connect($this->db_srv, $this->db_usr, $this->db_pwd))
			{
				trigger_error('SQL: ' . mysql_error(), E_USER_WARNING);
				$this->created = false;
				return;
            }
		}

		//Select the database or return an error.
		if (!mysql_select_db($this->db_db))
		{
			trigger_error('SQL: ' . mysql_error(), E_USER_WARNING);
			$this->created = false;
			return;
		}

		$this->created = true;
	}


	/**
	 * Perform query
	 *
	 * Performs a query directly to the Database, returning a array containing the data
	 *
	 * @todo Use mysql_affected_rows() to find if the UPDATE or DELETE query
	 * 		 actually did something. If no rows were affected, Database::query()
	 * 		 really should return FALSE, not TRUE as it does today.
	 * @param $q The query to execute
	 */
	function query($q, $parameters=array())
	{
		//Perform the query
		$result = mysql_query($q);
		$this->currentQuery = $q;

		// Decide what to do with the query results
		if (is_resource($result))
		{
			//Get the dataset
			$data = '';
			while ($t = mysql_fetch_object($result))
			{
				$data[] = $t;
			}

			return $data;
		}
		elseif ($result == FALSE)
		{
			// Trigger error, to invoke the error handler
			trigger_error('SQL: ' . mysql_error(), E_USER_NOTICE);

			return false;
		}
		elseif ($result == TRUE)
		{
			// Successful UPDATE/DELETE query
			return true;
		}

   	}


   	/**
   	 * Get last insert ID
   	 *
   	 * Get the ID from the last INSERT query
   	 *
   	 * @return int $last_insert_id
   	 */
   	function last_insert_id()
   	{
   		return mysql_insert_id();
   	}

   	/**
   	 * Escape string
   	 *
   	 * This method calls the underlying DBMS' corresponding escape function,
   	 * or if such a function does not exist in PHP, this method will implement it
   	 * or reference an implementation.
   	 *
   	 * @param string $string String to escape
   	 * @return string Escaped string
   	 */
   	function escape_string($string)
   	{
   		return mysql_real_escape_string($string);
   	}
}

?>