<?php
/**
 * Vikingboard Admin CP MySQL
 *
 * @package Vikingboard
 * @version 0.2.0
 * @copyright Copyright (c) 2004-2006 The Vikingboard Project
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://www.vikingboard.com
 *
 * $Id: sql_MySQL_admin.php 1853 2007-11-24 14:02:04Z jorgenboard $
 */

/**
 * The default SQL class
 *
 */
class sql extends SQLGlobal
{
	/**
	 * SQL class constructor, sets SQL prefix based on parameter
	 *
	 * @accss public
	 * @param prefix string
	 * @return bool
	 */
	function sql($prefix)
	{
		$this->prefix	=	$prefix;
		return true;
	}


	/**
	 * returns query to get total members registered
	 *
	 * @access public
	 * @return string
	 */
	function countUsers()
	{
		return "SELECT COUNT(*) AS `total`
				FROM `{$this->prefix}member`
				WHERE `id` != 1";
	}

	/**
	 * returns query to get total posts in DB
	 *
	 * @access public
	 * @return string
	 */
	function countPosts()
	{
		return "SELECT COUNT(*) AS `total`
				FROM `{$this->prefix}post`";
	}

	/**
	 * returns query to get totalt topics in DB
	 *
	 * @access public
	 * @return string
	 */
	function countTopics()
	{
		return "SELECT COUNT(*) AS `total`
				FROM `{$this->prefix}topic`";
	}

	/**
	 * returns query to get total reports filed
	 *
	 * @access public
	 * @return string
	 */
	function countReports()
	{
		return "SELECT COUNT(*) AS `total`
				FROM `{$this->prefix}reported`
				WHERE `status` = 1
				OR `status` = 3";
	}


	/**
	 * return query to get all template sets in db
	 *
	 * @access public
	 * @return string
	 */
	function get_template_sets()
	{
		return "SELECT *
				FROM `{$this->prefix}template_sets`
				ORDER BY `name` ASC";
	}

	/**
	 *
	 * Forum managment
	 *
	 */


	/**
	 * Returns query to get all forum categories ordered by order asc
	 *
	 * @access public
	 * @return string
	 */
	function get_forum_categories()
	{
		return "SELECT *
				FROM `{$this->prefix}category`
				ORDER BY `order` ASC";
	}

	/**
	 * Returns query to get all forums in category $in
	 *
	 * @param int $in
	 * @access public
	 * @return string
	 */
	function get_forums_in_category($in)
	{
		return "SELECT *
				FROM `{$this->prefix}forum`
				WHERE `cat` = '{$in[0]}'
				ORDER BY `order` ASC";
	}

	/**
	 * Get REAL number of topics in a forum
	 *
	 * @param int $forumid
	 * @return string
	 */
	function get_topics_in_forum($in)
	{
		return "SELECT COUNT(*) AS `total`
				FROM `{$this->prefix}topic`
				WHERE `forum` = '{$in[0]}'";
	}

	/**
	 * Get REAL number of posts in a forum
	 *
	 * @param int $forumid
	 * @return string
	 */
	function get_posts_in_forum($in)
	{
		return "SELECT COUNT(*) AS `total`
				FROM `{$this->prefix}post` p, `{$this->prefix}topic` t
				WHERE p.`tid` = t.`id`
					AND t.`forum` = '{$in[0]}'";
	}

   /**
	 * Returns query to get statistics from a spesific forum
	 *
	 * @param int $in (0 = int forumID)
	 * @access public
	 * @return string
	 */
	function get_forum_stats($in)
	{
		return "SELECT `stat_posts`, `stat_threads`
				FROM `{$this->prefix}forum`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Returns query to update forum stats
	 *
	 * @param int $in (0 = int forumID, 1 = int thread count, 2 = int post count)
	 * @access public
	 * @return string
	 */
	function update_forum_stats($in)
	{
		return "UPDATE `{$this->prefix}forum`
				SET `stat_threads` = '{$in[1]}', `stat_posts` = '{$in[2]}'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Returns query to create a new category
	 *
	 * @param int $in (0 = string name, 1 = string description, 2 = int order)
	 * @access public
	 * @return string
	 */
	function get_last_topic($in)
	{
		return "SELECT *
				FROM `{$this->prefix}topic`
				WHERE `forum` = '{$in[0]}'
				ORDER BY `lpost_time` DESC
				LIMIT 1";
	}

	/**
	 * Gets the last post in a topic
	 *
	 * @param int $topic
	 * @return string
	 */
	function get_last_post($in)
	{
		return "SELECT *
				FROM `{$this->prefix}post` p, `{$this->prefix}topic` t
				WHERE p.`tid` = '{$in[0]}'
					AND t.`id` = p.`tid`
				ORDER BY p.`id` DESC
				LIMIT 1";
	}

	/**
	 * Returns query to update the last-post for a specific topic
	 *
	 * @param int $topic
	 * @param int $forum
	 * @param string $author
	 * @param int $id
	 * @param int $uid
	 * @param int $time
	 * @return string
	 */
	function update_last_post($in)
	{
		return "UPDATE `{$this->prefix}forum`
				SET `lpost_title` = '{$in[5]}', `lpost_tid` = '{$in[6]}',
					`lpost_pid` = '{$in[2]}', `lpost_uid` = '{$in[3]}',
					`lpost_time` = '{$in[4]}', `lpost_name` = '{$in[1]}'
				WHERE `id` = '{$in[0]}'";
	}

	/**
	 * Returns query to create a new category
	 *
	 * @param int $in (0 = string name, 1 = int order)
	 * @access public
	 * @return string
	 */
	function createCategory($in)
	{
		return "INSERT INTO `{$this->prefix}category` (`name`, `order`, `extend`)
				VALUES ('{$in[0]}', '{$in[1]}', '1')";
	}

	/**
	 * Returns query to get the last category
	 *
	 * @access public
	 * @return string
	 */
	function get_last_cat()
	{
		return "SELECT `order`
				FROM `{$this->prefix}category`
				ORDER BY `order` DESC
				LIMIT 1";
	}

	/**
	 * Get the forum with the highest order (the last in the list)
	 * from a specified category
	 *
	 * @param int $cat
	 * @access public
	 * @return string
	 */
	function get_last_forum($in)
	{
		return "SELECT `order`
				FROM `{$this->prefix}forum`
				WHERE `cat` = '{$in[0]}'
				ORDER BY `order` DESC
				LIMIT 1";
	}

	/**
	 * Returns query to create a new forum in DB
	 *
	 * @param $in array (0 = string name, 1 = string description, 2 = int category, 3 = int order)
	 * @access public
	 * @return string
	 */
	function createForum($in)
	{
		return "INSERT INTO `{$this->prefix}forum` (`name`, `descr`, `cat`, `order`)
				VALUES ('{$in[0]}', '{$in[1]}' , '{$in[2]}', '{$in[3]}')";
	}

	/**
	 * Update a forum category
	 *
	 * @param int $cat_id
	 * @param string $cat_name
	 * @param int $extended
	 * @return string query
	 */
	function update_category($in)
	{
		return "UPDATE `{$this->prefix}category`
				SET `name` = '{$in[1]}', `extend` = '{$in[2]}'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Fetch a forum category
	 *
	 * @param int $cat_id
	 * @return string
	 */
	function get_forum_category($in)
	{
		return "SELECT *
				FROM `{$this->prefix}category`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Fetch info about a single forum
	 *
	 * @param int $forumid
	 * @return string query
	 */
	function get_forum_info($in)
	{
		return "SELECT `name`, `descr`, `id`, `cat`
				FROM `{$this->prefix}forum`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Update forum info (name and description)
	 *
	 * @param int $forumid
	 * @param string $name
	 * @param string $descr
	 * @return string query
	 */
	function update_forum_info($in)
	{
		return "UPDATE `{$this->prefix}forum`
				SET `name` = '{$in[1]}', `descr` = '{$in[2]}'
				WHERE `id` = '{$in[0]}'";
	}

	/**
	 * Move a forum to another category
	 *
	 * @param int $forumid
	 * @param int $catid
	 * @return string query
	 */
	function move_forum($in)
	{
		return "UPDATE `{$this->prefix}forum`
				SET `cat` = '{$in[1]}'
				WHERE `id` = '{$in[0]}'";
	}

	/**
	 * Get category from forum id
	 *
	 * @param int $forumid
	 * @return string query
	 */
	function get_forum_cat($in)
	{
		return "SELECT `cat`
				FROM `{$this->prefix}forum`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Change forum order (up or down)
	 *
	 * @param int $forum_id
	 * @param string $order_movement ("+ '15'" or "- '15'")
	 * @return string query
	 */
	function change_forum_order($in)
	{
		return "UPDATE `{$this->prefix}forum`
				SET `order` = `order` {$in[1]}
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Change category order (up or down)
	 *
	 * @param int $cat_id
	 * @param string $order_movement ("+ '15'" or "- '15'")
	 * @return string query
	 */
	function change_cat_order($in)
	{
		return "UPDATE `{$this->prefix}category`
				SET `order` = `order` {$in[1]}
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Update forum order (set to specific number)
	 *
	 * @param int $forum_id
	 * @param int $order
	 * @return string query
	 */
	function update_forum_order($in)
	{
		return "UPDATE `{$this->prefix}forum`
				SET `order` = '{$in[1]}'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Update category order (set to specific number)
	 *
	 * @param int $cat_id
	 * @param int $order
	 * @return string query
	 */
	function update_cat_order($in)
	{
		return "UPDATE `{$this->prefix}category`
				SET `order` = '{$in[1]}'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Delete a forum
	 *
	 * @param int $forumid
	 * @return string query
	 */
	function delete_forum($in)
	{
		return "DELETE FROM `{$this->prefix}forum`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Get all forums on the board, by order
	 *
	 * @return string query
	 */
	function get_all_forums()
	{
		return "SELECT *
				FROM `{$this->prefix}forum`
				ORDER BY `order` ASC";
	}

	/**
	 * Move all topics and posts from a forum to another
	 *
	 * @param int $forumid sender forum
	 * @param int $target recipient forum
	 * @return string query
	 */
	function move_forum_contents($in)
	{
		return "UPDATE `{$this->prefix}topic`
				SET `forum` = '{$in[1]}'
				WHERE `forum` = '{$in[0]}'";
	}

	/**
	 * Get number of topics from category
	 *
	 * @param int $cat_id
	 * @return string query
	 */
	function get_cat_topics($in)
	{
		return "SELECT COUNT(*) AS `topics`
				FROM `{$this->prefix}topic`
				WHERE `cat` = '{$in[0]}'";
	}

	/**
	 * Move all topics from a category to another
	 *
	 * @param int $catid
	 * @param int $target_cat
	 * @return string query
	 */
	function move_category_topics($in)
	{
		return "UPDATE `{$this->prefix}topic`
				SET `cat` = '{$in[1]}'
				WHERE `cat` = '{$in[0]}'";
	}

	/**
	 * Move all forums from a category to another
	 *
	 * @param int $catid
	 * @param int $target_cat
	 * @return string query
	 */
	function move_category_forums($in)
	{
		return "UPDATE `{$this->prefix}forum`
				SET `cat` = '{$in[1]}'
				WHERE `cat` = '{$in[0]}'";
	}

	/**
	 * Delete a category. Run delete_category_forums() as well, to avoid
	 * orphaned/disconnected forums.
	 *
	 * @param int $catid
	 * @return string query
	 */
	function delete_category($in)
	{
		return "DELETE FROM `{$this->prefix}category`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Delete all forums in a category. Make sure to run this when you run
	 * delete_category(), or you will end up with orphaned forums.
	 *
	 * @param int $catid
	 * @return string query
	 */
	function delete_category_forums($in)
	{
		return "DELETE FROM `{$this->prefix}forum`
				WHERE `cat` = '{$in[0]}'";
	}

	/**
	 * Get all topics in a specified forum
	 *
	 * @param int $forumid
	 * @return string query
	 */
	function get_all_topics_in_forum($in)
	{
		return "SELECT `id`
				FROM `{$this->prefix}topic`
				WHERE `forum` = '{$in[0]}'";
	}

	/**
	 * Deletes all posts in a specified topic
	 *
	 * @param int $topic_id
	 * @return string query
	 */
	function delete_posts_in_topic($in)
	{
		return "DELETE FROM `{$this->prefix}post`
				WHERE `tid` = '{$in[0]}'";
	}

	/**
	 * Delete a topic. Do NOT delete a topic without deleting the contained
	 * posts as well! We don't want any orphans!
	 *
	 * @param int $topic_id
	 * @return string query
	 */
	function delete_topic($in)
	{
		return "DELETE FROM `{$this->prefix}topic`
				WHERE `id` = '{$in[0]}'";
	}







	/**
	 * Returns a spesific help topic specified by $location
	 *
	 * @param string $location
	 * @access public
	 * @return string
	 */
	function get_help_topics($in)
	{
		return "SELECT *
				FROM `{$this->prefix}help`
				WHERE `location` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Updates help topics (topic $in) with new data
	 *
	 * @param in array (0 = location, 1= content)
	 * @access public
	 * @return string
	 */
	function update_help_topics($in)
	{
		return "UPDATE `{$this->prefix}help`
				SET `content` = '{$in[1]}'
				WHERE `location` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * returns query to get all template categories
	 * @access public
	 * @return string
	 */
	function get_template_categories()
	{
		return "SELECT *
				FROM `{$this->prefix}template_category`
				ORDER BY `id` ASC";
	}

	/**
	 * returns query to get ALL templates
	 *
	 * @access public
	 * @return string
	 */
	function get_templates()
	{
		return "SELECT *
				FROM `{$this->prefix}template`
				ORDER BY `id` ASC";
	}

	/**
	 * returns query to get templates in sets and categories
	 *
	 * @param array $in (0 = int category, 1 = int set_id)
	 * @access public
	 * @return string
	 */
	function get_templates_in_set_and_cat($in) {
		return "SELECT *
				FROM `{$this->prefix}template`
				WHERE `cat` = '{$in[0]}'
					AND `set_id` = '{$in[1]}'
				ORDER BY `name` ASC";
	}

	/**
	 * Returns query to get all fields about a spesific template from db
	 *
	 * @param array $in (0 = int templateID)
	 * @access public
	 * @return string
	 */
	function get_template_from_id($in) {
		return "SELECT *
				FROM `{$this->prefix}template`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Returns query to update a template with new data to DB
	 *
	 * @param array $in (0 = int id, 1 = string html code, 2 = int category)
	 * @access public
	 * @return string
	 */
	function update_template_code($in)
	{
		return "UPDATE `{$this->prefix}template`
				SET set_id = '{$in[4]}', name = '{$in[2]}', nice_name = '{$in[1]}', cat = '{$in[3]}'
				WHERE `id` = '{$in[0]}' LIMIT 1";
	}


	/**
	 * Admin CP - Backup
	 */


	// Return a list of all databse tables
	function get_tables()
	{
		return "SHOW TABLES LIKE '{$this->prefix}%'";
	}

	/**
	 * Returns SQL for how a table should be created
	 *
	 * @param string $table_name Table name, including prefix
	 * @return string query
	 */
	function get_create_sql($in)
	{
		return "SHOW CREATE TABLE {$in[0]}";
	}

	/**
	 * Get absolutely everything from a table
	 *
	 * @param string $table_name Table name, including prefix
	 * @return string query
	 */
	function get_everything_from_table($in)
	{
		return "SELECT *
				FROM {$in[0]}";
	}

	/**
	 * Get table structure from a table
	 *
	 * @param string $table_name Table name, including prefix
	 * @return string query
	 */
	function get_table_structure($in)
	{
		return "SHOW COLUMNS FROM {$in[0]}";
	}

	/**
	 * Admin CP - Word cencor
	 */

	/**
	 * Get the bloddymothafucking bad words
	 *
	 * @return string query
	 */
	function get_badwords()
	{
		return "SELECT *
				FROM `{$this->prefix}badword`";
	}

	/**
	 * Remove a badword
	 *
	 * @param int $id Badword id
	 * @return string query
	 */
	function delete_badword($in)
	{
		return "DELETE FROM `{$this->prefix}badword`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Add a bad word
	 *
	 * @param string $before Uncencored word
	 * @param string $after Word to replace with
	 * @return string query
	 */
	function add_badword($in)
	{
		return "INSERT INTO `{$this->prefix}badword` (name, nname)
				VALUES ('{$in[0]}', '{$in[1]}')";
	}

	/**
	 * Admin CP - Language
	 */

	/**
	 * Get all available languages
	 *
	 * @return string query
	 */
	function get_languages()
	{
		return "SELECT *
				FROM `{$this->prefix}languages`
				ORDER BY `language` ASC";
	}


	/**
	 * Adds a new template to the database
	 *
	 * @return String query
	 */
	function add_template_tag($in) {
		return "INSERT INTO {$this->prefix}template (set_id, name, nice_name, cat)
				VALUES ('{$in[0]}', '{$in[1]}', '{$in[2]}', '{$in[3]}')";
	}

	/**
	 * Get announcements
	 */
	function get_announcements($in)
	{
		return "SELECT `id`, `title`, `message`, `start`, `end`, `importance`, `groups`
				FROM `{$this->prefix}announcements`
				WHERE `end` > '{$in[2]}'
				LIMIT {$in[0]}, {$in[1]}";
	}

	/**
	 * Add new announcement
	 */
	function add_announcement($in)
	{
		return "INSERT INTO `{$this->prefix}announcements`
					(`title`, `message`, `start`, `end`, `importance`, `groups`)
				VALUES ('{$in[0]}', '{$in[1]}', '{$in[2]}',
					'{$in[3]}', '{$in[4]}', '{$in[5]}')";
	}

	/**
	 * Update announcement
	 */
	function update_announcement($in)
	{
		return "UPDATE `{$this->prefix}announcements`
				SET `title` = '{$in[0]}', `message` = '{$in[1]}', `start` = '{$in[2]}',
					`end` = '{$in[3]}', `importance` = '{$in[4]}', `groups` = '{$in[5]}'
				WHERE `id` = '{$in[6]}'
				LIMIT 1";
	}

	/**
	 * Delete announcement
	 */
	function delete_announcement($in)
	{
		return "DELETE FROM `{$this->prefix}announcements`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	function get_groups()
	{
		return "SELECT `id`, `g_name` AS `name`
				FROM `{$this->prefix}groups`";
	}

	function get_all_group_ids()
	{
		return "SELECT `id`
				FROM `{$this->prefix}groups`";
	}


	/**
	 * Site Config
	 */

	/**
	 * Get sites
	 *
	 * Get all registered sites on the board
	 *
	 */
	function get_sites()
	{
		return "SELECT * FROM `{$this->prefix}config` ORDER BY `id` ASC";
	}

	/**
	 * Create a site
	 *
	 * @param string name
	 * @param string url
	 * @param string host
	 * @param string pass_seed
	 * @return array (2 queries)
	 */
	function create_new_site($in)
	{
		$q[] = "INSERT INTO `{$this->prefix}config` (`forum_name`, `forum_url`, `site_host`, `pw_seed`)
                              VALUES ('{$in[0]}', '{$in[1]}', '{$in[2]}', '{$in[3]}')";

		$q[] = "SELECT `id` FROM `{$this->prefix}config` ORDER BY `id` DESC LIMIT 1";

		return $q;
	}

	/**
	 * Update site
	 *
	 * Update the settings and properties of a forum site
	 *
	 * @param int $id
	 * @param string $forum_name
	 * @param string $forum_url
	 * @param string $forum_email
	 * @param string $site_homepage
	 * @param string $site_host
	 * @param int $def_tpl
	 * @param int $def_cat
	 * @param int $def_lang
	 * @param int $active
	 * @param int $imgcat
	 * @param int $show_maxtopics
	 * @param int $show_maxposts
	 * @param int $prune_topics
	 * @param string $timestamp1
	 * @param string $timestamp2
	 * @return string Query
	 *
	 */
	function update_site($in)
	{
		return "UPDATE `{$this->prefix}config`
				SET `forum_name`	= '{$in[1]}',
					`forum_url`		= '{$in[2]}',
					`forum_email`	= '{$in[3]}',
					`site_homepage`	= '{$in[4]}',
					`site_host`		= '{$in[5]}',
					`def_tpl`		= '{$in[6]}',
					`def_cat`		= '{$in[7]}',
					`def_lang`		= '{$in[8]}',
					`active`		= '{$in[9]}',
					`show_maxtopics`= '{$in[10]}',
					`show_maxposts`	= '{$in[11]}',
					`prune_topics`	= '{$in[12]}',
					`timestamp1`	= '{$in[13]}',
					`timestamp2`	= '{$in[14]}'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Get total number of sites installed
	 *
	 * @return string Query
	 */
	function count_sites()
	{
		return "SELECT COUNT(*) AS `number` FROM `{$this->prefix}config`";
	}

	/**
	 * Delete a site
	 *
	 * @param int $site
	 * @return string Query
	 */
	function delete_site($in)
	{
		return "DELETE FROM `{$this->prefix}config` WHERE `id` = '{$in[0]}' LIMIT 1";
	}

	/**
	 * POST REPORTS
	 */

	/**
	 * Get reported posts
	 *
	 * @param string WHERE
	 * @return object database
	 */
	function get_reported_posts($in)
	{
		return "SELECT r.`id` AS report_id, r.`uid` AS reportee_id, r.`pid` AS post_id, r.`time`, r.`status`,
					t.`id` AS thread_id, t.`title` AS thread_title, p.`tid`, p.`author_id`, p.`author_name`, m.`name` as reportee_name
					FROM `{$this->prefix}reported` r, `{$this->prefix}post` p, `{$this->prefix}topic` t, `{$this->prefix}member` m
					WHERE {$in[0]} t.`id` = p.`tid` AND p.`id` = r.`pid` AND m.`id` = r.`uid` GROUP BY r.`id` DESC";
	}

	/**
	 * Update report status
	 *
	 * @param int id
	 * @param int status
	 */
	function update_report_status($in)
	{
		return "UPDATE `{$this->prefix}reported` SET `status` = '{$in[1]}' WHERE `id` = '{$in[0]}' LIMIT 1";
	}

	/**
	 * Get reported post
	 *
	 * @param int post_id
	 */
	function get_reported_post($in)
	{
		return "SELECT r.`id`, r.`uid`, r.`pid`, r.`time`, r.`status`, r.`message`, r.`comment`, p.`tid`,
					t.`title`, p.`author_name`, m.`id`, m.`name` AS reportee_name
					FROM `{$this->prefix}reported` r, `{$this->prefix}post` p, `{$this->prefix}member` m, `{$this->prefix}topic` t
					WHERE r.`id` = '{$in[0]}' AND p.`id` = r.`pid` AND m.`id` = r.`uid` AND t.`id` = p.`tid` LIMIT 1";
	}

	/**
	 * Update reported post
	 *
	 * @param int id
	 * @param int status
	 * @param string comment
	 */
	function update_reported_post($in)
	{
		return "UPDATE `{$this->prefix}reported` SET `status` = '{$in[1]}', `comment` = '{$in[2]}' WHERE `id` = '{$in[0]}' LIMIT 1";
	}

	/**
	 * Admin CP - User management
	 */

	/**
	 * Unban user
	 *
	 * @param int $id
	 */
	function unban($in)
	{
		return "UPDATE `{$this->prefix}member` SET `group` = '3' WHERE `id` = '{$in[0]}' LIMIT 1";
	}

	/**
	 * Get all banned users
	 *
	 */
	function get_banlist()
	{
		return "SELECT `name`, `id` FROM `{$this->prefix}member` WHERE `group` = '4'";
	}

	/**
	 * Ban user
	 *
	 * @param int $id
	 */
	function ban_user($in)
	{
		return "UPDATE `{$this->prefix}member` SET `group` = '4' WHERE `id` = '{$in[0]}' LIMIT 1";
	}

	/**
	 * Get user based on userid
	 *
	 * @param int $id
	 */
	function select_user_from_id($in)
	{
		return "SELECT * FROM `{$this->prefix}member` WHERE `id` = '{$in[0]}' LIMIT 1";
	}

	/**
	 * Get user based on username
	 *
	 * @param string $username
	 */
	function select_user_from_name($in)
	{
		return "SELECT * FROM `{$this->prefix}member` WHERE `name` = '{$in[0]}' LIMIT 1";
	}

	/**
	 * Delete the user from the system (not undoable)
	 *
	 * @param int $id
	 */
	function drop_user_from_id($in)
	{
		// Delete from both member tables
		$q[] = "DELETE FROM `{$this->prefix}member` WHERE `id` = '{$in[0]}' LIMIT 1";

		$q[] = "DELETE FROM `{$this->prefix}member_extra` WHERE `mid` = '{$in[0]}' LIMIT 1";

		// And reduce overall user number
		$q[] = "UPDATE `{$this->prefix}stats` SET `total_users` = `total_users` - 1 LIMIT 1";

		return $q;
	}

	/**
	 * Is the adress in use?
	 *
	 * To see if somebody is using the email adress already
	 *
	 * @param string $email
	 */
	function email_in_use($in)
	{
		return "SELECT `id` FROM `{$this->prefix}member` WHERE `email` = '{$in[0]}' LIMIT 1";
	}

	/**
	 * Is the username in use?
	 *
	 * We don't want users with overlapping names, do we?
	 *
	 * @param string $username
	 */
	function username_in_use($in)
	{
		return "SELECT `id` FROM `{$this->prefix}member` WHERE `name` = '{$in[0]}' LIMIT 1";
	}


    /**
     * Update user info
     *	$id
	 *	$name
	 *	$email
	 *	$title
	 *	$group
	 *	$language
	 *	$template
	 *	$avatar
	 *	$location
	 *	$homepage
	 *	$real_name
	 *	$birthday
	 *	$im_network
	 *	$interests
	 *	$signature
	 *	$use_smileys
	 *	$use_signature
     */
    function update_user($in)
	{
		return "UPDATE `{$this->prefix}member`
				SET `name`			=	'{$in[1]}',
					`email`			=	'{$in[2]}',
					`title`			=	'{$in[3]}',
					`group`			=	'{$in[4]}',
					`lang`			=	'{$in[5]}',
					`skin_set`		=	'{$in[6]}',
					`avatar`		=	'{$in[7]}',
					`location`		=	'{$in[8]}',
					`homepage`		=	'{$in[9]}',
					`real_name`		=	'{$in[10]}',
					`birthday`		=	'{$in[11]}',
					`im_networks`	=	'{$in[12]}',
					`interests`		=	'{$in[13]}',
					`signature`		=	'{$in[14]}',
					`use_smiley`	=	'{$in[15]}',
					`use_sig`		=	'{$in[16]}'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	function update_user_password($in)
	{
		return "UPDATE `{$this->prefix}member`
				SET `password` = '{$in[1]}'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Update global stats
	 *
	 * @param string $type Type of stat to update (any of "topics", "posts" or "users)
	 */
	function update_global_stats($in)
	{
		switch ($in[0])
		{
			case 'topics':
				return "UPDATE `{$this->prefix}stats` SET `total_topics` = (`total_topics` + 1) LIMIT 1";
			break;

			case 'posts':
				return "UPDATE `{$this->prefix}stats` SET `total_posts` = (`total_posts` + 1) LIMIT 1";
			break;

			case 'users':
				return "UPDATE `{$this->prefix}stats` SET `total_users` = (`total_users` + 1) LIMIT 1";
			break;
		}
	}

	/**
	 * Insert new user data
	 *
	 * @param string username
	 * @param string password
	 * @param string email
	 * @param int group
	 */
	function insert_new_user_data($in)
	{
		return "INSERT INTO
					{$this->prefix}member
					(`name`, `password`, `email`, `registered`, `group`)
				VALUES
					('{$in[0]}', '{$in[1]}', '{$in[2]}', '" . time() . "', '{$in[3]}')";
	}

	/**
	 * Finding the newest ID/name in the member table
	 *
	 */
	function get_latest_user()
	{
		return "SELECT `id`, `name` FROM `{$this->prefix}member` ORDER BY `id` DESC LIMIT 1";
	}

	/**
	 * Putting the user into the member_extra table as well
	 *
	 * @param int $user_id
	 */
	function insert_extra_user_data($in)
	{
		return "INSERT INTO `{$this->prefix}member_extra` (`mid`) VALUES ('{$in[0]}')";
	}

	/**
	 * Get userid from username
	 *
	 * @param string $name
	 */
	function get_id_from_name($in)
	{
		return "SELECT `id` FROM `{$this->prefix}member` WHERE `name` = '{$in[0]}' LIMIT 1";
	}

	/**
	 * Run a custom select query
	 *
	 * @param string $name
	 * @param string $table
	 * @param string $order
	 */
    function select_get($in)
    {
		return "SELECT * FROM `{$this->prefix}{$in[1]}` ORDER BY `{$in[0]}` {$in[2]}";
    }


	/**
	 * Admin CP - BBCodes
	 */

	/**
	 * Get all active BBCodes
	 *
	 */
	function get_bbcodes()
	{
		return "SELECT * FROM `{$this->prefix}parse_rules` ORDER BY `id` ASC";
	}

	/**
	 * Get one BBCode/parse rule in particular
	 *
	 * @param int $id
	 */
	function get_bbcode($in)
	{
		return "SELECT * FROM `{$this->prefix}parse_rules` WHERE `id` = '{$in[0]}' ORDER BY `id` ASC";
	}

	/**
	 * Save a modified BBCode/parse rule
	 *
	 * @param int $id
	 * @param string $descr
	 * @param string $find
	 * @param string $replace
	 */
	function save_bbcode($in)
	{
		return "UPDATE `{$this->prefix}parse_rules` SET `descr` = '{$in[1]}', `find` = '{$in[2]}', `replace` = '{$in[3]}' WHERE `id` = '{$in[0]}' LIMIT 1";
	}

	/**
	 * Add a new BBCode/parse rule to the DB
	 *
	 * @param string $descr
	 * @param string $find
	 * @param string $replace
	 */
	function add_bbcode($in)
	{
		return "INSERT INTO `{$this->prefix}parse_rules` (`descr`, `find`, `replace`) VALUES ('{$in[0]}', '{$in[1]}', '{$in[2]}')";
	}
	/**
	 * Remove a BBCode/parse rule from the DB
	 *
	 * @param int $userid
	 */
	function delete_bbcode($in)
	{
		return "DELETE FROM `{$this->prefix}parse_rules` WHERE `id` = '{$in[0]}' LIMIT 1";
	}

	/**
	 * Admin CP - Task log
	 */

	/**
	 * Fetch $max log entries from the task log
	 *
	 * @param int $max
	 */
	function get_task_log($in)
	{
		return "SELECT `time`, `ip`, `task` FROM `{$this->prefix}log_tasks` ORDER BY `time` DESC LIMIT 0,{$in[0]}";
	}
}

?>
