<?php

/**
 * MySQL file for cp.php
 *
 * @package Vikingboard
 * @version 0.2.0
 * $Id: sql_MySQL_cp.php 1727 2007-10-18 19:56:31Z jorgenboard $
 */

class sql extends SQLGlobal
{
	/**
	 * SQL class constructor
	 *
	 */
	function sql($prefix)
	{

		$this->prefix	=	$prefix;
	}

	/**
	 * Get number of unread messages in inbox
	 *
	 * @param int $user_id
	 */
	function get_new_messages_inbox($in)
	{
		return "SELECT COUNT(p.`id`) `number`
				FROM `{$this->prefix}pm` p
				WHERE p.`belongs_to` = '{$in[0]}'
					AND p.`fid` = '1'
					AND p.`read` = '0'";
	}

	// Fetching profile data
	function get_profile_data($in)
	{
		return "SELECT `id`, `name`, `email`, `signature`, `avatar`,
					`posts`, `registered`, `location`, `interests`, `homepage`,
					`blog`, `real_name`, `birthday`, `user_photo`, `title`
				FROM `{$this->prefix}member`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	// Gets the avatar and member photo info
	function get_user_avatar($in)
	{
		return "SELECT `avatar`, `user_photo`
				FROM `{$this->prefix}member`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	// Gets the signature info
	function get_user_signature($in)
	{
		return "SELECT `signature`
				FROM `{$this->prefix}member`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	// Updating profile data
	function update_profile_data($in)
	{
		return "UPDATE `{$this->prefix}member`
				SET `homepage` = '{$in[1]}', `blog` = '{$in[2]}', `real_name` = '{$in[3]}',
					`im_msn` = '{$in[4]}', `birthday` = '{$in[5]}',
					`location` = '{$in[6]}', `interests` = '{$in[7]}'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	// Updating a users signature
	function update_user_signature($in)
	{
		return "UPDATE `{$this->prefix}member`
				SET `signature` = '{$in[1]}'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	// Updating a users avatar
	function update_user_avatar($in)
	{
		return "UPDATE `{$this->prefix}member`
				SET `avatar` = '{$in[1]}'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Finding out how many messages a user got in his inbox
	 *
	 * @param int $user_id
	 */
	function get_num_messages_folder($in)
	{
		return "SELECT COUNT(p.`id`) AS `number`
				FROM `{$this->prefix}pm` p
				WHERE p.`belongs_to` = '{$in[0]}'
					AND p.`fid` = '{$in[1]}'";
	}

	/**
	 * Getting the messages from the inbox
	 *
	 * @param int $to
	 */
	function get_messages_folder($in)
	{
		return "SELECT *
				FROM `{$this->prefix}pm` p
				WHERE p.`belongs_to` = '{$in[0]}'
					AND p.`fid` = '{$in[1]}'
				ORDER BY 'id' DESC";
	}

	/**
	 * Get folder info
	 *
	 * @param int $folder_id
	 */
	function get_folder_info($in)
	{
		return "SELECT * FROM `{$this->prefix}pm_folders` p
				WHERE p.`fid` = '{$in[0]}' LIMIT 1";
	}

	/**
	 * Insert a new PM Folder
	 *
	 * @param string $name
	 * @param int $uid
	 */
	function insert_new_folder($in)
	{
		return "INSERT
					INTO `{$this->prefix}pm_folders`
				VALUES
					('', '{$in[0]}', '{$in[1]}')";
	}

	//Getting the user config for sending a pm (show smileys, signature, etc)
	function get_user_choices($in)
	{
		return "SELECT `posts`, `use_smiley`, `use_sig`
				FROM `{$this->prefix}member`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Can we read this PM?
	 *
	 * @param int $pm_id
	 * @param int $userid
	 */
	function can_read_pm($in)
	{
		return "SELECT d.`author_id`, d.`content`, d.`date`, p.`title`, p.`belongs_to`
				FROM `{$this->prefix}pm_data` d, `{$this->prefix}pm` p
				WHERE d.`id` = p.`msg_id`
					AND d.`id` = '{$in[0]}'
					AND p.`belongs_to` = '{$in[1]}'
				LIMIT 1";
	}

	/**
	 * Remove forum subscriptions
	 *
	 * Removes selected forum subscriptions
	 * @param int userid
	 * @param string forums
	 */
	function remove_forum_subscriptions($in)
	{
		return "DELETE FROM
					`{$this->prefix}subscr_forum`
				WHERE
					`uid` = '{$in[0]}'
				AND
					`fid` IN({$in[1]})";
	}

	/**
	 * Get forum subscriptions
	 *
	 * Gets all the forums a user subscribes to
	 * @param int userid
	 */
	function get_forum_subscriptions($in)
	{
		return "SELECT `fid`
				FROM `{$this->prefix}subscr_forum`
				WHERE `uid` = '{$in[0]}'
				ORDER BY `id` DESC";
	}

	/**
	 * Get forum subscription info
	 *
	 * @param int forumid
	 */
	function get_forum_subscr_info($in)
	{
		return "SELECT `id`, `name`, `cat`, `lpost_title`, `lpost_tid`,
					`lpost_pid`, `lpost_uid`, `lpost_time`, `lpost_name`,
					`stat_threads`, `stat_posts`
				FROM `{$this->prefix}forum`
				WHERE `id` ='{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Are we allowed to recall this PM?
	 *
	 * @param int $pm_id
	 * @param int $userid
	 */
	function allowed_to_recall_pm($in)
	{
		return "SELECT `trace`
				FROM `{$this->prefix}pm`
				WHERE `from_id` = '{$in[1]}'
					AND `id` = '{$in[0]}'
					AND `read` = '0'";
	}

	/**
	 * Let's remove this PM (in unread state) from the recipients mailbox
	 *
	 * @param int $pm_id
	 */
	function recall_pm($in)
	{
		return "DELETE FROM `{$this->prefix}pm`
				WHERE `id` = '{$in[0]}'";
	}

	/**
	 * Get the traced PMs
	 *
	 * @param int $user_id
	 */
	function get_traced_pms($in)
	{
		return "SELECT *
				FROM `{$this->prefix}pm` p
				WHERE p.`from_id` = '{$in[0]}'
					AND p.`trace` = '1'
					AND p.`belongs_to` != '{$in[0]}'
				ORDER BY p.`date`";
	}

	/**
	 * Are we allowed to read it?
	 *
	 * @param int $pm_id
	 * @param int $userid
	 */
	function allowed_to_read_pm($in)
	{
		return "SELECT `belongs_to`
				FROM `{$this->prefix}pm`
				WHERE `id` = '{$in[0]}'
					AND `belongs_to` = '{$in[1]}'";
	}

	/**
	 * Deletes a PM
	 *
	 * @param int $pm_id
	 */
	function delete_pm($in)
	{
		return "DELETE FROM `{$this->prefix}pm`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Decrease the pm count for a user
	 *
	 * @param int $uid
	 */
	function update_pm_count($in)
	{
		return "UPDATE `{$this->prefix}member`
				SET `new_pms` = (`new_pms` - '1')
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Move PM to archive
	 *
	 * @param int $pm_in
	 */
	function move_pm_to_archive($in)
	{
		return "UPDATE `{$this->prefix}pm` SET `fid` = '4' WHERE `id` = '{$in[0]}' LIMIT 1";
	}

	/**
	 * Marks a pm with read flag
	 *
	 * @param int $pm_id
	 */
	function mark_pm_as_read($in)
	{
		return "UPDATE `{$this->prefix}pm`
				SET `read` = '1'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Marks a pm as unread
	 *
	 * @param int $pm_id
	 */
	function mark_pm_unread($in)
	{
		return "UPDATE `{$this->prefix}pm`
				SET `read` = '0'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Insert PM data
	 *
	 * @param string $message
	 * @param string $date
	 * @param int $author_id
	 * @param string $cc_to
	 */
	function create_new_pm_data($in)
	{
		return "INSERT INTO `{$this->prefix}pm_data` (`date`, `content`, `author_id`, `cc_to`)
				VALUES ('{$in[1]}', '{$in[0]}', '{$in[2]}', '{$in[3]}')";
	}

	/**
	 * Constructs a new PM object. Does not notify.
	 *
	 * @param int $msg_id
	 * @param string $title
	 * @param int $from_id
	 * @param int $to_id
	 * @param string $in_folder
	 * @param int $trace
	 * @param int $belongs_to
	 */
	function create_new_pm($in)
	{
		return "INSERT INTO `{$this->prefix}pm`
				VALUES ('', '{$in[0]}', '{$in[2]}', '{$in[1]}', '{$in[3]}',
					'{$in[4]}', '{$in[5]}', '0', 'NULL', '0', '{$in[6]}', '{$in[7]}')";
	}

	/**
	 * Update the new pm count for the recipient,
	 * and display a notification
	 *
	 * @param int $to_id
	 */
	function update_new_pm($in)
	{
		return "UPDATE `{$this->prefix}member`
				SET `new_pms` = (`new_pms` + '1'), `done_pmpopup` = '0'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Lower the new pm count, when something
	 * has been read
	 *
	 * @param int $uid
	 */
	function reduce_new_pm($in)
	{
		return "UPDATE `{$this->prefix}member`
				SET `new_pms` = (`new_pms` - '1')
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Fetch a single PM
	 *
	 * @param int $pm_id
	 */
	function get_pm_content($in)
	{
		return "SELECT *
				FROM `{$this->prefix}pm_data` pm
				LEFT JOIN `{$this->prefix}pm` p ON pm.`id` = p.`msg_id`
				WHERE p.`id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Getting some user info for use in PM view
	 *
	 * @param int $user_id
	 */
	function get_user_stuff($in)
	{
		return "SELECT `signature`, `avatar`, `registered`, `location`,
					`posts`, `name`, `title`
				FROM `{$this->prefix}member`
				WHERE `id` ='{$in[0]}'
				LIMIT 1";
	}

	/**
	 * We've read this, move along!
	 *
	 * @param int $pm_id
	 * @param int $date
	 */
	function mark_pm_read($in)
	{
		return "UPDATE `{$this->prefix}pm`
				SET `really_read` = '1', `read_date` = '{$in[1]}', `read` = '1'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}


	// --------------------+
	// Topic subscriptions |
	// --------------------+


	/**
	 * Get topic subscriptions
	 *
	 * @param int user
	 */
	function get_topic_subscriptions($in)
	{
		return "SELECT `tid`
				FROM `{$this->prefix}subscr_topic`
				WHERE `uid` = '{$in[0]}'";
	}

	/**
	 * Get topic subscription info
	 *
	 * @param int topic_id
	 */
	function get_topic_subscr_info($in)
	{
		return "SELECT t.`id`, t.`title`, f.`lpost_pid`, f.`lpost_uid`,
					f.`lpost_name`, f.`lpost_time`, t.`replies`, t.`views`, c.`id`
				FROM `{$this->prefix}topic` t, `{$this->prefix}forum` f, `{$this->prefix}category` c
				WHERE t.`id` ='{$in[0]}'
					AND f.`id` = t.`forum`
					AND f.`cat` = c.`id`
				LIMIT 1";
	}

	/**
	 * Remove topic subscriptions
	 *
	 * Removes selected topic subscriptions
	 * @param int userid
	 * @param array topics
	 */
	function remove_topic_subscriptions($in)
	{
		// Start making the query
		$query	=	"DELETE FROM `{$this->prefix}subscr_topic`
					WHERE `uid` = '{$in[0]}'
						AND `tid` = ";

		$i	=	0;
		foreach ($in[1] as $topic)
		{
			// First topic
			if($i == 0)
			{
				$query	.=	$topic;
				$i++;
			}
			// The other topics
			else
			{
				$query	.=	" OR " . $topic;
			}
		}

		return $query;
	}

	//-----------------+
	// Forum settings  |
	//-----------------+

	/**
	 * Get forum themes
	 *
	 * Get all active forum themes
	 *
	 */
	function get_forum_themes()
	{
		return "SELECT `id`, `name` FROM `{$this->prefix}template_sets` WHERE `active` = '1'";
	}

	/**
	 * Get forum languages
	 *
	 * Get all available forum languages
	 *
	 */
	function get_forum_languages()
	{
		return "SELECT `id`, `language` FROM `{$this->prefix}languages`";
	}

	/**
	 * Update user settings
	 *
	 * Save user preferences (lang, theme etc)
	 *
	 * @param int $lang
	 * @param int $theme
	 * @param int $user_id
	 */
	function update_user_settings($in)
	{
		return "UPDATE `{$this->prefix}member` SET `lang` = '{$in[0]}', `skin_set` = '{$in[1]}' WHERE `id` = '{$in[2]}' LIMIT 1";
	}
}

?>