<?php
/**
 * Global MySQL file
 *
 * @package Vikingboard
 * @version 0.2.0
 * @copyright Copyright (c) 2004-2007 The Vikingboard Project
 * @license GPL {@link http://www.gnu.org/licenses/gpl.html}
 * @link http://vikingboard.com/
 *
 * $Id: sql_MySQL_global.php 1859 2007-11-27 18:59:28Z jorgenboard $
 *
 */

class SQLGlobal
{
	/**
	 * SQL class constructor
	 *
	 */
	function sql($prefix)
	{
		$this->prefix	=	$prefix;
	}


	//Run a custom SQL snippet
	function custom($in) {
		return $in[0];
	}

    //Removes guest sessions on a ip
    function remove_guest_sessions($in)
    {
        return "DELETE FROM `{$this->prefix}sessions` WHERE ip='{$in[0]}' AND uid=1";
    }

	//Get`s site forum configuration
	function get_forum_config()
	{
		return "SELECT *
				FROM `{$this->prefix}config`
				WHERE `site_host` = '{$_SERVER['HTTP_HOST']}'
				LIMIT 1";
	}

	//GET information about a session ID
	function get_user_info($in)
	{
		return "SELECT s.`uid`, s.`hide`, s.`time` AS `updateTime`, m.*, g.*
				FROM `{$this->prefix}sessions` s, `{$this->prefix}member` m, `{$this->prefix}groups` g
				WHERE s.`sid` = '{$in[0]}'
                    AND s.`ip` = '{$in[1]}'
					AND m.`id` = s.`uid`
					AND g.`id` = s.`group`
				LIMIT 1";
	}

    //Logging in a user :D (wooho, welcome DUDE :D)
    function update_loginuser($in)
    {
        return "UPDATE `{$this->prefix}sessions`
                SET `uid` = '{$in[0]}', `time` = '".forumtime()."', `stayin` = '{$in[4]}',
                    `hide` = '{$in[3]}', `ip` = '".$_SERVER['REMOTE_ADDR']."',
                    `user` = '{$in[2]}', `group` = '{$in[1]}'
                WHERE `sid` ='{$in[5]}'
                LIMIT 1";
    }

	/**
	 * Get last updated time
	 *
	 * Get the last time the user session was updated,
	 * to calculate (amongst other things) if the user
	 * is online.
	 *
	 * @param int $user_id
	 * @return string query
	 */
	function get_last_update($in)
	{
		return "SELECT s.`time`
				FROM `{$this->prefix}sessions` s
				WHERE s.`uid` = '{$in[0]}'
				ORDER BY s.`time` DESC
				LIMIT 1";
	}

	//Inserts a session to the sessions table
	function session_inserter($in)
	{
		return "INSERT INTO `{$this->prefix}sessions` (`sid`, `uid`, `time`, `ip`)
				VALUES ('{$in[0]}', '1', '".forumtime()."', '{$in[1]}')";

	}

	//Updates a session to the sessions table
	function session_updater($in)
	{
		return "UPDATE `{$this->prefix}sessions`
				SET `time` = '".forumtime()."', `ip` = '{$in[1]}'
				WHERE `sid` = '{$in[0]}'
				LIMIT 1";
	}

	//Getting the user that is logging in
	function get_info_about_user_logging_in($in)
	{
		return "SELECT `id`, `name`, `group`
				FROM `{$this->prefix}member`
				WHERE `password` = '{$in[0]}'
					AND `name` = '{$in[1]}'
				LIMIT 1";
	}

	// Getting smileys :D :woot: :blush: :wee: :mad: :tomanysmileys: :RTFM: :lol:
	function get_smileys()
	{
		return "SELECT `id`, `name`, `url`, `code`, `set_id`
				FROM `{$this->prefix}smiley`
				WHERE `show` = '1' ORDER BY `id` ASC";
	}

	// Getting the bloddymothafucking bad words
	function get_badwords()
	{
		return "SELECT *
				FROM `{$this->prefix}badword`";
	}

	// get username from userid
	function get_username_from_id($in)
	{
		return "SELECT `name`
				FROM `{$this->prefix}member`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	// Getting a users id from the username
	function get_userid_from_name($in)
	{
		return "SELECT `id`
				FROM `{$this->prefix}member`
				WHERE `name` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Adds the file information to the database/filesystem
	 *
	 * @param string $filename
	 * @param string $type
	 * @param int $size
	 * @param string $rnd_name
	 * @param int $uid
	 * @param int $type
	 */
	function add_file_info($in)
	{
		return "INSERT INTO `{$this->prefix}files` (`id`, `name`, `mime`, `size`, `filename`, `uid`, `type`)
				VALUES ('', '{$in[0]}', '{$in[1]}', '{$in[2]}', '{$in[3]}', '{$in[4]}', '{$in[5]}')";
	}

	/**
	 * Get all info you need for a file download
	 *
	 * @param int $id
	 */
	function get_file($in)
	{
		return "SELECT *
				FROM `{$this->prefix}files`
				WHERE `id` = '{$in[0]}'";
	}

	/**
	 * Emailer functions
	 */

	/**
	 * Get the users mail info from user id
	 *
	 * Getting some information based om member id that is used in the
	 * emailer
	 *
	 * @param int $user_id
	 */
	function get_users_mailinfo_from_id($in)
	{
		return "SELECT `name`, `email`, `lang`
				FROM `{$this->prefix}member`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Save problem email
	 *
	 * Stores a email that could not be sendt in the DB
	 *
	 * @param string $to
	 * @param string $title
	 * @param string $headers
	 * @param string $mail
	 */
	function save_problem_email($in)
	{
		return "INSERT INTO `{$this->prefix}mail_queue` (to_email, title, message, headers)
				VALUES ('{$in[0]}', '{$in[1]}', '{$in[3]}', '{$in[2]}')";
	}

	/**
	 * Updates time spent on the boad statistics
	 *
	 * @param array $in[0] int userID
	 * @param array $in[1] int seconds to add to current timer
	 */
	function update_time_online($in)
	{
			return "UPDATE `{$this->prefix}member_extra`
					SET `time_online` = `time_online` + '{$in[1]}'
					WHERE `mid` = '{$in[0]}'
					LIMIT 1";
	}

	/**
	 * Get all parse rules for the post-parser
	 *
	 */
	function get_parse_rules()
	{
		return "SELECT *
				FROM `{$this->prefix}parse_rules`";
	}

	/**
	 * Get post info for the post parser
	 *
	 * @param int $postid
	 */
	function get_post_info($in)
	{
		return "SELECT `author_name`, `author_id`, `posted` FROM `{$this->prefix}post` WHERE `id` = '{$in[0]}' LIMIT 1";
	}

}

?>
