<?php

/**
 * MySQL file for members.php
 *
 * @package Vikingboard
 * @version 0.2.0
 * $Id: sql_MySQL_members.php 1820 2007-11-20 01:08:11Z jorgenboard $
 */

class sql extends SQLGlobal
{
	/**
	 * SQL class constructor, PHP4 style
	 *
	 */
	function sql($prefix)
	{
		$this->prefix	=	$prefix;
	}

	/**
	 * Get member list
	 *
	 * @param string 	$order
	 * @param string 	$desc
	 * @param int 		$showfrom
	 * @param int 		$total
	 */
	function get_member_list($in)
	{
		return "SELECT DISTINCT m.`id`, m.`name`, m.`posts`, m.`registered`, m.`title`, m.`group`, g.`g_name`
				FROM `{$this->prefix}member` m, `{$this->prefix}groups` g
				WHERE g.`id` = m.`group`
					AND m.`id` != '1'
				ORDER BY m.`{$in[0]}` {$in[1]}
				LIMIT {$in[2]}, {$in[3]}";
	}

	/**
	 * Get the list of online members
	 *
	 * @param int $cut_time Time since last request (in minutes) as cut time
	 * @param int forumtime()
	 * @param string $order
	 * @param string $desc/$asc
	 * @param int $show_from
	 * @param int $show_to
	 */
	function get_online_members_list($in)
	{
		return "SELECT DISTINCT m.`id`, m.`name`, s.`hide`, s.`time`, m.`posts`, m.`registered`, m.`title`, m.`group`, g.`g_name`
				FROM `{$this->prefix}member` m, `{$this->prefix}groups` g, `{$this->prefix}sessions` s
				WHERE g.`id` = m.`group`
					AND m.`id` != '1'
					AND s.`uid` = m.`id`
					AND s.`hide` != '1'
					AND (s.`time` + (({$in[0]} * 60) - {$in[1]})) > 0
				ORDER BY m.`{$in[2]}` {$in[3]}
				LIMIT {$in[4]}, {$in[5]}";
	}

	/**
	 * Get last visit time by userid
	 *
	 * @param int $id
	 */
	function get_member_status($in)
	{
		return "SELECT `time`
				FROM `{$this->prefix}sessions`
				WHERE `uid` = '{$in[0]}'
				ORDER BY `time` DESC
				LIMIT 1";
	}


	// Getting the total board stats
	function get_forum_stats()
	{
		return "SELECT *
				FROM `{$this->prefix}stats`
				LIMIT 1";
	}

	// Getting the number of users that have been online the last $in minutes
	function get_online_users($in)
	{
		return "SELECT COUNT(`sid`) as `users`
				FROM `{$this->prefix}sessions`
				WHERE `time` >= '{$in[0]}'";
	}
}

?>