<?php

/**
 * MySQL file for messages.php
 *
 * @package Vikingboard
 * @version 0.2.0
 * $Id$
 */

class sql extends SQLGlobal
{
	/**
	 * SQL class constructor
	 *
	 */
	function sql($prefix)
	{

		$this->prefix	=	$prefix;
	}

	/**
	 * Get number of unread messages in inbox
	 *
	 * @param int $user_id
	 */
	function get_new_messages_inbox($in)
	{
		return "SELECT COUNT(p.`id`) `number`
				FROM `{$this->prefix}pm` p
				WHERE p.`belongs_to` = '{$in[0]}'
					AND p.`fid` = '1'
					AND p.`read` = '0'";
	}

	/**
	 * Finding out how many messages a user got in his inbox
	 *
	 * @param int $user_id
	 */
	function get_num_messages_folder($in)
	{
		return "SELECT COUNT(p.`id`) AS `number`
				FROM `{$this->prefix}pm` p
				WHERE p.`belongs_to` = '{$in[0]}'
					AND p.`fid` = '{$in[1]}'";
	}

	/**
	 * Getting the messages from the inbox
	 *
	 * @param int $to
	 */
	function get_messages_folder($in)
	{
		return "SELECT *
				FROM `{$this->prefix}pm` p
				WHERE p.`belongs_to` = '{$in[0]}'
					AND p.`fid` = '{$in[1]}'
				ORDER BY `id` DESC";
	}

	/**
	 * Get folder info
	 *
	 * @param int $folder_id
	 */
	function get_folder_info($in)
	{
		return "SELECT * FROM `{$this->prefix}pm_folders` p
				WHERE p.`fid` = '{$in[0]}' LIMIT 1";
	}

	/**
	 * Insert a new message Folder
	 *
	 * @param string $name
	 * @param int $uid
	 */
	function insert_new_folder($in)
	{
		return "INSERT
					INTO `{$this->prefix}pm_folders`
				VALUES
					('', '{$in[0]}', '{$in[1]}')";
	}

	function get_folders($in)
	{
		return "SELECT `fid`, `name`
				FROM `{$this->prefix}pm_folders`
				WHERE `owner` = '{$in[0]}'";
	}

	/**
	 * Are we allowed to recall this message?
	 *
	 * @param int $pm_id
	 * @param int $userid
	 */
	function allowed_to_recall_message($in)
	{
		return "SELECT `trace`
				FROM `{$this->prefix}pm`
				WHERE `from_id` = '{$in[1]}'
					AND `id` = '{$in[0]}'
					AND `read` = '0'";
	}

	/**
	 * Let's remove this message (in unread state) from the recipients mailbox
	 *
	 * @param int $pm_id
	 */
	function recall_message($in)
	{
		return "DELETE FROM `{$this->prefix}pm`
				WHERE `id` = '{$in[0]}'";
	}

	/**
	 * Get the traced messages
	 *
	 * @param int $user_id
	 */
	function get_traced_messages($in)
	{
		return "SELECT *
				FROM `{$this->prefix}pm` p
				WHERE p.`from_id` = '{$in[0]}'
					AND p.`trace` = '1'
					AND p.`belongs_to` != '{$in[0]}'
				ORDER BY p.`date`";
	}

	/**
	 * Are we allowed to read it?
	 *
	 * @param int $pm_id
	 * @param int $userid
	 */
	function allowed_to_read_message($in)
	{
		return "SELECT `belongs_to`
				FROM `{$this->prefix}pm`
				WHERE `id` = '{$in[0]}'
					AND `belongs_to` = '{$in[1]}'";
	}

	/**
	 * Deletes a message
	 *
	 * @param int $pm_id
	 */
	function delete_message($in)
	{
		return "DELETE FROM `{$this->prefix}pm`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Decrease the message count for a user
	 *
	 * @param int $uid
	 */
	function update_message_count($in)
	{
		return "UPDATE `{$this->prefix}member`
				SET `new_pms` = (`new_pms` - '1')
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Move message to archive
	 *
	 * @param int $pm_in
	 */
	function move_message_to_archive($in)
	{
		return "UPDATE `{$this->prefix}pm` SET `fid` = '4' WHERE `id` = '{$in[0]}' LIMIT 1";
	}

	/**
	 * Marks a message with read flag
	 *
	 * @param int $pm_id
	 */
	function mark_message_as_read($in)
	{
		return "UPDATE `{$this->prefix}pm`
				SET `read` = '1'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Marks a message as unread
	 *
	 * @param int $pm_id
	 */
	function mark_message_unread($in)
	{
		return "UPDATE `{$this->prefix}pm`
				SET `read` = '0'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Insert message data
	 *
	 * @param string $message
	 * @param string $date
	 * @param int $author_id
	 * @param string $cc_to
	 */
	function create_new_message_data($in)
	{
		return "INSERT INTO `{$this->prefix}pm_data` (`date`, `content`, `author_id`, `cc_to`)
				VALUES ('{$in[1]}', '{$in[0]}', '{$in[2]}', '{$in[3]}')";
	}

	/**
	 * Constructs a new message object. Does not notify.
	 *
	 * @param int $msg_id
	 * @param string $title
	 * @param int $from_id
	 * @param int $to_id
	 * @param string $in_folder
	 * @param int $trace
	 * @param int $belongs_to
	 */
	function create_new_message($in)
	{
		return "INSERT INTO `{$this->prefix}pm`
				VALUES ('', '{$in[0]}', '{$in[2]}', '{$in[1]}', '{$in[3]}',
					'{$in[4]}', '{$in[5]}', '0', 'NULL', '0', '{$in[6]}', '{$in[7]}')";
	}

	/**
	 * Update the new message count for the recipient,
	 * and display a notification
	 *
	 * @param int $to_id
	 */
	function update_new_message($in)
	{
		return "UPDATE `{$this->prefix}member`
				SET `new_pms` = (`new_pms` + '1'), `done_pmpopup` = '0'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Lower the new message count, when something
	 * has been read
	 *
	 * @param int $uid
	 */
	function reduce_new_message($in)
	{
		return "UPDATE `{$this->prefix}member`
				SET `new_pms` = (`new_pms` - '1')
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Fetch a single message
	 *
	 * @param int $pm_id
	 */
	function get_message_content($in)
	{
		return "SELECT *
				FROM `{$this->prefix}pm_data` pm
				LEFT JOIN `{$this->prefix}pm` p ON pm.`id` = p.`msg_id`
				WHERE p.`id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Getting some user info for use in message view
	 *
	 * @param int $user_id
	 */
	function get_user_stuff($in)
	{
		return "SELECT `signature`, `avatar`, `registered`, `location`,
					`posts`, `name`, `title`
				FROM `{$this->prefix}member`
				WHERE `id` ='{$in[0]}'
				LIMIT 1";
	}

	/**
	 * We've read this, move along!
	 *
	 * @param int $pm_id
	 * @param int $date
	 */
	function mark_message_read($in)
	{
		return "UPDATE `{$this->prefix}pm`
				SET `really_read` = '1', `read_date` = '{$in[1]}', `read` = '1'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}


	//Getting the user config for sending a pm (show smileys, signature, etc)
	function get_user_choices($in)
	{
		return "SELECT `posts`, `use_smiley`, `use_sig`
				FROM `{$this->prefix}member`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Can we read this PM?
	 *
	 * @param int $pm_id
	 * @param int $userid
	 */
	function can_read_pm($in)
	{
		return "SELECT d.`author_id`, d.`content`, d.`date`, p.`title`, p.`belongs_to`
				FROM `{$this->prefix}pm_data` d, `{$this->prefix}pm` p
				WHERE d.`id` = p.`msg_id`
					AND d.`id` = '{$in[0]}'
					AND p.`belongs_to` = '{$in[1]}'
				LIMIT 1";
	}

	/**
	 * Move a message from folder to folder
	 *
	 * @param int $pm_id
	 * @param int $to_folder
	 */
	function move_message($in)
	{
		return "UPDATE `{$this->prefix}pm`
				SET
					`fid` = '{$in[1]}'
				WHERE
					`id` = '{$in[0]}'
				LIMIT 1";
	}
}

?>
