<?php

/**
 * MySQL file for post.php
 *
 * @package Vikingboard
 * @version 0.2.0
 * $Id: sql_MySQL_post.php 1856 2007-11-25 18:49:49Z ueland $
 */

class sql extends SQLGlobal
{
	/**
	 * SQL class constructor
	 *
	 */
	function sql($prefix)
	{
		$this->prefix	=	$prefix;
	}

	// Getting information around a post, topic name etc
	function get_post_information($in)
	{
		return "SELECT p.`post`, p.`author_id`, p.`author_name`, p.`posted`,
					t.`id`, t.`title`, t.`forum`, t.`cat`, p.`tid`
				FROM `{$this->prefix}post` p,
					`{$this->prefix}topic` t
				WHERE t.`id` = p.`tid`
					AND p.`id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Get the first post in a topic
	 *
	 * @param int $topic_id
	 */
	function get_first_post_in_topic($in)
	{
		return "SELECT `id`
				FROM `{$this->prefix}post`
				WHERE `tid` = '{$in[0]}'
				ORDER BY `posted` ASC
				LIMIT 1";
	}

	/**
	 * Get topic subscriptions from user
	 *
	 * @param int $topic_id
	 * @param int $user_id
	 */
	function get_topic_subscription_from_user($in)
	{
		return "SELECT `id`
				FROM `{$this->prefix}subscr_topic`
				WHERE `tid` = '{$in[0]}'
					AND `uid` = '{$in[1]}'
				LIMIT 1";
	}

	/**
	 * Add topic subscription
	 *
	 * @param int $topic_id
	 * @param int $user_id
	 */
	function add_topic_subscription($in)
	{
		return "INSERT INTO `{$this->prefix}subscr_topic` (`tid`, `uid`)
				VALUES ('{$in[0]}', '{$in[1]}')";
	}

	/**
	 * Remove topic subscription
	 *
	 * @param int $topic_id
	 * @param int $user_id
	 */
	function remove_topic_subscription($in)
	{
		return "DELETE FROM `{$this->prefix}subscr_topic`
				WHERE `tid` = '{$in[0]}'
					AND `uid` = '{$in[1]}'
				LIMIT 1";
	}

	/**
	 * Get topic information
	 *
	 * @param int $topic_id
	 */
	function get_topic_information($in)
	{
		return "SELECT t.`id`, t.`title`, t.`status`, t.`started`, f.`lpost_pid`,
					t.`replies`, f.`id` `fid`, f.`name` `fname`, c.`id` `catid`, c.`name` `catname`
				FROM `{$this->prefix}topic` t, `{$this->prefix}forum` f, `{$this->prefix}category` c
				WHERE t.`id` ='{$in[0]}'
					AND f.`id` = t.`forum`
					AND f.`cat` = c.`id`
				LIMIT 1";
	}

	/**
	 * Get category info
	 *
	 * @param int $category_id
	 */
	function get_category_info($in)
	{
		return "SELECT `id`, `name`
				FROM `{$this->prefix}category`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Get forum info
	 *
	 * @param int $forum_id
	 */
	function get_forum_info($in)
	{
		return "SELECT `id`, `name`, `cat`
				FROM `{$this->prefix}forum`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Get topic title
	 *
	 * @param int $topic_id
	 */
	function get_topic_title($in)
	{
		return "SELECT `title`
				FROM `{$this->prefix}topic`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Get quoted posts
	 *
	 * @param string $quoted_posts_id
	 * @param int $limit
	 */
	function get_quoted_posts($in)
	{
		return "SELECT p.`post`, m.`name`
				FROM `{$this->prefix}post` p,
					`{$this->prefix}member` m
				WHERE p.`id`
				IN({$in[0]})
				AND m.`id` = p.`author_id`
				LIMIT {$in[1]}";
	}

	/**
	 * Get guest posting privelegies
	 */
	function get_guest_privelegies()
	{
		return "SELECT `g_create_new_posts`
				FROM `{$this->prefix}groups`
				WHERE `id` = 1u
				LIMIT 1";
	}

	/**
	 * Insert a new topic
	 *
	 * @param int $forum_id
	 * @param int $cat_id
	 * @param string $title
	 * @param int $userid
	 * @param string $username
	 */
	function insert_newtopic($in)
	{
		return "INSERT INTO `{$this->prefix}topic` (`forum`, `cat`, `title`, `status`, `replies`,
					`views`, `sticky`, `starter_id`, `starter_name`, `started`, `lpost_name`,
					`lpost_id`, `lpost_uid`, `lpost_time`)
				VALUES ('{$in[0]}', '{$in[1]}', '{$in[2]}',
					 '1', '0', '0', '0', '{$in[3]}', '{$in[4]}', '" . forumtime() . "',
					'{$in[4]}', '{$in[3]}', '{$in[3]}', '" . forumtime() . "')";
	}

	/**
	 * Get newest topic id from a user
	 *
	 * @param int $user_id
	 */
	function get_newest_topicid_from_user($in)
	{
		return "SELECT `id`
				FROM `{$this->prefix}topic`
				WHERE `starter_id` = '{$in[0]}'
				ORDER BY `id` DESC
				LIMIT 1";
	}

	/**
	 * Get the owner of a post
	 *
	 * @param int $post_id
	 */
	function get_post_owner($in)
	{
		return "SELECT m.`id`
				FROM `{$this->prefix}member` m, `{$this->prefix}post` p
				WHERE m.`id` = p.`author_id`
					AND p.`id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Inserting a new post on topic reply
	 *
	 * @param int $topic_id
	 * @param string $user_name
	 * @param int $user_id
	 * @param string $text
	 * @param string $ip
	 */
	function insert_new_post($in)
	{
		return "INSERT INTO `{$this->prefix}post` (`tid`, `author_name`,
					`author_id`, `posted`, `post`, `ip`, `queued`)
				VALUES ('{$in[0]}', '{$in[1]}', '{$in[2]}', '" . forumtime() . "',
					'{$in[3]}', '{$in[4]}', '0')";
	}

	/**
	 * Update post data
	 *
	 * @param int $post_id
	 * @param int $user_id The user that last edited the post
	 * @param string $post_title
	 * @param string $post_content
	 */
	function update_topic_data($in)
	{
		return "UPDATE `{$this->prefix}post` p, `{$this->prefix}topic` t
				SET t.`title` = '{$in[2]}', p.`post` = '{$in[3]}',
					p.`times_edited` = `times_edited` + 1, p.`last_edit` = '" . time() . "',
					p.`last_edit_by` = '{$in[1]}'
				WHERE t.`id` = p.`tid`
					AND p.`id` = '{$in[0]}'";
	}

	/**
	 * Update post data
	 *
	 * @param int $post_id
	 * @param int $user_id The user that last edited the post
	 * @param string $post_content
	 */
	function update_post_data($in)
	{
		return "UPDATE `{$this->prefix}post`
				SET `post` = '{$in[2]}', `times_edited` = `times_edited` + 1,
					`last_edit` = '" . time() . "', `last_edit_by` = '{$in[1]}'
				WHERE `id` = '{$in[0]}'";
	}

	/**
	 * Finding the newest post id from a topic
	 *
	 * @param int $user_id
	 * @param int $topic_id
	 */
	function get_new_post_id($in)
	{
		return "SELECT `id`, `tid`
				FROM `{$this->prefix}post`
				WHERE `author_id` ='{$in[0]}'
					AND `tid` ='{$in[1]}'
				ORDER BY `id` DESC
				LIMIT 1";
	}

	/**
	 * Update user postcount
	 *
	 * @param int $user_id
	 */
	function update_user_postcount($in)
	{
		return "UPDATE `{$this->prefix}member`
				SET `posts` = (`posts` + 1)
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Updates stats on a new topic creation
	 *
	 * @param int $forumId
	 * @param String $title
	 * @param int $lastpost_id
	 * @param String $lastpost_author_name
	 * @param int $userId
	 */
	function update_stats_on_newtopic($in)
	{
		$data[0] = "UPDATE `{$this->prefix}forum`
					SET `lpost_title` = '{$in[1]}', `lpost_pid` = '{$in[3]}',
						`lpost_tid` = '{$in[2]}', `lpost_uid` = '{$in[5]}',
						`lpost_time` = '" . forumtime() . "', `lpost_name` = '{$in[4]}',
						`stat_threads` = (`stat_threads` + 1), `stat_posts` = (`stat_posts` + 1)
					WHERE `id` ='{$in[0]}'
					LIMIT 1";

		$data[1] = "UPDATE `{$this->prefix}topic`
					SET `lpost_name` = '{$in[4]}', `lpost_id` = '{$in[3]}',
						`lpost_uid` = '{$in[5]}', `lpost_time` = '" . forumtime() . "'
					WHERE `id` = '{$in[2]}'
					LIMIT 1";

					return $data;
	}


	/**
	 * Update global stats
	 *
	 * @param string topics|posts|users
	 */
	function update_global_stats($in)
	{
        if ($in[0] == 'topics')
        {
			return "UPDATE `{$this->prefix}stats`
					SET `total_topics` = (`total_topics` + 1)
					LIMIT 1";
		}
		if ($in[0] == 'posts')
		{
			return "UPDATE `{$this->prefix}stats`
					SET `total_posts` = (`total_posts` + 1)
					LIMIT 1";
		}
		if ($in[0] == 'users')
		{
			return "UPDATE `{$this->prefix}stats`
					SET `total_users` = (`total_users` + 1)
					LIMIT 1";
		}
	}

	/**
	 * Get topic subscribers
	 *
	 * @param int topicID
	 */
	function get_topic_subscribers($in)
	{
		return "SELECT `uid`
				FROM `{$this->prefix}subscr_topic`
				WHERE `tid` = '{$in[0]}'";
	}

	/**
	 * Updating lastpost and forumstats
	 * on new reply
	 *
	 * @param int $forumid
	 * @param int $lpost_topic_id
	 * @param int $lpost_post_id
	 * @param string $lpost_author
	 * @param int $lpost_userid
	 * @param string $topic_title
	 */
	function update_forum_stats_on_reply($in)
	{
		return "UPDATE {$this->prefix}forum
				SET lpost_tid = {$in[1]}, lpost_pid={$in[2]}, lpost_time = '" . forumtime() . "',
					lpost_name = '{$in[3]}', lpost_uid = {$in[4]},
					lpost_title = '{$in[5]}', stat_posts = (stat_posts + 1)
				WHERE id = {$in[0]} LIMIT 1";
	}

	/**
	 * Updating lastpost and stats of a topic
	 * when replying
	 *
	 * @param int $topicid
	 * @param int $postid
	 * @param string $username
	 * @param int $userid
	 */
	function update_topic_stats_on_reply($in)
	{
        return "UPDATE `{$this->prefix}topic`
				SET `replies` = (`replies` + 1), `lpost_name` = '{$in[2]}', `lpost_id` = '{$in[1]}',
					`lpost_uid` = '{$in[3]}', `lpost_time` =".forumtime()."
				WHERE `id` = {$in[0]}
				LIMIT 1;";
	}

	/**
	 * Adds a poll title
	 *
	 * @param int $topicId
	 * @param String $title
	 */
	function insert_new_poll_title($in)
	{
		$data[0] = "INSERT INTO `{$this->prefix}poll` (`tid`, `name`)
					VALUES ({$in[0]}, '{$in[1]}')";
		$data[1] = "UPDATE `{$this->prefix}topic`
					SET `has_poll` = 1
					WHERE `id` = {$in[0]}
					LIMIT 1";
		return $data;
	}

	/**
	 * Updates a poll title
	 *
	 * @param int $topicId
	 * @param String $newTitle
	 */
	function update_poll_title($in)
	{
		return "UPDATE `{$this->prefix}poll`
				SET `name` = '{$in[1]}'
				WHERE `tid` = {$in[0]}
				LIMIT 1";
	}


	/**
	 * Adds a poll question
	 *
	 * @param int $topicId
	 * @param String $answer
	 */
	function insert_new_poll_question($in)
	{
		return "INSERT INTO `{$this->prefix}poll_choices` (`pid`, `question`)
				VALUES ({$in[0]}, '{$in[1]}')";
	}

	/**
	 * Updates a poll question
	 *
	 * @param int $topicId
	 * @param String $newQuestion
	 * @param int limit
	 */
	function update_poll_question($in)
	{
		return "UPDATE `{$this->prefix}poll_choices`
				SET `question` = '{$in[1]}'
				WHERE `pid` = {$in[0]}
				LIMIT {$in[2]}, 1";
	}

	/**
	 * Get forum subscriptions
	 *
	 * @param int $forumId
	 */
	function get_subscriptions_in_forum($in)
	{
		return "SELECT `uid`
				FROM `{$this->prefix}subscr_forum`
				WHERE `fid` = {$in[0]}";
	}

	/**
	 * Get topic status
	 *
	 * @param int $forum_id
	 */
	function get_topic_status($in)
	{
		return "SELECT status, forum FROM `{$this->prefix}topic` WHERE `id` = {$in[0]} LIMIT 1";
	}
}

?>
