<?php
/**
 * MySQL file for search.php
 *
 * @package Vikingboard
 * @version 0.2.0
 * $Id: sql_MySQL_search.php 1724 2007-10-17 17:27:39Z ueland $
 */

class sql extends SQLGlobal
{
	/**
	 * SQL class constructor
	 *
	 */
	function sql($prefix)
	{
		$this->prefix	=	$prefix;
	}

	// Find number of search-results
	//function runSearchCalculation($words, $userId)
	function run_search_calculation($in)
	{
		//First, construct a match SQL
		$points = -1;

		$sql   =  " MATCH (p.`post`) AGAINST ('";
		foreach ($in[0] as $row)
		{
		  	$points++;
			$sql	.=	$row;
		}
		$sql   .=  "' IN BOOLEAN MODE)";

		//Calculate minimum relevance "points"
		if ($points != 0)
		{
			$points--;
		}
		$points	=	"{$points}.99";

		//Also search for a user?
		if (is_numeric($in[1]))
		{
			$userSQL	=	" AND p.`author_id` = {$in[1]}";
		}

		//then, the main thing
		return "SELECT COUNT( p.`id` ) AS `totals`
				FROM `{$this->prefix}post` p
				WHERE
                  	{$sql}
				 > {$points} {$userSQL}";
	}

	// Perform a topic search
	//function runTopicSearch($words=array(), $limit=0, $max=25)
	function run_topic_search($in)
	{
		//First part of the query
		$sql	=	"SELECT t.`id`, t.`title`, f.`name`
					FROM `{$this->prefix}topic` t, `{$this->prefix}forum` f
					WHERE ";

		//First, construt a match SQL
		foreach ($in[0] as $word)
		{
			$sql	.=	" t.`title` LIKE '%{$word}%' AND";
		}

		//Continue the query
		$sql	.=	' t.`forum` = f.`id`';

		return $sql;
 	}

	// Perform a search
	//function runSearch($words=array(), $limit=0, $max=25)
	function run_search($in)
	{
		//First, construct a match SQL
		$points = -1;

		$sql   =  ' MATCH (p.`post`) AGAINST (\'';

		foreach ($in[0] as $row)
		{
		  	$points++;
			$sql	.=	$row;
		}

		$sql   .=  '\' IN BOOLEAN MODE) AS `relevance`';


		//Calculate min relevance "points"
		if ($points != 0)
		{
			$points--;
		}

		$points	=	"{$points}.99";

		return "SELECT p.`id`, p.`post`, p.`posted`, p.`author_name`, p.`tid`,
					p.`author_id`, f.`name` AS `forumName`, f.`id` AS `forumId`,
					t.`title` AS `topicTitle`,

					{$sql}

				FROM `{$this->prefix}post` p, `{$this->prefix}forum` f, `{$this->prefix}topic` t
				WHERE `queued` = 0
					AND t.`id` = p.`tid`
					AND f.`id` = t.`forum`
				HAVING `relevance` > {$points}
				ORDER BY `relevance` DESC
				LIMIT {$in[1]} , {$in[2]}";
 	}

	/**
	 * Trying to get information about a username within a login
	 *
	 * @param string $username
	 */
	function get_finduser_login($in)
	{
		return "SELECT `id`, `name`, `group`, `posts`
				FROM `{$this->prefix}member`
				WHERE `name` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Count the absolutely correct number of posts from a user
	 *
	 * @param int $userId
	 */
	function count_users_posts($in)
	{
		return "SELECT COUNT(p.`id`) AS `totals`
				FROM `{$this->prefix}post` p
				WHERE p.`author_id` = '{$in[0]}'";
	}

	 /**
	  * Find topics from a user
	  *
	  * @param int $userId
	  * @param int $start
	  * @param int $max
	  */
	function get_users_topics($in)
	{
		return "SELECT t.`id`, t.`title`, f.`name`
				FROM `{$this->prefix}topic` t, `{$this->prefix}forum` f
				WHERE `starter_id` = '{$in[0]}'
					AND t.`forum` = f.`id`
				ORDER BY t.`id` DESC
				LIMIT {$in[1]},{$in[2]}";
	}

	// Find posts from a user
	//function get_users_posts($userId, $start=0, $max=25)
	function get_users_posts($in)
	{
		return "SELECT p.`id`, p.`post`, p.`posted`, p.`author_name`, p.`tid`,
					p.`author_id`, f.`name` AS `forumName`, f.`id` AS `forumId`,
					t.`title` AS `topicTitle`
				FROM `{$this->prefix}post` p, `{$this->prefix}forum` f, `{$this->prefix}topic` t
				WHERE `queued` = 0
					AND p.`author_id` = {$in[0]}
					AND t.`id` = p.`tid`
					AND f.`id` = t.`forum`
				ORDER BY `posted` DESC
				LIMIT {$in[1]} , {$in[2]}";
	}

	/**
	 * Get the post IDs from the last posts
	 *
	 * @param int $start
	 * @param int $stop
	 */
	function get_last_posts($in)
	{
        return "SELECT p.`id`, p.`post`, p.`posted`, p.`tid`, p.`author_name`,
						p.`author_id`, f.`name` AS `forumName`, f.`id` AS `forumId`,
						t.`title` AS `topicTitle`
				FROM `{$this->prefix}post` p, `{$this->prefix}forum` f, `{$this->prefix}topic` t
				WHERE `queued` = 0
					AND t.`id` = p.`tid`
					AND f.`id` = t.`forum`
				ORDER BY p.`posted` DESC
				LIMIT {$in[0]}, {$in[1]}";
	}

	/**
	 * Find the newest topics
	 *
	 * @param int $start
	 * @param int $end
	 */
	function get_last_topics($in)
	{
		return "SELECT t.`id`, t.`title`, f.`name`
				FROM `{$this->prefix}topic` t, `{$this->prefix}forum` f
				WHERE t.`forum` = f.`id`
				ORDER BY `started` ASC
				LIMIT {$in[0]},{$in[1]}";
	}


    // Find total posts within a time-period
    function calculate_last_posts($in)
    {
        $calc = (time() - $in[0]);
        return "SELECT COUNT( p.id ) as totals FROM {$this->prefix}post p WHERE p.posted > {$calc}";
    }
}

?>
