<?php

/**
 * MySQL file for settings.php
 *
 * @package Vikingboard
 * @version 0.2.0
 * $Id$
 */

class sql extends SQLGlobal
{
	/**
	 * SQL class constructor
	 *
	 */
	function sql($prefix)
	{

		$this->prefix	=	$prefix;
	}

	// Fetching profile data
	function get_profile_data($in)
	{
		return "SELECT `id`, `name`, `email`, `signature`, `avatar`,
					`posts`, `registered`, `location`, `interests`, `websites`,
					`real_name`, `birthday`, `user_photo`, `title`, `im_networks`,
					`allow_pm`, `allow_email`
				FROM `{$this->prefix}member`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	/**
	 * Update profile data for a user
	 *
	 * @param int $uid
	 * @param string $avatar
	 * @param string $real_name
	 * @param string $location
	 * @param string $birthday
	 * @param string $websites
	 * @param string $im_networks
	 * @param int $allow_pm
	 */
	function update_profile_data($in)
	{
		return "UPDATE `{$this->prefix}member`
				SET `avatar` = '{$in[1]}',
					`real_name` = '{$in[2]}',
					`location` = '{$in[3]}',
					`birthday` = '{$in[4]}',
					`websites` = '{$in[5]}',
					`im_networks` = '{$in[6]}',
					`allow_pm`	= '{$in[7]}'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	// Gets the avatar and member photo info
	function get_user_avatar($in)
	{
		return "SELECT `avatar`, `user_photo`
				FROM `{$this->prefix}member`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	// Updating a users avatar
	function update_user_avatar($in)
	{
		return "UPDATE `{$this->prefix}member`
				SET `avatar` = '{$in[1]}'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	// Gets the signature info
	function get_user_signature($in)
	{
		return "SELECT `signature`
				FROM `{$this->prefix}member`
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	// Updating a users signature
	function update_user_signature($in)
	{
		return "UPDATE `{$this->prefix}member`
				SET `signature` = '{$in[1]}'
				WHERE `id` = '{$in[0]}'
				LIMIT 1";
	}

	// +--------------------+
	// |Forum subscriptions |
	// +--------------------+

	/**
	 * Remove forum subscriptions
	 *
	 * Removes selected forum subscriptions
	 * @param int userid
	 * @param string forums
	 */
	function remove_forum_subscriptions($in)
	{
		return "DELETE FROM
					`{$this->prefix}subscr_forum`
				WHERE
					`uid` = '{$in[0]}'
				AND
					`fid` IN({$in[1]})";
	}

	/**
	 * Get forum subscriptions
	 *
	 * Gets all the forums a user subscribes to
	 * @param int userid
	 */
	function get_forum_subscriptions($in)
	{
		return "SELECT `fid`
				FROM `{$this->prefix}subscr_forum`
				WHERE `uid` = '{$in[0]}'
				ORDER BY `id` DESC";
	}

	/**
	 * Get forum subscription info
	 *
	 * @param int forumid
	 */
	function get_forum_subscr_info($in)
	{
		return "SELECT `id`, `name`, `cat`, `lpost_title`, `lpost_tid`,
					`lpost_pid`, `lpost_uid`, `lpost_time`, `lpost_name`,
					`stat_threads`, `stat_posts`
				FROM `{$this->prefix}forum`
				WHERE `id` ='{$in[0]}'
				LIMIT 1";
	}


	// +--------------------+
	// |Topic subscriptions |
	// +--------------------+

	/**
	 * Get topic subscriptions
	 *
	 * @param int user
	 */
	function get_topic_subscriptions($in)
	{
		return "SELECT `tid`
				FROM `{$this->prefix}subscr_topic`
				WHERE `uid` = '{$in[0]}'";
	}

	/**
	 * Get topic subscription info
	 *
	 * @param int topic_id
	 */
	function get_topic_subscr_info($in)
	{
		return "SELECT t.`id`, t.`title`, f.`lpost_pid`, f.`lpost_uid`,
					f.`lpost_name`, f.`lpost_time`, t.`replies`, t.`views`, c.`id`
				FROM `{$this->prefix}topic` t, `{$this->prefix}forum` f, `{$this->prefix}category` c
				WHERE t.`id` ='{$in[0]}'
					AND f.`id` = t.`forum`
					AND f.`cat` = c.`id`
				LIMIT 1";
	}

	/**
	 * Remove topic subscriptions
	 *
	 * Removes selected topic subscriptions
	 * @param int userid
	 * @param array topics
	 */
	function remove_topic_subscriptions($in)
	{
		// Start making the query
		$query	=	"DELETE FROM `{$this->prefix}subscr_topic`
					WHERE `uid` = '{$in[0]}'
						AND `tid` = ";

		$i	=	0;
		foreach ($in[1] as $topic)
		{
			// First topic
			if($i == 0)
			{
				$query	.=	$topic;
				$i++;
			}
			// The other topics
			else
			{
				$query	.=	" OR " . $topic;
			}
		}

		return $query;
	}

	// +-----------------+
	// | Forum settings  |
	// +-----------------+

	/**
	 * Get forum themes
	 *
	 * Get all active forum themes
	 *
	 */
	function get_forum_themes()
	{
		return "SELECT `id`, `name` FROM `{$this->prefix}template_sets` WHERE `active` = '1'";
	}

	/**
	 * Get forum languages
	 *
	 * Get all available forum languages
	 *
	 */
	function get_forum_languages()
	{
		return "SELECT `id`, `language` FROM `{$this->prefix}languages`";
	}

	/**
	 * Update user settings
	 *
	 * Save user preferences (lang, theme etc)
	 *
	 * @param int $lang
	 * @param int $theme
	 * @param int $user_id
	 */
	function update_user_settings($in)
	{
		return "UPDATE `{$this->prefix}member` SET `lang` = '{$in[0]}', `skin_set` = '{$in[1]}' WHERE `id` = '{$in[2]}' LIMIT 1";
	}
}

?>
