<?php

/**
 * MySQL file for topic.php
 *
 * @package Vikingboard
 * @version 0.2.0
 * $Id: sql_MySQL_topic.php 1818 2007-11-20 00:30:59Z jorgenboard $
 */

class sql extends SQLGlobal
{
	/**
	 * SQL class constructor
	 *
	 */
	function sql($prefix)
	{

		$this->prefix	=	$prefix;
	}

	//Update the topic read count
	function update_topic_view_counter($in)
	{
		return "UPDATE {$this->prefix}topic SET views =(views + 1) WHERE id ={$in[0]} LIMIT 1";
	}

	function get_last_post_data($in)
	{
		return "SELECT t.`replies`, p.`id`
				FROM `{$this->prefix}topic` t, `{$this->prefix}post` p
				WHERE t.`id` = '{$in[0]}'
					AND p.`tid` = '{$in[0]}'
				ORDER BY p.`posted` DESC
				LIMIT 1";
	}

	//Gets all poll-related info for a topic ID
	function get_poll($in) {
		return "SELECT p.name, p.votes, c.question, c.votes
				FROM {$this->prefix}poll p, {$this->prefix}poll_choices c
				WHERE c.pid={$in[0]} AND p.tid={$in[0]} ORDER BY c.id ASC";
	}

	//Getting information about a topic
	function get_topic_information($in)
	{
		return "SELECT t.id, t.title, t.status, t.started, t.starter_id, f.lpost_pid,
					t.replies, t.has_poll, t.sticky, f.id fid, f.name fname, c.id catid, c.name catname
				FROM {$this->prefix}topic t, {$this->prefix}forum f, {$this->prefix}category c
			       	WHERE t.id = '{$in[0]}' AND f.id = t.forum AND f.cat = c.id
			       	LIMIT 1";
	}

	//Getting post ID`s from a topic
	function get_postIDs_in_topic($in)
	{
			return "SELECT `id`
					FROM `{$this->prefix}post`
					WHERE `tid` =  {$in[0]}
						AND `queued` = 0
					ORDER BY `id` ASC
					LIMIT {$in[1]}, {$in[2]}";
	}

	//Getting the posts in a topic (or at least some of them)
	function get_posts_in_topic($in)
	{
		return "SELECT p.id, p.author_name, p.author_id, p.posted, p.post, p.ip,
					p.times_edited, p.last_edit_by, p.last_edit, m.avatar, m.posts,
					m.registered, m.location, m.title, m.signature, g.g_name
				FROM {$this->prefix}post p
				LEFT JOIN {$this->prefix}member m ON (p.author_id = m.id)
				LEFT JOIN {$this->prefix}groups g ON (m.group = g.id)
				WHERE p.id IN ({$in[0]} 0)
				ORDER BY p.id ASC
				LIMIT {$in[1]}";
	}

	//Get information about a spesific forum
	function get_forum_info($in)
	{
		return "SELECT id, name, cat, stat_threads FROM {$this->prefix}forum WHERE id ={$in[0]} LIMIT 1";
	}

	/**
	 * Get topic subscription
	 *
	 *
	 * @param int user
	 * @param int topic
	 */
	function get_topic_subscription($in)
	{
		return "SELECT `id` FROM {$this->prefix}subscr_topic WHERE `uid` = {$in[0]} AND `tid` = {$in[1]} LIMIT 1";
	}

	/**
	 * New topic subscription
	 *
	 *
	 * @param int user
	 * @param int topic
	 */
	function new_topic_subscription($in)
	{
		return "INSERT INTO {$this->prefix}subscr_topic (`uid`, `tid`) VALUES ('{$in[0]}', '{$in[1]}')";
	}

	// Getting information around a post, topic name etc
	function get_post_information($in)
	{
		return "SELECT p.post, p.author_id, p.author_name, p.use_sig, p.posted, t.id, t.title, t.forum, t.cat, p.tid
					FROM {$this->prefix}post p, {$this->prefix}topic t
					WHERE t.id=p.tid AND p.id={$in[0]} LIMIT 1";
	}

	// Gets the very first post in topic
	function first_post_in_topic($in)
	{
		return "SELECT `id` FROM `{$this->prefix}post` WHERE `tid` = {$in[0]} ORDER BY `id` ASC LIMIT 1";
	}

	/**
	 * Delete a post
	 *
	 * @param int $id
	 */
	function delete_post($in)
	{
		return "DELETE FROM {$this->prefix}post WHERE id={$in[0]} LIMIT 1";
	}

	/**
	 * REduce the reply count in a topic
	 * when deleting a post
	 *
	 * @param int $topic_id
	 */
	function reduce_topic_reply_count($in)
	{
		return "UPDATE {$this->prefix}topic SET replies = replies - 1 WHERE id={$in[0]} LIMIT 1";
	}

	/**
	 * Reduce the post count in a forum
	 * when deleting a post
	 *
	 * @param int $forum_id
	 */
	function reduce_forum_post_count($in)
	{
		return "UPDATE {$this->prefix}forum SET stat_posts = stat_posts - 1 WHERE id={$in[0]} LIMIT 1";
	}

	/**
	 * Delete a topic
	 *
	 * @param int $id
	 */
	function delete_topic($in)
	{
		return "DELETE FROM `{$this->prefix}topic` WHERE `id` = {$in[0]} LIMIT 1";
	}

	/**
	 * Reduce the topic count in a forum by one
	 * when deleting a topic
	 *
	 * @param int $forum_id
	 */
	function reduce_forum_topic_count($in)
	{
		return "UPDATE {$this->prefix}forum SET stat_threads = stat_threads - 1 WHERE id={$in[0]} LIMIT 1";
	}

	/**
	 * Gets the last post in a topic
	 *
	 * @param int $topic
	 */
	function get_last_post($in)
	{
		return "SELECT * FROM {$this->prefix}post p, {$this->prefix}topic t WHERE p.tid = '{$in[0]}' AND t.id = p.tid ORDER BY p.id DESC LIMIT 1";
	}

	/**
	 * Update lastpost-stats for a topic
	 *
	 * @param string $author
	 * @param int $id
	 * @param int $uid
	 * @param int $time
	 * @param int $topic
	 */
	function update_topic_last_post($in)
	{
		return "UPDATE `{$this->prefix}topic` SET `lpost_name` = '{$in[0]}', `lpost_id` = '{$in[1]}', `lpost_uid` = '{$in[2]}', `lpost_time` = '{$in[3]}' WHERE `id` = '{$in[4]}'";
	}

	/**
	 * Update lastpost-stats for a forum
	 *
	 * @param int $id
	 * @param int $uid
	 * @param int $time
	 * @param string $author
	 * @param int $forum
	 */
	function update_forum_last_post($in)
	{
		return "UPDATE `{$this->prefix}forum` SET `lpost_pid` = '{$in[0]}', `lpost_uid` = '{$in[1]}', `lpost_time` = '{$in[2]}', `lpost_name` = '{$in[3]}' WHERE `id` = '{$in[4]}'";
	}

	// Counts all posts in a topic
	function count_posts_in_topic($in)
	{
		return "SELECT COUNT(*) AS total FROM `{$this->prefix}post` WHERE `tid` = '{$in[0]}'";
	}

	/**
	 * Delete all posts in a topic
	 *
	 * @param int $topic_id
	 */
	function delete_posts_in_topic($in)
	{
		return "DELETE FROM `{$this->prefix}post` WHERE `tid` = '{$in[0]}' LIMIT 0";
	}


	/**
	 * Reduce the forum post-count when
	 * deleting a topic
	 *
	 * @param int $num_posts
	 * @param int $forum_id
	 */
	function reduce_forum_post_count_dyn($in)
	{
		return "UPDATE {$this->prefix}forum SET `stat_posts` = ( `stat_posts` - {$in[0]}) WHERE id = '{$in[1]}' LIMIT 1";
	}

	/**
	 * Get last topic from a forum
	 *
	 * @param int $forum_id
	 */
	function get_last_topic($in)
	{
		return "SELECT * FROM `{$this->prefix}topic` WHERE `forum` = '{$in[0]}' ORDER BY `lpost_time` DESC LIMIT 1";
	}

	/**
	 * Updates the lastpost for a forum, on eg. topic deletion
	 *
	 * @param int $forum
	 * @param string $title
	 * @param int $tid
	 * @param int $pid
	 * @param int $uid
	 * @param int $time
	 * @param string $name
	 */
	function update_last_topic($in)
	{
		return "UPDATE `{$this->prefix}forum` SET `lpost_title` = '{$in[1]}', `lpost_tid` = '{$in[2]}', `lpost_pid` = '{$in[3]}', `lpost_uid` = '{$in[4]}', `lpost_time` = '{$in[5]}', `lpost_name` = '{$in[6]}' WHERE `id` = '{$in[0]}'";
	}

	function get_author_details($in)
	{
		return "SELECT m.`name`, m.`registered`, m.`posts`, m.`location`, m.`title`, g.`g_name` `group_name`
				FROM `{$this->prefix}member` m, `{$this->prefix}groups` g
				WHERE m.`id` = '{$in[0]}'
					AND g.`id` = m.`group`
				LIMIT 1";
	}
}

?>
