<?php

/**
* @package Vikingboard
* @author Tor Henning Ueland <tor.henning@vikingboard.com>
* @copyright Copyright (c) 2004-2006 The Vikingboard Project
* @license GPL {@link http://www.gnu.org/licenses/gpl.html}
* @link http://www.vikingboard.com
*
* $Id: kernel.php 1886 2007-12-03 00:37:18Z jorgenboard $
*/

if (!defined('VBOARD'))
{
	die('Hacker attempt in ' . basename(__FILE__));
}

//Enable/disable development mode
define('IN_DEVELOPMENT', false);

//Load functions file
require_once('functions.php');

//Disable error reporting and use our custom error handler, if not in development
error_reporting(0);
switch (@$_GET['error'])
{
	//use only screen reporting
	case 1:
		if (IN_DEVELOPMENT == true)
		{
			error_reporting(E_ALL);
		}
	break;

	//default: use custom handler
	default:
		include 'inc/lib/error_handler.php';
		set_error_handler('error_handler');
	break;
}

//Clean incoming data
$magicquotes	=	get_magic_quotes_gpc();

$_POST			=	parse_global($_POST, $magicquotes, false);
$_GET			=	parse_global($_GET, $magicquotes, true);
$_COOKIE		=	parse_global($_COOKIE, $magicquotes, true);
$_SERVER		=	parse_global($_SERVER, $magicquotes, true);


//Require needed libraries
require_once 'inc/lib/session.php';
require_once 'drivers.php';
require_once 'inc/lib/timer.php';
require_once 'inc/conf.php';
require_once 'inc/lib/data.php';
require_once 'inc/user.php';
require_once 'inc/lib/screen.php';
require_once 'inc/drivers/mail/' . DRIVER_MAIL . '.php';

//Timer
$timer	=	new timer;

//Initialize classes
$config_global	=	new config_global;
$data			=	new Data($config_global);
$session        =   new Session($data);
$config 		=	new config($data);
$user			=	new User($data, $config, $session);
$screen			=	new screen($data, $config, $user, $timer);

// Report errors if some are missing
if (!isset($user))
{
	trigger_error('User object is missing!', E_USER_ERROR);
	//define('IN_MAINTENANCE', 1);
}
if (!isset($data))
{
	trigger_error('Data object is missing!', E_USER_ERROR);
	//define('IN_MAINTENANCE', 1);
}

//Require language file(s)
if (defined('IN_ACP'))
{
	require_once('inc/lang/' . $user->lang . '/admin.php');
}
else
{
	require_once('inc/lang/' . $user->lang . '/index.php');
}

//Trigger error if the board is offline
if (($config->active == 0 && !$user->g_view_offline) || ($config->forum_on == 0 && !$user->g_view_offline) || defined('IN_MAINTENANCE'))
{
	error_msg('<h1>Maintenance mode</h1><p>The forum is in maintenance mode, please check back later.</p>', 1);
}

//Trigger error if the user is banned
if (isset($user) && ($user->g_viewforum !=1 || $user->group == 4))
{
  	$lang_login	=	new lang_login;
	error_msg($lang_login->login_banned, 1);
}
?>