<?php

/**
 * This is the primary function for handling multiple
 * pages. When you need to have page navigation, use
 * this, please, in order to keep a consistant look
 * and feel.
 *
 * This file may look unsophisticated and plain, but
 * this is done on purpose, as it is supposed to be
 * as fast and cheap on CPU time as possible.
 *
 * @author Jørgen Tellnes <jorgis@jorgis.com>
 * @package Vikingboard
 * @name pages
 * @version 0.1
 * @todo Have the ability to use a custom scheme for this,
 * so that the board admin/skin dude can let the pagination
 * look like whatever he wants
 *
 * @param int $current 		The page currently displayed
 * @param int $last			The last page in the dataset
 * @param string $href		The href to generate on the page links
 * @param int multiplier	Number to increment the page link URL with.
 * 							This number is added to end of the URL
 * @return string $html		Plain HTML output, to use in Screen
 *
 * $Id: pages.php 1885 2007-12-03 00:16:43Z jorgenboard $
 */

//oh no!
if (!defined("VBOARD"))
{
	die('Hacker attempt in ' . basename(__FILE__));
}

function pages($current, $last, $href, $multiplier)
{
	/*
	 * We'll display the first two entries (if they exist), and then
	 * display the current entry and the two that surrounds it. If the
	 * current is not the last, we'll display the last two as well.
	 */

	// First pages
	if ($current == 1)
	{
		$pages[]	=	$current;
	}
	elseif ($current >= 2)
	{
		$pages	=	array(1, 2);
	}
	else
	{
		$pages[]	=	1;
	}

	// Around the current
	if ($current != 1)
	{
		$pages[]	=	$current - 1;
	}

	$pages[]	=	$current;

	if ($current != $last)
	{
		$pages[]	=	$current + 1;
	}

	// At the end
	if ($current != $last)
	{
		$pages[]	=	$last - 1;
	}

	$pages[]	=	$last;

	// Remove dupes
	$pages	=	array_unique($pages);

	// Then we'll translate the $pages array into a full HTML thingy
	$html	=	"";
	foreach ($pages as $page)
	{
		if ($page == $current)
		{
			$display	=	'<em>' . $page . '</em>';
		}
		else
		{
			$display	=	$page;
		}

		$page	=	($multiplier * $page) - $multiplier;

		$html	.=	'<a href="' . $href . $page . '">' . $display . '</a>';
		if ($page != $last)
		{
			$html	.=	', ';
		}
	}

	return $html;
}
?>