<?php

/**
 * PLEASE UPDATE THIS DESCRIPTION TEXT
 *
 * $Id: session.php 1885 2007-12-03 00:16:43Z jorgenboard $
 */

//oh no!
if (!defined('VBOARD'))
{
	die('Hacker attempt in ' . basename(__FILE__));
}

//Force sessionIDs to be sent on URLS
ini_set('session.use_trans_sid', true);

//Change session name to something nicer
session_name('sess');



/**
 * Session class - Handles all session related work
 */
class Session
{

   /**
	* Class constructor sets session ID and starts it
	*
	* @return void
	*/
   function Session(&$data)
   {
		$this->data = &$data;

		//Force sessionIDs to be sent on URLS
		ini_set('session.use_trans_sid', true);

		//Change session name to something nicer
		session_name('session');

		//Start a session (yay)
		session_start();

		$this->ip = get_remote_address();

		//Auth session
		$this->auth();
	}

   /**
	* Get`s user info on the current session
	*
	* @return void
	*/
	function auth()
	{
		$sql = $this->data->query('get_user_info', array($this->id(), $this->ip));

		if (!isset($sql[0]->id))
		{
			$this->save_session();
		}
		else
		{
			$this->user  = $sql[0];
		}
	}

   /**
	* Updates session ID in the database
	*
	* @return void
	*/
	function update_session()
	{
		$this->data->query('session_updater', array($this->id(), $this->ip));

		if ((forumtime() - $this->user->updateTime) < 3600)
		{
			$this->data->query('update_time_online', array($this->user->uid, (forumtime() - $this->user->updateTime))); //also called time wasted :)
		}
	}

   /**
	* Logs in a user on the active session ID
	*
	* @return void
	*/
	function login($id, $group, $name, $hide)
	{
		$this->data->query('update_loginuser', array($id, $group, $name, $hide, 1, $this->id()));
		$this->auth();
	}

   /**
	* Clears a session ID
	*
	* @return void
	*/
	function clear($param)
	{
		unset($_SESSION[$param]);
	}

   /**
	* Saves session ID to DB
	*
	* @return void
	*/
	function save_session()
	{
		//Remove other sessions before saving this session
		$this->data->query('remove_guest_sessions', array($this->ip));

		$this->data->query('session_inserter', array($this->id(), $this->ip) );
		$this->auth();
	}

   /**
	* Returns session ID
	*
	* @return String
	*/
	function id()
	{
		if (isset($_GET['session']) && strlen($_GET['session']) == 32)
		{
			$s = $_GET['session'];
		}
		else
		{
			$s = session_id();
		}

		return $s;
	}

   /**
	* Gets a session key
	*
	* @return String value
	*/
	function get($param)
	{
		if (isset($_SESSION[$param]))
		{
			return $_SESSION[$param];
		}
		else
		{
			return null;
		}
	}

   /**
	* Sets a given session key
	*
	* @return void
	*/
	//Set a session key
	function set($param, $value)
	{
		$_SESSION[$param] = $value;
	}
}

?>