/**
 * The Vikingboard installer SQL-file. Contains
 * use FTP if it detects that some file stuff is wrong or missing.
 *
 * @package Vikingboard
 * @version 0.1
 *
 * $Id: installation.sql 1868 2007-11-27 20:18:43Z jorgenboard $
 */

#languages
DROP TABLE IF EXISTS `PREFIX|languages`;
CREATE TABLE `PREFIX|languages` (
`id` INT( 4 ) NOT NULL AUTO_INCREMENT ,
`language` VARCHAR( 255 ) NOT NULL ,
PRIMARY KEY ( `id` )
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci;

INSERT INTO `PREFIX|languages` ( `id` , `language` ) VALUES ('1', 'English');
INSERT INTO `PREFIX|languages` ( `id` , `language` ) VALUES ('2', 'Norwegian');

#TEMPLATE CATEGORIES

DROP TABLE IF EXISTS `PREFIX|template_category`;
CREATE TABLE `PREFIX|template_category` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci AUTO_INCREMENT=18;


INSERT INTO `PREFIX|template_category` VALUES (2, 'Admin CP - Template administration');
INSERT INTO `PREFIX|template_category` VALUES (3, 'Admin CP - Global/general');
INSERT INTO `PREFIX|template_category` VALUES (4, 'User CP');
INSERT INTO `PREFIX|template_category` VALUES (5, 'Navigation');
INSERT INTO `PREFIX|template_category` VALUES (6, 'Topic view');
INSERT INTO `PREFIX|template_category` VALUES (7, 'Post view');
INSERT INTO `PREFIX|template_category` VALUES (8, 'Admin CP - Configuration');
INSERT INTO `PREFIX|template_category` VALUES (9, 'Admin CP - Cachemanagement');
INSERT INTO `PREFIX|template_category` VALUES (10, 'Admin CP - Forums');
INSERT INTO `PREFIX|template_category` VALUES (11, 'Global template bits');
INSERT INTO `PREFIX|template_category` VALUES (12, 'View Forum');
INSERT INTO `PREFIX|template_category` VALUES (13, 'Frontpage');
INSERT INTO `PREFIX|template_category` VALUES (14, 'Search');
INSERT INTO `PREFIX|template_category` VALUES (15, 'Admin CP -  Task log');
INSERT INTO `PREFIX|template_category` VALUES (16, 'Admin CP - Word Cencor');
INSERT INTO `PREFIX|template_category` VALUES (17, 'Admin CP - Languages');
INSERT INTO `PREFIX|template_category` VALUES (18, 'Admin CP - User Managment');
INSERT INTO `PREFIX|template_category` VALUES (19, 'Admin CP | Help pages');





#Template sets
DROP TABLE IF EXISTS `PREFIX|template_sets`;
CREATE TABLE `PREFIX|template_sets` (
  `id` int(11) NOT NULL auto_increment,
  `active` int(1) NOT NULL default '0',
  `name` varchar(250) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci;




# Table structure for table `PREFIX|badword`
#

DROP TABLE IF EXISTS `PREFIX|badword`;
CREATE TABLE `PREFIX|badword` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) default NULL,
  `nname` varchar(50) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci AUTO_INCREMENT=1 ;



# Table structure for table `PREFIX|category`
#

DROP TABLE IF EXISTS `PREFIX|category`;
CREATE TABLE `PREFIX|category` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) default NULL,
  `extend` tinyint(1) NOT NULL default '0',
  `order` int(3) default '0' NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci AUTO_INCREMENT=1 ;



# Table structure for table `PREFIX|config`
#

DROP TABLE IF EXISTS `PREFIX|config`;
CREATE TABLE `PREFIX|config` (
  `id` int(3) NOT NULL auto_increment,
  `forum_name` varchar(50) default NULL,
  `forum_url` varchar(50) default NULL,
  `forum_email` varchar(75) NOT NULL default '',
  `site_homepage` varchar(50) default NULL,
  `site_host` varchar(50) default NULL,
  `def_tpl` int(3) default '1',
  `def_cat` int(3) default '1',
  `def_lang` int(3) default '1',
  `active` char(1) NOT NULL default '0',
  `pw_seed` varchar(255) NOT NULL default '',
  `show_maxtopics` int(5) NOT NULL default '50',
  `show_maxposts` int(5) NOT NULL default '15',
  `prune_topics` int(5) NOT NULL default '30',
  `timestamp1` varchar(25) NOT NULL default 'd.m.y g:i',
  `timestamp2` varchar(25) NOT NULL default 'd.m.Y g:i',
  PRIMARY KEY  (`id`),
  KEY `site_host` (`site_host`),
  KEY `active` (`active`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci AUTO_INCREMENT=1 ;



# Table structure for table `PREFIX|forum`
#

DROP TABLE IF EXISTS `PREFIX|forum`;
CREATE TABLE `PREFIX|forum` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) default NULL,
  `descr` varchar(250) NOT NULL default '',
  `cat` int(50) default NULL,
  `order` int(4) NOT NULL default '0',
  `lpost_title` varchar(60) default NULL,
  `lpost_tid` int(11) NOT NULL default '0',
  `lpost_pid` int(11) NOT NULL default '0',
  `lpost_uid` int(11) NOT NULL default '0',
  `lpost_time` int(12) NULL DEFAULT NULL,
  `lpost_name` varchar(50) NOT NULL default '',
  `stat_threads` int(11) default '0',
  `stat_posts` int(11) default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci AUTO_INCREMENT=1 ;


# --------------------------------------------------------

#
# Table structure for table `PREFIX|groups`
#

DROP TABLE IF EXISTS `PREFIX|groups`;
CREATE TABLE `PREFIX|groups` (
  `id` int(3) NOT NULL auto_increment,
  `g_name` varchar(75) NOT NULL default 'Unamed',
  `g_view_offline` int(1) NOT NULL default '0',
  `g_viewforum` int(1) NOT NULL default '1',
  `g_can_search` int(1) NOT NULL default '1',
  `g_can_delete_own_posts` int(1) NOT NULL default '0',
  `g_can_delete_own_topics` int(1) NOT NULL default '0',
  `g_can_edit_own_posts` int(1) NOT NULL default '0',
  `g_create_new_posts` int(1) NOT NULL default '1',
  `g_create_new_polls` int(1) NOT NULL default '1',
  `g_is_admin` int(1) NOT NULL default '0',
  `g_is_mod` int(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci AUTO_INCREMENT=7 ;

#
# Dumping data for table `PREFIX|groups`
#

INSERT INTO `PREFIX|groups` (`id`, `g_name`, `g_view_offline`, `g_viewforum`, `g_can_search`, `g_can_delete_own_posts`, `g_can_delete_own_topics`, `g_can_edit_own_posts`, `g_create_new_posts`, `g_create_new_polls`, `g_is_admin`, `g_is_mod`) VALUES
(1, 'Administrator', 1, 1, 1, 1, 1, 1, 1, 1, 1, 1),
(2, 'Moderator', 0, 1, 1, 1, 1, 1, 1, 1, 0, 1),
(3, 'Member', 0, 1, 1, 0, 0, 1, 1, 1, 0, 0),
(4, 'Banned user', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
(5, 'Validating user', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
(6, 'Guest', 0, 1, 1, 0, 0, 0, 0, 0, 0, 0);


# --------------------------------------------------------

#
# Table structure for table `PREFIX|help`
#

DROP TABLE IF EXISTS `PREFIX|help`;
CREATE TABLE `PREFIX|help` (
  `id` int(4) NOT NULL auto_increment,
  `location` varchar(50) NOT NULL default '',
  `content` text NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci AUTO_INCREMENT=4 ;

#
# Dumping data for table `PREFIX|help`
#

INSERT INTO `PREFIX|help` (`id`, `location`, `content`) VALUES (1, 'help', 'This is the help manual'),
(2, 'rules', 'this is the forum rules'),
(3, 'guidelines', 'This is the forum guidelines.');


# --------------------------------------------------------

#
# Table structure for table `PREFIX|log_tasks`
#

DROP TABLE IF EXISTS `PREFIX|log_tasks`;
CREATE TABLE `PREFIX|log_tasks` (
  `id` int(11) NOT NULL auto_increment,
  `time` int(11) NOT NULL default '0',
  `ip` varchar(255) NOT NULL default '',
  `task` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci AUTO_INCREMENT=1 ;


# --------------------------------------------------------

#
# Table structure for table `PREFIX|mail_queue`
#

DROP TABLE IF EXISTS `PREFIX|mail_queue`;
CREATE TABLE `PREFIX|mail_queue` (
  `id` int(11) NOT NULL auto_increment,
  `to_email` varchar(250) NOT NULL default '',
  `title` varchar(250) NOT NULL default '',
  `message` text NOT NULL,
  `headers` text NOT NULL,
  PRIMARY KEY  (`id`),
  FULLTEXT KEY `message` (`message`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci AUTO_INCREMENT=2 ;


# --------------------------------------------------------

#
# Table structure for table `PREFIX|member`
#

DROP TABLE IF EXISTS `PREFIX|member`;
CREATE TABLE `PREFIX|member` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) default NULL,
  `password` varchar(50) default NULL,
  `email` varchar(50) default NULL,
  `lang` int(3) NOT NULL default '1',
  `skin_set` int(3) NOT NULL default '1',
  `signature` text,
  `avatar` varchar(200) default NULL,
  `posts` int(11) NOT NULL default '0',
  `registered` varchar(50) default NULL,
  `location` varchar(200) NOT NULL default '',
  `interests` text  NOT NULL,
  `real_name` varchar(255) NOT NULL default '',
  `birthday` date NOT NULL default '0000-00-00',
  `user_photo` varchar(255) NOT NULL default '',
  `im_networks` mediumtext NOT NULL default '',
  `websites` mediumtext NOT NULL default '',
  `allow_pm` tinyint(1) NOT NULL default '1',
  `allow_email` tinyint(1) NOT NULL default '0',
  `group` char(1) default '3',
  `title` varchar(75) NOT NULL default '',
  `use_smiley` char(1) NOT NULL default '0',
  `use_sig` char(1) NOT NULL default '1',
  `use_emailer` char(1) NOT NULL default '0',
  `show_sig` char(1) NOT NULL default '1',
  `show_avatars` char(1) NOT NULL default '1',
  `new_pms` int(3) unsigned NOT NULL default '0',
  `warnlevel` int(1) NOT NULL default '0',
  `show_pmpopup` int(1) NOT NULL default '1',
  `done_pmpopup` int(11) NOT NULL default '1',
  `memberlist_per_page` int(8) NOT NULL default '25',
  PRIMARY KEY  (`id`),
  KEY `group` (`group`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci AUTO_INCREMENT=1 ;


#
# Dumping data for table `PREFIX|member`
#

INSERT INTO `PREFIX|member`
	(`id`, `name`, `password`, `email`, `lang`, `signature`, `avatar`, `posts`,
	`registered`, `location`, `interests`, `websites`, `real_name`,
	`birthday`, `user_photo`, `im_networks`, `group`, `title`, `use_smiley`,
	`use_sig`, `use_emailer`, `show_sig`, `show_avatars`, `new_pms`, `warnlevel`,
	`show_pmpopup`, `done_pmpopup`, `memberlist_per_page`)
	VALUES
	(1, NULL, NULL, NULL, '1', NULL, NULL, '0', NULL, '', '', '', '', '', '', '',
	 '6', 'Guest', '1', '0', '0', '0', '0', '0', '0', '0', '0', '25');


# --------------------------------------------------------

#
# Table structure for table `PREFIX|member_extra`
#

DROP TABLE IF EXISTS `PREFIX|member_extra`;
CREATE TABLE `PREFIX|member_extra` (
  `mid` int(11) NOT NULL default '0',
  `act_key` varchar(255) NOT NULL default '',
  `admin_act_waiting` int(1) NOT NULL default '0',
  `conf_key` varchar(32) NOT NULL default '',
  `last_login` int(11) NOT NULL default '0',
  `time_online` int(11) NOT NULL default '0',
  `converted` smallint(1) NOT NULL default '0',
  `last_login_fail_time` int(11) NOT NULL default '0',
  `login_failiures` tinyint(3) NOT NULL default '0',
  KEY `mid` (`mid`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci;

#
# Dumping data for table `PREFIX|member_extra`
#

INSERT INTO `PREFIX|member_extra` (`mid`, `act_key`, `admin_act_waiting`) VALUES (1, '', 0);

#
# Table structure for table `PREFIX|parse_rules`
#

DROP TABLE IF EXISTS `PREFIX|parse_rules`;
CREATE TABLE `PREFIX|parse_rules` (
  `id` smallint(6) NOT NULL auto_increment,
  `descr` varchar(255) NOT NULL default '',
  `find` varchar(255) NOT NULL default '',
  `replace` tinytext NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM  DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci AUTO_INCREMENT=24 ;

#
# Dumping data for table `PREFIX|parse_rules`
#

INSERT INTO `PREFIX|parse_rules` (`id`, `descr`, `find`, `replace`) VALUES
(1, 'Strong text', '[strong]:text:[/strong]', '<strong>:text:</strong>'),
(2, 'Bold text', '[b]:text:[/b]', '<strong>:text:</strong>'),
(3, 'Emphasized text', '[em]:text:[/em]', '<em>:text:</em>'),
(4, 'Italic text', '[i]:text:[/i]', '<span class="italic">:text:</span>'),
(5, 'Underlined text', '[u]:text:[/u]', '<span class="underline">:text:</span>'),
(6, 'Deleted text', '[del]:text:[/del]', '<span class="strikethrough">:text:</span>'),
(7, 'Subscript', '[sub]:text:[/sub]', '<sub>:text:</sub>'),
(8, 'Superscript', '[sup]:text:[/sup]', '<sup>:text:</sup>'),
(9, 'Text color', '[color=:word:]:text:[/color]', '<span class="color-:word:">:text:</span>'),
(10, 'Font type', '[font=:word:]:text:[/font]', '<span class="font-:word:">:text:</span>'),
(11, 'Text align', '[align=:word:]:text:[/align]', '<span class="align-:word:">:text:</span>'),
(12, 'Font size', '[size=:number:]:text:[/size]', '<span class="size-:number:">:text:</span>'),
(13, 'Hyperlink without link text', '[url]:url:[/url]', '<a href=":url:">:url:</a>'),
(14, 'Hyperlink with link text', '[url=:url:]:text:[/url]', '<a href=":url:">:text:</a>'),
(15, 'Email link without link text', '[email]:email:[/email]', '<a href="mailto::email:">:email:</a>'),
(16, 'Email with link text', '[email=:email:]:text:[/email]', '<a href="mailto::email:">:text:</a>'),
(17, 'Wikipedia link in different languages', '[wp=:word:]:text:[/wp]', '<a href="http://:word:.wikipedia.org/wiki/:text:">:text:</a>'),
(18, 'Wikipedia link (default language)', '[wp]:text:[/wp]', '<a href="http://wikipedia.org/wiki/:text:">:text:</a>'),
(19, 'Google search', '[google]:text:[/google]', '<a href="http://google.com/search?q=:text:">:text:</a>'),
(20, 'Yahoo! search', '[yahoo]:text:[/yahoo]', '<a href="http://search.yahoo.com/search?p=:text:">:text:</a>'),
(21, 'Image without alt text', '[img]:url:[/img]', '<img src=":url:" />'),
(22, 'Image with alt text', '[img=:text:]:url:[/img]', '<img src=":url:" alt=":text:" />');
(23, 'Start of simple quote', '[quote]', '<div class="quote">\r\n	<blockquote class="quote">'),
(24, 'End of quote', '[/quote]', '</blockquote>\r\n	<div class="quote-end"></div>\r\n</div>'),
(25, 'Start of URL quote', '[quote=:url:]', '<div class="quote">\r\n	<p class="cite">From <a href="http://:url:">:url:</a></p>\r\n	<blockquote class="quote">'),
(26, 'Start ordinary unspecified quote', '[quote=:text:]', '<div class="quote">\r\n	<p class="cite">:text:</p>\r\n	<blockquote class="quote">\r\n');

#
# Table structure for table `PREFIX|pm_data`
#

DROP TABLE IF EXISTS `PREFIX|pm_data`;
CREATE TABLE `PREFIX|pm_data` (
  `id` int(11) NOT NULL auto_increment,
  `date` varchar(32) default NULL,
  `content` text NOT NULL,
  `author_id` int(11) NOT NULL default '0',
  `cc_to` text NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci;

# --------------------------------------------------------

#
# Table structure for table `PREFIX|pm`
#

DROP TABLE IF EXISTS `PREFIX|pm`;
CREATE TABLE `PREFIX|pm` (
  `id` int(11) NOT NULL auto_increment,
  `msg_id` int(11) NOT NULL default '0',
  `date` varchar(32) default NULL,
  `title` varchar(255) NOT NULL default '',
  `from_id` int(11) NOT NULL default '0',
  `to_id` int(11) NOT NULL default '0',
  `fid` int(11) NOT NULL default '1',
  `read` tinyint(1) NOT NULL default '0',
  `read_date` varchar(32) default NULL,
  `really_read` tinyint(1) NOT NULL default '0',
  `trace` tinyint(1) NOT NULL default '0',
  `belongs_to` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `msg_id` (`msg_id`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci;

# --------------------------------------------------------

#
# Table structure for table `PREFIX|pm_folders`
#

DROP TABLE IF EXISTS `PREFIX|pm_folders`;
CREATE TABLE `PREFIX|pm_folders` (
  `fid` int(6) NOT NULL auto_increment,
  `name` varchar(255) collate utf8_unicode_ci NOT NULL,
  `owner` int(11) NOT NULL default '0',
  PRIMARY KEY  (`fid`),
  KEY `name` (`name`)
) TYPE=MyISAM  DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci AUTO_INCREMENT=5 ;

#
# Dumping data for table `vboardtest_pm_folders`
#

INSERT INTO `PREFIX|pm_folders` (`fid`, `name`, `owner`) VALUES
(1, 'Inbox', 0),
(2, 'Sent Items', 0),
(3, 'Drafts', 0);

# --------------------------------------------------------

#
# Table structure for table `PREFIX|poll`
#

DROP TABLE IF EXISTS `PREFIX|poll`;
CREATE TABLE `PREFIX|poll` (
  `tid` int(11) NOT NULL default '0',
  `name` varchar(250) NOT NULL default '',
  `votes` int(11) NOT NULL default '0',
  UNIQUE KEY `tid` (`tid`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci COMMENT='tid=topic id, name=poll question/name, votes=int votes';


# --------------------------------------------------------

#
# Table structure for table `PREFIX|poll_choices`
#

DROP TABLE IF EXISTS `PREFIX|poll_choices`;
CREATE TABLE `PREFIX|poll_choices` (
  `id` int(11) NOT NULL auto_increment,
  `pid` int(11) NOT NULL default '0',
  `question` varchar(250) NOT NULL default '',
  `votes` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `pid` (`pid`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci COMMENT='id=choice id, pid=poll id, question=the question, votes=int ' AUTO_INCREMENT=1 ;


# --------------------------------------------------------

#
# Table structure for table `PREFIX|post`
#

DROP TABLE IF EXISTS `PREFIX|post`;
CREATE TABLE `PREFIX|post` (
  `id` int(11) NOT NULL auto_increment,
  `tid` int(11) NOT NULL,
  `author_name` varchar(50) default NULL,
  `author_id` int(11) NOT NULL,
  `posted` int(11) default NULL,
  `post` text,
  `ip` varchar(15) NOT NULL default '',
  `queued` tinyint(1) NOT NULL default '0',
  `times_edited` int(11) NOT NULL default '0',
  `last_edit` int(11) NOT NULL,
  `last_edit_by` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `tid` (`tid`,`id`,`queued`),
  KEY `author_id` (`author_id`),
  FULLTEXT KEY `post` (`post`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci AUTO_INCREMENT=2 ;


# --------------------------------------------------------

#
# Table structure for table `PREFIX|reg_antispam`
#

DROP TABLE IF EXISTS `PREFIX|reg_antispam`;
CREATE TABLE `PREFIX|reg_antispam` (
  `id` int(9) unsigned NOT NULL auto_increment,
  `ip` varchar(50) NOT NULL default '',
  `browser` varchar(100) NOT NULL default '',
  `time` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `ip` (`ip`,`browser`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci AUTO_INCREMENT=2 ;


# --------------------------------------------------------

#
# Table structure for table `PREFIX|reported`
#

DROP TABLE IF EXISTS `PREFIX|reported`;
CREATE TABLE `PREFIX|reported` (
  `id` int(11) NOT NULL auto_increment,
  `uid` int(11) NOT NULL default '0',
  `pid` int(11) NOT NULL default '0',
  `time` int(11) NOT NULL default '0',
  `status` int(1) NOT NULL default '1',
  `message` text NOT NULL,
  `comment` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `uid` (`uid`,`status`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci;


# --------------------------------------------------------

#
# Table structure for table `PREFIX|sessions`
#

DROP TABLE IF EXISTS `PREFIX|sessions`;
CREATE TABLE `PREFIX|sessions` (
  `sid` varchar(100) NOT NULL default '',
  `uid` int(11) NOT NULL default '1',
  `time` int(11) default NULL,
  `stayin` int(1) default '0',
  `hide` int(1) default '0',
  `ip` varchar(16) NOT NULL default '',
  `browser` varchar(50) NOT NULL default '',
  `user` varchar(32) NOT NULL default '',
  `group` char(1) NOT NULL default '6',
  PRIMARY KEY  (sid(50)),
  KEY `browser` (browser(50)),
  KEY `ip` (`ip`),
  KEY `group` (`group`)
) TYPE=HEAP DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci;


# --------------------------------------------------------

#
# Table structure for table `PREFIX|smiley`
#

DROP TABLE IF EXISTS `PREFIX|smiley`;
CREATE TABLE `PREFIX|smiley` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) default NULL,
  `url` varchar(250) default NULL,
  `code` varchar(50) NOT NULL default '',
  `show` char(1) default '1',
  `set_id` int(3) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `code` (`code`),
  KEY `id` (`id`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci AUTO_INCREMENT=14 ;

#
# Dumping data for table `PREFIX|smiley`
#

INSERT INTO `PREFIX|smiley` (`id`, `name`, `url`, `code`, `show`, `set_id`) VALUES
	(1, 'Angel', 'face-angel.gif', ':angel:', '1', '1'),
	(2, 'Crying', 'face-crying.gif', ':cry:', '1', '1'),
	(3, 'Devil', 'face-devil-grin.gif', ':devil:', '1', '1'),
	(4, 'Nerd', 'face-glasses.gif', ':nerd:', '1', '1'),
	(5, 'Grin', 'face-grin.gif', ':grin:', '1', '1'),
	(6, 'Kiss', 'face-kiss.gif', ':love:', '1', '1'),
	(7, 'Monkey', 'face-monkey.gif', ':monkey:', '1', '1'),
	(8, 'Sad', 'face-sad.gif', ':(', '1', '1'),
	(9, 'Smile', 'face-smile.gif', ':)', '1', '1'),
	(10, 'Big Smile', 'face-smile-big.gif', ':D', '1', '1'),
	(11, 'Surprised', 'face-surprise.gif', ':o', '1', '1'),
	(12, 'Wink', 'face-wink.gif', ';)', '1', '1'),
	(13, 'Plain', 'face-plain.gif', ':|', '1', '1');

# --------------------------------------------------------

#
# Table structure for table `PREFIX|stats`
#

DROP TABLE IF EXISTS `PREFIX|stats`;
CREATE TABLE `PREFIX|stats` (
  `id` int(11) NOT NULL auto_increment,
  `total_posts` varchar(50) default NULL,
  `total_topics` varchar(50) default NULL,
  `total_users` varchar(50) default NULL,
  `max_users_online` int(6) NOT NULL default '0',
  `max_users_date` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci AUTO_INCREMENT=2 ;

#
# Dumping data for table `PREFIX|stats`
#

INSERT INTO `PREFIX|stats` (`id`, `total_posts`, `total_topics`, `total_users`, `max_users_online`, `max_users_date`) VALUES (1, '1', '1', '1', 0, 0);


# --------------------------------------------------------

#
# Table structure for table `PREFIX|subscr_forum`
#

DROP TABLE IF EXISTS `PREFIX|subscr_forum`;
CREATE TABLE `PREFIX|subscr_forum` (
  `id` int(11) NOT NULL auto_increment,
  `uid` int(11) NOT NULL default '0',
  `fid` int(6) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `fid` (`fid`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci AUTO_INCREMENT=1 ;


# --------------------------------------------------------

# Table structure for table `PREFIX|subscr_topic`
#
DROP TABLE IF EXISTS `PREFIX|subscr_topic`;
CREATE TABLE `PREFIX|subscr_topic` (
	`id` int(11) NOT NULL auto_increment,
	`uid` int(11) NOT NULL default '0',
	`tid` int(6) NOT NULL default '0',
PRIMARY KEY  (`id`),
KEY `fid` (`tid`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci AUTO_INCREMENT=1 ;
# --------------------------------------------------------
#

#
# Table structure for table `PREFIX|template`
#

DROP TABLE IF EXISTS `PREFIX|template`;
CREATE TABLE `PREFIX|template` (
  `id` int(11) NOT NULL auto_increment,
  `set_id` int(11) NOT NULL default '0',
  `name` varchar(200) NOT NULL default '',
  `nice_name` varchar(250) NOT NULL default 'unnamed',
  `cat` int(3) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `set_id` (`set_id`,`name`),
  KEY `cat` (`cat`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci;


# --------------------------------------------------------

#
# Table structure for table `PREFIX|topic`
#

DROP TABLE IF EXISTS `PREFIX|topic`;
CREATE TABLE `PREFIX|topic` (
  `id` int(11) NOT NULL auto_increment,
  `forum` int(6) NOT NULL default '0',
  `cat` int(6) default '0',
  `title` varchar(75) default NULL,
  `status` tinyint(1) default NULL,
  `replies` int(10) default NULL,
  `views` int(10) default NULL,
  `sticky` tinyint(1) NOT NULL default '0',
  `starter_id` int(10) default NULL,
  `starter_name` varchar(50) default NULL,
  `started` int(11) NOT NULL default '0',
  `lpost_name` varchar(50) default NULL,
  `lpost_id` int(10) NOT NULL default '0',
  `lpost_uid` int(11) NOT NULL default '0',
  `lpost_time` int(11) default NULL,
  `has_poll` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`,`forum`),
  KEY `status` (`status`),
  KEY `lpost_time` (`lpost_time`),
  KEY `started` (`started`)
) TYPE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci;



#TEMPLATE SETS
INSERT INTO `PREFIX|template_sets` VALUES (1, '1', 'Vikingboard default theme');

#TEMPLATE HTML CODE
INSERT INTO `PREFIX|template` VALUES (1, 1, 'mainmenu_member', 'Menu for members', '11');

INSERT INTO `PREFIX|template` VALUES (2, 1, 'list_forum', 'Forumrow', '13');

INSERT INTO `PREFIX|template` VALUES (3, 1, 'wrapper', 'Forum wrapper', '11');

INSERT INTO `PREFIX|template` VALUES (4, 1, 'frontpage', 'Frontpage', '13');

INSERT INTO `PREFIX|template` VALUES (5, 1, 'mainmenu_guest', 'Menu for guests', '11');

INSERT INTO `PREFIX|template` VALUES (6, 1, 'message', 'Error-message page', '11');

INSERT INTO `PREFIX|template` VALUES (7, 1, 'list_category', 'Categoryrow', '0');

INSERT INTO `PREFIX|template` VALUES (9, 1, 'showtopic_body', 'Topic page', '6');

INSERT INTO `PREFIX|template` VALUES (10, 1, 'showtopic_post', 'Postrow', '6');

INSERT INTO `PREFIX|template` VALUES (11, 1, 'list_topic', 'Topicrow', '12');

INSERT INTO `PREFIX|template` VALUES (12, 1, 'forum', 'Forum page', '12');

INSERT INTO `PREFIX|template` VALUES (13, 1, 'notification', 'Notification Page', '11');

INSERT INTO `PREFIX|template` VALUES (14, 1, 'help', 'Help Pages', '11');

INSERT INTO `PREFIX|template` VALUES (15, 1, 'post_buttons', 'Posting buttons', '7');

INSERT INTO `PREFIX|template` VALUES (16, 1, 'post_body', 'Post page', '7');

INSERT INTO `PREFIX|template` VALUES (18, 1, 'register', 'Registration page', '0');

INSERT INTO `PREFIX|template` VALUES (19, 1, 'login', 'Login page', '11');

INSERT INTO `PREFIX|template` VALUES (20, 1, 'user_cp_menu', 'User CP | Menu', '4');

INSERT INTO `PREFIX|template` VALUES (21, 1, 'user_cp_frontpage', 'User CP | Frontpage', '4');

INSERT INTO `PREFIX|template` VALUES (22, 1, 'user_cp_profile', 'User CP | Profile', '4');

INSERT INTO `PREFIX|template` VALUES (23, 1, 'profile', 'User profile', '0');

INSERT INTO `PREFIX|template` VALUES (24, 1, 'user_cp_signature', 'User CP | Signature', '4');

INSERT INTO `PREFIX|template` VALUES (25, 1, 'user_cp_pm_send', 'User CP | Send PM', '4');

INSERT INTO `PREFIX|template` VALUES (26, 1, 'post_buttons_pm', 'PM | Posting buttons', '4');

INSERT INTO `PREFIX|template` VALUES (27, 1, 'user_cp_pm_inbox', 'User CP | PM Inbox', '4');

INSERT INTO `PREFIX|template` VALUES (28, 1, 'user_cp_avatar', 'User CP | Avatar', '4');

INSERT INTO `PREFIX|template` VALUES (29, 1, 'user_cp_trace_pm', 'User CP | Trace PM', '4');

INSERT INTO `PREFIX|template` VALUES (30, 1, 'user_cp_trace_pm_readrow', 'User CP | Trace PM | Read messages row', '4');

INSERT INTO `PREFIX|template` VALUES (31, 1, 'user_cp_trace_pm_unreadrow', 'User CP | Trace PM | Unread messages row', '4');

INSERT INTO `PREFIX|template` VALUES (32, 1, 'user_cp_trace_pm_no_trace', 'User CP | Trace PM | Nothing to trace row', '4');

INSERT INTO `PREFIX|template` VALUES (33, 1, 'user_cp_inbox_row', 'User CP | PM Inbox row', '4');

INSERT INTO `PREFIX|template` VALUES (34, 1, 'user_cp_inbox_nopm', 'User CP | PM Inbox | No pm row', '4');

INSERT INTO `PREFIX|template` VALUES (35, 1, 'navigation_start', 'Navigation | start', '5');

INSERT INTO `PREFIX|template` VALUES (36, 1, 'navigation_link', 'Navigation | link', '5');

INSERT INTO `PREFIX|template` VALUES (37, 1, 'navigation_end', 'Navigation | end', '5');

INSERT INTO `PREFIX|template` VALUES (38, 1, 'post_quick_reply', 'Post | Quick Reply', '6');

INSERT INTO `PREFIX|template` VALUES (39, 1, 'Memberlist', 'Memberlist', '0');

INSERT INTO `PREFIX|template` VALUES (40, 1, 'memberlist_data', 'memberlist_data', '0');

INSERT INTO `PREFIX|template` VALUES (41, 1, 'report_post', 'Report post', '7');

INSERT INTO `PREFIX|template` VALUES (42, 1, 'user_cp_read_pm', 'User CP | Read PM', '4');

INSERT INTO `PREFIX|template` VALUES (43, 1, 'basic_link', 'A simple link', '11');

INSERT INTO `PREFIX|template` VALUES (44, 1, 'confirm', 'Confirm dialogue', '11');

INSERT INTO `PREFIX|template` VALUES (45, 1, 'adminwrapper', 'Admin - Wrapper', '3');

INSERT INTO `PREFIX|template` VALUES (46, 1, 'adminmenu', 'Admin - Menu', '3');

INSERT INTO `PREFIX|template` VALUES (47, 1, 'admin_tpl_main', 'Template admin - mainpage', '2');

INSERT INTO `PREFIX|template` VALUES (48, 1, 'admin_tpl_listset', 'Template admin - list template set', '2');

INSERT INTO `PREFIX|template` VALUES (49, 1, 'admin-tpl_listcat', 'List categories in active set', '2');

INSERT INTO `PREFIX|template` VALUES (50, 1, 'admin-tpl_listtpl', 'Template admin - List templates in category', '2');

INSERT INTO `PREFIX|template` VALUES (51, 1, 'admin-tpl_editor', 'Template editor page', '2');

INSERT INTO `PREFIX|template` VALUES (52, 1, 'admin-tpl_addcode', 'Add template code form', '2');

INSERT INTO `PREFIX|template` VALUES (53, 1, 'admin_forums_deleteforum', 'Admin CP | Forums - Delete forum', '10');

INSERT INTO `PREFIX|template` VALUES (54, 1, 'admin-tpl_addcategory', 'Add template category form', '2');

INSERT INTO `PREFIX|template` VALUES (55, 1, 'adm_conf_global_startgroup', 'Global config - startGroup', '8');

INSERT INTO `PREFIX|template` VALUES (56, 1, 'adm_conf_global_textbox', 'Global config - a textbox', '8');

INSERT INTO `PREFIX|template` VALUES (57, 1, 'admin_forums_addcat', 'Admin CP | Forums - Add category', '10');

INSERT INTO `PREFIX|template` VALUES (58, 1, 'adm_conf_global_drop_content', 'Global config - a drop down content', '8');

INSERT INTO `PREFIX|template` VALUES (59, 1, 'adm_conf_global_drop_wrap', 'Global config - a drop down wrapper', '8');

INSERT INTO `PREFIX|template` VALUES (60, 1, 'adm_conf_global_setting_wrap', 'Global config - showSetting', '8');

INSERT INTO `PREFIX|template` VALUES (61, 1, 'adm_conf_global_endSubGroup', 'Global config - endSubGroup', '8');

INSERT INTO `PREFIX|template` VALUES (62, 1, 'adm_conf_global_endGroup', 'Global config - endGroup', '8');

INSERT INTO `PREFIX|template` VALUES (63, 1, 'adm_conf_global', 'Global config - wrapper', '8');

INSERT INTO `PREFIX|template` VALUES (64, 1, 'admin_index', 'Frontpage', '3');

INSERT INTO `PREFIX|template` VALUES (65, 1, 'admin_cachemanager', 'Cachemanager - wrapper', '9');

INSERT INTO `PREFIX|template` VALUES (66, 1, 'admin_cache_startList', 'Cachemanager - startRow', '9');

INSERT INTO `PREFIX|template` VALUES (67, 1, 'admin_cache_row', 'Cachemanager - Row', '9');

INSERT INTO `PREFIX|template` VALUES (68, 1, 'admin_cache_endtList', 'Cachemanager - endRow', '9');

INSERT INTO `PREFIX|template` VALUES (69, 1, 'admin_forums_main', 'Forums - Forumlisting', '10');

INSERT INTO `PREFIX|template` VALUES (70, 1, 'admin_forums_cat', 'Forums - renderCategory', '10');

INSERT INTO `PREFIX|template` VALUES (71, 1, 'admin_forums_forums', 'Forums - renderForum', '10');

INSERT INTO `PREFIX|template` VALUES (72, 1, 'admin_forums_editcat', 'Forums - Edit Category', '10');

INSERT INTO `PREFIX|template` VALUES (73, 1, 'dropdown_start', 'Dropdown - start', '11');

INSERT INTO `PREFIX|template` VALUES (74, 1, 'dropdown_end', 'Dropdown - end', '11');

INSERT INTO `PREFIX|template` VALUES (75, 1, 'dropdown_option', 'Dropdown - Row', '11');

INSERT INTO `PREFIX|template` VALUES (77, 1, 'admin_forums_addforum', 'Forums - Add forum', '10');

INSERT INTO `PREFIX|template` VALUES (78, 1, 'gotnewposts_code', 'Forum - new posts html', '13');

INSERT INTO `PREFIX|template` VALUES (79, 1, 'donthavenewposts_code', 'Forum - no new posts html', '13');

INSERT INTO `PREFIX|template` VALUES (80, 1, 'forum_lastpostlink', 'Forum - Lastpost link', '13');

INSERT INTO `PREFIX|template` VALUES (81, 1, 'search_frontpage', 'Search - Frontpage', '14');

INSERT INTO `PREFIX|template` VALUES (82, 1, 'search_result_wrapper', 'Search - Resultswrapper', '14');

INSERT INTO `PREFIX|template` VALUES (83, 1, 'search_result_defaultrow', 'Search - ResultRow - Standard', '14');

INSERT INTO `PREFIX|template` VALUES (84, 1, 'search_result_extendedrow', 'Search - ResultRow - Inline', '14');

INSERT INTO `PREFIX|template` VALUES (85, 1, 'admin_tasklog_main', 'Task log - wrapper/main', '15');

INSERT INTO `PREFIX|template` VALUES (86, 1, 'admin_tasklog_row', 'Task log - Row', '15');

INSERT INTO `PREFIX|template` VALUES (87, 1, 'admin_cache_viewraw', 'Cachemanager - View cache data', '9');

INSERT INTO `PREFIX|template` VALUES (88, 1, 'admin_cencor_list', 'Word Cencor - main page', '16');

INSERT INTO `PREFIX|template` VALUES (89, 1, 'admin_languages', 'Frontpage', '17');

INSERT INTO `PREFIX|template` VALUES (90, 1, 'admin_languages_row', 'Frontpage - languageRow', '17');

INSERT INTO `PREFIX|template` VALUES (91, 1, 'admin_languages_editlang', 'Language - Edit language file', '17');

INSERT INTO `PREFIX|template` VALUES (92, 1, 'admin_languages_lang_category', 'Language - language Category', '17');

INSERT INTO `PREFIX|template` VALUES (93, 1, 'admin_languages_wordRow', 'language - wordRow', '17');

INSERT INTO `PREFIX|template` VALUES (94, 1, 'lostpass_frontpage', 'Lost password frontpage', '0');

INSERT INTO `PREFIX|template` VALUES (95, 1, 'lostpass_new_pass', 'Lost password, new password form', '0');

INSERT INTO `PREFIX|template` VALUES (96, 1, 'lostpass_multi_frontpage', 'Lost password frontpage (with multi_reg on)', '0');

INSERT INTO `PREFIX|template` VALUES (97, 1, 'lostpass_multi_new_pass', 'Lost password, new password form (with multi_reg on)', '0');

INSERT INTO `PREFIX|template` VALUES (98, 1, 'admin_cencor_row', 'Word Cencor - row', '16');

INSERT INTO `PREFIX|template` VALUES (99, 1, 'adm_conf_site', 'Site config - Wrapper', '8');

INSERT INTO `PREFIX|template` VALUES (100, 1, 'admin_forums_editforum', 'Admin CP | Forums - Edit forum', '10');

INSERT INTO `PREFIX|template` VALUES (101, 1, 'search_topic_row', 'Search - TopicRow', '14');

INSERT INTO `PREFIX|template` VALUES (104, 1, 'buttons_newpost', 'New post buttons', '6');

INSERT INTO `PREFIX|template` VALUES (105, 1, 'admin-tpl_usermanage_add', 'Form for add_user in admincp.', '18');

INSERT INTO `PREFIX|template` VALUES (106, 1, 'admin-tpl_usermanage_drop', 'Drop user in ADMIN CP', '18');

INSERT INTO `PREFIX|template` VALUES (107, 1, 'admin-tpl_user_edit_field', 'Admin CP - Edit User loop fields', '18');

INSERT INTO `PREFIX|template` VALUES (108, 1, 'admin_user_edit', 'Admin CP - Edit User', '18');

INSERT INTO `PREFIX|template` VALUES (109, 1, 'admin_edit_user_frontpage', 'Admin CP | Edit User frontpage', '18');

INSERT INTO `PREFIX|template` VALUES (110, 1, 'admin-tpl_user_input', 'input for Admin CP user mng.', '18');

INSERT INTO `PREFIX|template` VALUES (111, 1, 'admin-tpl_user_textarea', 'Textarea input for Admin CP user mng.', '18');

INSERT INTO `PREFIX|template` VALUES (112, 1, 'admin-tpl_user_ban', 'Ban a user in Admin CP.', '18');

INSERT INTO `PREFIX|template` VALUES (113, 1, 'admin-tpl_user_ban_list', 'Banlist template for ADMIN CP', '18');

INSERT INTO `PREFIX|template` VALUES (114, 1, 'admin-tpl_user_select', 'Select for admin CP', '18');

INSERT INTO `PREFIX|template` VALUES (115, 1, 'admin_backup_frontpage', 'Frontpage', '19');

INSERT INTO `PREFIX|template` VALUES (116, 1, 'user_cp_subscr_forum', 'User CP | Subscriptions | Forum', '4');

INSERT INTO `PREFIX|template` VALUES (117, 1, 'user_cp_subscr_forum_row', 'User CP | Subscriptions | Forum row', '4');

INSERT INTO `PREFIX|template` VALUES (118, 1, 'user_cp_subscr_no_forum', 'User CP | Subscriptions | No forum', '4');

INSERT INTO `PREFIX|template` VALUES (119, 1, 'user_cp_subscr_topic', 'User CP | Subscriptions | Topic', '4');

INSERT INTO `PREFIX|template` VALUES (120, 1, 'user_cp_subscr_topic_row', 'User CP | Subscriptions | Topic row', '4');

INSERT INTO `PREFIX|template` VALUES (121, 1, 'user_cp_subscr_no_topic', 'User CP | Subscriptions | No topic', '4');

INSERT INTO `PREFIX|template` VALUES (122, 1, 'no_forum', 'Forumrow - No forum', '13');

INSERT INTO `PREFIX|template` VALUES (123, 1, 'extended_cat', 'Frontpage - Extended categories', '13');

INSERT INTO `PREFIX|template` VALUES (124, 1, 'admin_forums_deletecat', 'Admin CP | Forums - Delete category', '10');

INSERT INTO `PREFIX|template` VALUES (125, 1, 'admin_help_index', 'Admin CP | Help pages index', '19');

INSERT INTO `PREFIX|template` VALUES (126, 1, 'admin_forums_endcat', 'Admin CP | Forums - End of categoryrow', '10');

INSERT INTO `PREFIX|template` VALUES (127, 1, 'empty_row', 'Empty row', '11');

INSERT INTO `PREFIX|template` VALUES (128, 1, 'admin-reported_post', 'Reported post', '19');

INSERT INTO `PREFIX|template` VALUES (129, 1, 'admin-reported_posts', 'Reported posts', '19');

INSERT INTO `PREFIX|template` VALUES (130, 1, 'admin-reported_post_row', 'Reported post row', '19');

INSERT INTO `PREFIX|template` VALUES (131, 1, 'framed_image', 'Image with frame', '11');

INSERT INTO `PREFIX|template` VALUES (132, 1, 'smiley', 'Smiley insert code', '11');

INSERT INTO `PREFIX|template` VALUES (133, 1, 'navigation_no_link', 'Navigation | Without link', '5');

INSERT INTO `PREFIX|template` VALUES (134, 1, 'smileylist', 'Smiley list', '7');

INSERT INTO `PREFIX|template` VALUES (135, 1, 'list_item_link', 'List item with link', '0');

INSERT INTO `PREFIX|template` VALUES (136, 1, 'profile_website_link', 'Definition list item for profile', '0');

INSERT INTO `PREFIX|template` VALUES (137, 1, 'im_network', 'IM network in profile', '0');

INSERT INTO `PREFIX|template` VALUES (138, 1, 'viewTopic', 'View Topic', '6');







##important: NEVER have a semicolon (;) followed by a linebreak at the end of this file. It will mess up everything. :)
