<?php

/**
 * Register
 *
 * The perfect place to go for the fresh peepz that want to
 * join our nifty forum. Let's them register to the forum,
 * in other words.
 *
 * @package Vikingboard
 * @author Tor Henning Ueland <tor.henning@vikingboard.com>
 * @author Marius Pedersen Taule <marius@vikingboard.com>
 * @version 0.2.0
 *
 * $Id: register.php 1876 2007-11-27 21:31:17Z jorgenboard $
 */

// Yes, we are here
define('VBOARD', __FILE__);

// Include the kernel
include ('inc/kernel.php');

/**
 * Register class
 */
class Register
{
	var $data;
	var $user;
	var $screen;
	var $config;
	var $lang;

	function Register(&$data, &$user,& $screen, &$config)
	{
		//Set up some vars
		$this->data		=	&$data;
		$this->user		=	&$user;
		$this->screen	=	&$screen;
		$this->config	=	&$config;
		$this->lang		=	new lang_register;
		$this->screen->set_lang('lang_register');

		// Doh, already registered! Logged in, too, how stupid can one get?
		if($this->user->id != '1')
		{
			redirect('index.php');
		}

		// What to do?
		switch (true)
		{
			case isset($_GET['register']) :
				$this->register_member();
			break;

			case isset($_GET['activate']) :
				$this->activate_member();
			break;

			default :
				$this->register_form();
			break;
		}
/*		$mode	=	ifsetor($_GET['m'], false);
		switch($mode)
		{
			case 'register':
			$this->register_member();
			break;

			case 'activate':
			$this->activate_member();
			break;

			default:
			$this->register_form();
			break;
		}*/
	}


	/**
	 * Register form
	 */
	function register_form()
	{
		// Get the forum rules
		$rules	=	$this->data->cachedQuery('get_help_topics', array('rules'));
		$rules	=	$rules[0]->content;

		// Put them into a nice little array
		$html	=	array
		(
			'forum_rules' => $rules,
		);

		/**
		 * Templating
		 */

		$navigation	=	array
		(
			'register.php'	=>	$this->lang->register,
		);

		$this->screen->add_html('register', $html);
		$this->screen->add_wrapper($this->lang->register, $navigation);
		$this->screen->print_page();
	}

	/**
	 * Register member
	 *
	 */
	function register_member()
	{
		// Post data
		$username		=	ifsetor($_POST['username'], false);
		$password		=	ifsetor($_POST['password'], false);
		$password_conf	=	ifsetor($_POST['repeat_password'], false);
		$email			=	ifsetor($_POST['email'], false);
		$email_conf		=	ifsetor($_POST['repeat_email'], false);
		$agree			=	ifsetor($_POST['agree'], false);

		$lang_global	=	new lang_global;

		$link	=	'register.php';

		// Huston, do we have a username?
		if (!$username)
		{
			notify($this->lang->reg_error, $this->lang->no_usrname, $link);
		}

		// Did the user type something in both the password fields?
		if (!$password || !$password_conf)
		{
			notify($this->lang->reg_error, $this->lang->no_passwd, $link);
		}

		// Does the password fields contains the same data?
		if ($password != $password_conf)
		{
			notify($this->lang->reg_error, $this->lang->passwd_un, $link);
		}

		// Did the user type in the email address in both fields?
		if (!$email || !$email_conf)
		{
			notify($this->lang->reg_error, $this->lang->email_null, $link);
		}

		// Is the email address valid?
		if (!is_valid_email_address($email))
		{
			notify($this->lang->reg_error, $this->lang->no_alfa, $link);
		}

		// Do we allow multible registrations from the same email adress?
		if ($this->config->multi_reg == 0)
		{
			$multimail	=	$this->data->query('get_num_emails', array($email));
            if (isset($multimail[0]))
			{
				notify($this->lang->reg_error, $this->lang->mail_full, $link);
			}
		}

		// Does the email addresses match eachother?
		if ($email != $email_conf)
		{
			notify($this->lang->reg_error, $this->lang->email_un, $link);
		}

		// Scream out if the user don`t accept the forum rules.
		if (!$agree)
		{
			/**
			 * The choice between doing ten years and taking out some
			 * stupid motherfucker, ain't no choice at all. But I ain't
			 * no madman.
			 */
			notify($this->lang->reg_error, $this->lang->rules_dis, $link);
		}

		// Check for "wrong" input
		$username = htmlentities($username);
		$username = strip_tags($username);

		// Check the minimum length for the password
		if (strlen($password) < (int)$this->config->password_length)
		{
			notify($this->lang->reg_error, str_replace('%chars%', $this->config->password_length, $this->lang->too_short_password), $link);
		}

		// Check for the minimum password complexity
		if (password_strength($password) < (int)$this->config->password_strength)
		{
			notify($this->lang->reg_error, $this->lang->too_simple_password, $link);
		}

		// Check for minimum username length
		if (strlen($username) < (int)$this->config->username_length)
		{
			notify($this->lang->reg_error, str_replace('%chars%', $this->config->username_length, $this->lang->too_short_username), $link);
		}

		// Checking the username to make sure that we don't get me, myself and I.
		$usr_numcheck	=	$this->data->query('get_id_from_username', array($username));

		if (isset($usr_numcheck[0]))
		{
			// Username already taken, sorry dude
			notify($this->lang->reg_error, $this->lang->name_taken, $link);
		}

		// Anti spam check
		$a_ip		=	$_SERVER['REMOTE_ADDR'];
		$a_browser	=	$_SERVER['HTTP_USER_AGENT'];

		// Inserting a new row
		$this->data->query('insert_register_antispam_data', array($a_ip, $a_browser));

		// Checking the anti-spam list
		$antispam	=	$this->data->query('get_register_antispam_data', array($a_ip, $a_browser));

		if (count($antispam) > 1)
		{
			// Ey, we got a spammer!
			notify($this->lang->reg_error, $this->lang->antispam_act, $link);
		}

		/**
		 * The user is AOK, lets register "it".
		 */

		// Salt the password with some sweet seeds
		$password = encrypt($password);

		// Stats update:)
		$this->data->query('update_user_stats');

		// No activation is needed
		if ($this->config->reg_act == '0')
		{
			// Putting the user into the DB
			$this->data->query('insert_new_user_data', array($username, $password, $email, $this->config->reg_group));

			// Finding the latest ID so we can add it to the member_extra table
			$new_id	=	$this->data->query('get_latest_user');
			$new_id	=	$new_id[0]->id;
			$this->data->query('insert_extra_user_data', array($new_id));

			// Done, inform the happy newkid :)
			notify($this->lang->register, $this->lang->welcome, 'index.php', $this->lang->frontpage);
		}
		// The user must activate the account via mail
		else if ($this->config->reg_act == '1')
		{
			// Putting the user into the DB
			$this->data->query('insert_new_user_data', array($username, $password, $email, 5));

			// Finding the latest ID so we can add it to the member_extra table
			$new_id	=	$this->data->query('get_latest_user');
			$new_id	=	$new_id[0]->id;
			$this->data->query('insert_extra_user_data', array($new_id));

			// Creating and inserting a activation key
			$act_key	=	md5(forumtime() .  $reg_username . $reg_email1);

			$this->data->query('insert_new_update_key', array($act_key, $new_id, ));

			// Make mail!
			$lang_email	=	new	lang_emails;
			$mail_body	=	str_replace('%activation_url%', $this->config->forum_url . 'register.php?activate&key=' . $act_key, $lang_email->newuser_act);
			$mail_title	=	str_replace('%board_name%', $this->config->forum_name, $lang_email->tit_newuser);

			// Off, off and away! Hopefully, that is.
			emailer($new_id, $mail_title, $mail_body);

			// Done, inform the happy newkid :)
			notify($this->lang->registration_ok, $this->lang->regmail_sendt, 'index.php', $this->lang->frontpage);
		}

		/**
		 * @todo Admin activation
		 */
		//An admin must activate the account
		if ($this->config->reg_act =='2')
		{
			//putting the user into the DB
			$this->data->query('insert_new_user_data', array($username, $password, $email, 5));

			$new_id	=	$this->data->query('get_latest_user');
			$new_id	=	$new_id[0];
			$new_id	=	$new_id->id;
			$this->data->query('insert_extra_user_data', array($new_id));

			//send a message to the new registered user.
		}
	}


	/**
	 * Activate member
	 *
	 * Activates "deactivated" members. We don't want anyone left out of the
	 * party, do we?
	 */
	function activate_member()
	{
		// Variables to use
		$register_key	=	ifsetor($_GET['key'], 0);

		// Making sure that we got a key.
		if (!$register_key)
		{
			notify($this->lang->activation_error, $this->lang->no_regkey, 'index.php');
		}

		// So, is this key valid?
		$check_key	=	$this->data->query('get_check_regkey', array($register_key));

		if (!$check_key[0])
		{
			notify($this->lang->activation_error, $this->lang->regkey_invalid, 'index.php');
		}

		// Weeel everything seems fine, let`s activate then :)
		$check_key	=	$check_key[0];

		// whoops, is this a hacing attempt?
		$keyowner	=	$this->data->query('get_key_owner', array($register_key));
		$keyowner	=	$keyowner[0];
		if ($keyowner->mid != $check_key->mid)
		{
			notify($this->lang->activation_error, $this->lang->wrongkey, 'index.php');
		}
		else
		{
			// Puh, goodie :)
			$this->data->query('update_activated_user_group', array($keyowner->mid, $this->config->reg_group));
			$this->data->query('update_activated_user_key', array($keyowner->mid));
			notify($this->lang->activation_ok, $this->lang->account_activated, 'index.php', $this->lang->frontpage);
		}
	}
}

$R	=	new Register($data, $user, $screen, $config);

?>
