<?php
/**
 * @package Vikingboard
 * @author Tor Henning Ueland <tor.henning@vikingboard.com>
 * @author Marius Pedersen Taule <marius@vikingboard.com>
 * @version 0.2.0
 *
 * $Id: report.php 1678 2007-09-04 20:25:02Z jorgenboard $
 */

//yes, we are here
define('VBOARD', __FILE__);

// Get the kernel
require_once('inc/kernel.php');

/**
 * Report post class
 */
class report
{
	// Define some variables
	var $data;
	var $user;
	var $screen;
	var $config;
	var $lang;
	var $lang_global;

	/**
	 * Report post constructor
	 */
	function report(&$data, &$user,& $screen, &$config)
	{
		// Setup some vars
		$this->data			=	&$data;
		$this->user			=	&$user;
		$this->screen		=	&$screen;
		$this->config		=	&$config;
		$this->lang			=	new lang_report_post;

		$this->screen->set_lang('lang_report_post');

		// What to do?
		switch (1)
		{
			case isset($_GET['send']):
			$this->save_report();
			break;

			default:
			$this->report_post();
			break;
		}
	}

	/**
	 * Save report
	 *
	 * Adds the report to the database
	 */
	function save_report()
	{
		$id			=	safe_user_int('id', false);
		$message	=	htmlspecialchars($_POST['message']);

		// No user input?
		if (!$message || !$id)
		{
			/**
			 * @todo Make the error_msg() show backlinks, headers ++
			 */
			error_msg($this->lang->report_post, $this->lang->missing_data, 'report.php?p=' . $id);
		}

		// Save to database
		$this->data->query('insert_new_report', array($id, $this->user->id, $message));

		notify($this->lang->report_post, $this->lang->report_ok);
	}

	/**
	 * Report post
	 *
	 * Displays the form used to report a post
	 */
	function report_post()
	{
		// The reported post
		$id	=	safe_user_int('p', false);

		// No post to report or if reporter is a guest
		if (!$id || $this->user->id == 1)
		{
			redirect('index.php');
		}

		// Get some data
		$topic	=	$this->data->cachedQuery('get_topic_information', array($id));
		$topic	=   $topic[0];

		if (!$topic->id)
		{
			redirect('index.php');
		}

		// Navigation
		$navigation	=	array(
			'index.php?c=' . $topic->catid	=>	$topic->catname,
			'forum.php?f=' . $topic->fid	=>	$topic->fname,
			'topic.php?t=' . $topic->id		=>	$topic->title,
			'report.php?p=' . $id			=>	$this->lang->report_post
		);

		// Html it
		$html	=	array(
			'reported-post'	=>	str_replace('%topic%', $topic->title, str_replace('%topic_id%', $topic->id, $this->lang->reported_post)),
			'id'			=>	$id
		);

		//add html to output
		$this->screen->add_html('report_post', $html);

		//add navigation to output and wrap it nicely up
		$this->screen->add_wrapper($this->lang->report_post, $navigation);

		//print page
		$this->screen->print_page();
	}
}

$report	=	new report($data, $user, $screen, $config);

?>