<?php


/**
 * Vikingboard upgrade script.
 *
 * NOTE:
 * THIS FILE USES IT`S OWN CSS/HTML,
 * THIS BECAUSE THIS SCRIPT IS SUPPOSED
 * TO WORK EVEN IF THE VIKINGBOARD ITSELF
 * IS BROKEN AND DOES NOT WORK SINCE A UPGRADE
 * IS NEEDED.
 *
 * @author Tor henning Ueland
 */

//We are a vikingboard script
define('VBOARD', __FILE__);

//Make sure that files are required from the right place
ini_set('include_path', str_replace('upgrade/index.php', '', $_SERVER['SCRIPT_FILENAME']));

//Get kernel :)
require_once('inc/kernel.php');

class Upgrade
{
	// Define variables
	var $data;
	var $user;
	var $screen;
	var $config;
	var $version;
	var $version_plain;

	/*
	 * Constructor!
	 */
	function Upgrade(&$data, &$user, &$screen, &$config)
	{
		//Set up some vars
		$this->data		=	&$data;
		$this->user		=	&$user;
		$this->screen	=	&$screen;
		$this->config	=	&$config;

		//Make sure we are logged in.
		if ($this->user->g_is_admin !=1)
		{
			$this->message('Only administrators are allowed to upgrade the board.');
		}

		//Load in versions to upgrade
		$this->get_upgrade_versions();

		//Figure out what to do
		switch($_GET['act'])
		{

			case 'up_to_date':
				$this->nothing_needed();
			break;

			case 'check_new_versions':
				$this->load_todo();
			break;

			default:
				$this->frontpage();
		}
	}

	/*
	 * Informs that no upgrade is needed
	 */
	function nothing_needed() {
		$this->output("Hooray! Your version of Vikingboard appears to be up to date! (At lest there are no new upgrade scripts to run)");
	}
	
	/*
	 * Loads in all scripts and figures out what we are going to do
	 */
	function load_todo() {
		
		//Do the read files thingie
		$handle = opendir('scripts/'.DRIVER_SQL);
		while (false !== ($file = readdir($handle))) {
			if(stristr($file, 'up_')) {
				$this->todo[] = $file;
			}
		}

		//Load in all files and only trigger constructor since
		//theese may contain queries that MUST be run before any
		//upgrade routine.
		$text = 'Executing PRE-UPGRADE jobs...<br />Starting to load upgrade scripts...<br />';
		foreach($this->todo as $script) {
			require_once('scripts/'.DRIVER_SQL.'/'.$script);
			$script = str_replace('.php', '', $script);
			$s = new $script();
			$text .= "Script:  {$script}...<br />";
			$queries = $s->get_pre_upgrade_queries($this->data->queries->prefix);
			foreach($queries as $q) {
				$this->data->query('custom', array($q));
				$text .= "Query executed...<br />";
			}
		}

		//Figure out what upgrade script to run now...
		require_once('scripts/'.DRIVER_SQL.'/general_queries.php');
		$gq = new general_queries($this->data->queries->prefix);
		$latestVersion = $this->data->query('custom', array($gq->get_latest_version()));
		$text .= "Ready to upgrade from version {$latestVersion[0]->version_nice}!<br />";
		$latestVersion = $latestVersion[0]->version_internal;

		if($this->version_plain == $latestVersion) {
			header("Location:?act=up_to_date");
		}
	
		$text .= "<p><br /><div align=\"center\"><img src=\"go.png\" title=\"Start upgrade!\" /><br />
					<a href=\"?act=upgrade&from_version={$latestVersion}\">Step 2: Upgrade to next version!</a></b>
					</div></p>";
	
		$this->output($text);
	}

    function frontpage() {
        $this->output('<p>Welcome to the Vikingboard upgrader. This page will take you through all steps needed to get
                        your Vikingboard installation up to date. This upgrade system requires javascript enabled, if
                        you dont have it activated, you must first activate it.</p>
                        
						<p><br />
                            <div align="center">
                                <img src="go.png" title="Start upgrade!" /><br />
                                <a href="?act=check_new_versions">Step 1: Check for new versions</a></b>
                            </div>
                        </p>');
    }

	/*
	 * Prints a message
	 */
	function message($msg)
	{
		$this->output($msg);
        die();
	}


	/*
	 * Shows the frontpage
	 */
	function output($string)
	{
		echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
				<html xmlns="http://www.w3.org/1999/xhtml">

				<head>
					<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
					<link href="upgrade.css" rel="stylesheet" media="screen" type="text/css" />
					<title>Vikingboard - Upgrader</title>
				</head>

				<body>

					<div id="wrapper">

						<div id="content">

						<h1 id="header"><span class="hidden">Vikingboard</span></h1>
						<h2>Vikingboard upgrader</h2>
                        '.$string.'
					</div>
					<p class="powered_by">
						<a href="http://vikingboard.com/">Vikingboard.com</a>
					</p>
				</div>
			</body>
		</html>';
	}


	/*
	 * Figures out what versions to upgrade to
	 */
	function get_upgrade_versions()
	{
		$this->todo = array();
		$this->version = $this->config->version;
		$version_plain = strtolower($this->version);
		$version_plain = str_replace(' ', '', $version_plain);
		$this->version_plain = str_replace('.', '', $version_plain);
	}
}

new Upgrade($data, $user, $screen, $config);

?>
